// Code generated by ent, DO NOT EDIT.

package ent

import (
	"context"
	"fmt"

	"entgo.io/ent/dialect/sql/sqlgraph"
	"entgo.io/ent/schema/field"
	"kycnot.me/internal/ent/announcement"
)

// AnnouncementCreate is the builder for creating a Announcement entity.
type AnnouncementCreate struct {
	config
	mutation *AnnouncementMutation
	hooks    []Hook
}

// SetBody sets the "body" field.
func (ac *AnnouncementCreate) SetBody(s string) *AnnouncementCreate {
	ac.mutation.SetBody(s)
	return ac
}

// SetNillableBody sets the "body" field if the given value is not nil.
func (ac *AnnouncementCreate) SetNillableBody(s *string) *AnnouncementCreate {
	if s != nil {
		ac.SetBody(*s)
	}
	return ac
}

// SetTitle sets the "title" field.
func (ac *AnnouncementCreate) SetTitle(s string) *AnnouncementCreate {
	ac.mutation.SetTitle(s)
	return ac
}

// SetNillableTitle sets the "title" field if the given value is not nil.
func (ac *AnnouncementCreate) SetNillableTitle(s *string) *AnnouncementCreate {
	if s != nil {
		ac.SetTitle(*s)
	}
	return ac
}

// SetLink sets the "link" field.
func (ac *AnnouncementCreate) SetLink(s string) *AnnouncementCreate {
	ac.mutation.SetLink(s)
	return ac
}

// SetNillableLink sets the "link" field if the given value is not nil.
func (ac *AnnouncementCreate) SetNillableLink(s *string) *AnnouncementCreate {
	if s != nil {
		ac.SetLink(*s)
	}
	return ac
}

// SetWarning sets the "warning" field.
func (ac *AnnouncementCreate) SetWarning(b bool) *AnnouncementCreate {
	ac.mutation.SetWarning(b)
	return ac
}

// SetNillableWarning sets the "warning" field if the given value is not nil.
func (ac *AnnouncementCreate) SetNillableWarning(b *bool) *AnnouncementCreate {
	if b != nil {
		ac.SetWarning(*b)
	}
	return ac
}

// SetActive sets the "active" field.
func (ac *AnnouncementCreate) SetActive(b bool) *AnnouncementCreate {
	ac.mutation.SetActive(b)
	return ac
}

// SetNillableActive sets the "active" field if the given value is not nil.
func (ac *AnnouncementCreate) SetNillableActive(b *bool) *AnnouncementCreate {
	if b != nil {
		ac.SetActive(*b)
	}
	return ac
}

// Mutation returns the AnnouncementMutation object of the builder.
func (ac *AnnouncementCreate) Mutation() *AnnouncementMutation {
	return ac.mutation
}

// Save creates the Announcement in the database.
func (ac *AnnouncementCreate) Save(ctx context.Context) (*Announcement, error) {
	return withHooks(ctx, ac.sqlSave, ac.mutation, ac.hooks)
}

// SaveX calls Save and panics if Save returns an error.
func (ac *AnnouncementCreate) SaveX(ctx context.Context) *Announcement {
	v, err := ac.Save(ctx)
	if err != nil {
		panic(err)
	}
	return v
}

// Exec executes the query.
func (ac *AnnouncementCreate) Exec(ctx context.Context) error {
	_, err := ac.Save(ctx)
	return err
}

// ExecX is like Exec, but panics if an error occurs.
func (ac *AnnouncementCreate) ExecX(ctx context.Context) {
	if err := ac.Exec(ctx); err != nil {
		panic(err)
	}
}

// check runs all checks and user-defined validators on the builder.
func (ac *AnnouncementCreate) check() error {
	return nil
}

func (ac *AnnouncementCreate) sqlSave(ctx context.Context) (*Announcement, error) {
	if err := ac.check(); err != nil {
		return nil, err
	}
	_node, _spec := ac.createSpec()
	if err := sqlgraph.CreateNode(ctx, ac.driver, _spec); err != nil {
		if sqlgraph.IsConstraintError(err) {
			err = &ConstraintError{msg: err.Error(), wrap: err}
		}
		return nil, err
	}
	id := _spec.ID.Value.(int64)
	_node.ID = int(id)
	ac.mutation.id = &_node.ID
	ac.mutation.done = true
	return _node, nil
}

func (ac *AnnouncementCreate) createSpec() (*Announcement, *sqlgraph.CreateSpec) {
	var (
		_node = &Announcement{config: ac.config}
		_spec = sqlgraph.NewCreateSpec(announcement.Table, sqlgraph.NewFieldSpec(announcement.FieldID, field.TypeInt))
	)
	if value, ok := ac.mutation.Body(); ok {
		_spec.SetField(announcement.FieldBody, field.TypeString, value)
		_node.Body = value
	}
	if value, ok := ac.mutation.Title(); ok {
		_spec.SetField(announcement.FieldTitle, field.TypeString, value)
		_node.Title = value
	}
	if value, ok := ac.mutation.Link(); ok {
		_spec.SetField(announcement.FieldLink, field.TypeString, value)
		_node.Link = value
	}
	if value, ok := ac.mutation.Warning(); ok {
		_spec.SetField(announcement.FieldWarning, field.TypeBool, value)
		_node.Warning = value
	}
	if value, ok := ac.mutation.Active(); ok {
		_spec.SetField(announcement.FieldActive, field.TypeBool, value)
		_node.Active = value
	}
	return _node, _spec
}

// AnnouncementCreateBulk is the builder for creating many Announcement entities in bulk.
type AnnouncementCreateBulk struct {
	config
	err      error
	builders []*AnnouncementCreate
}

// Save creates the Announcement entities in the database.
func (acb *AnnouncementCreateBulk) Save(ctx context.Context) ([]*Announcement, error) {
	if acb.err != nil {
		return nil, acb.err
	}
	specs := make([]*sqlgraph.CreateSpec, len(acb.builders))
	nodes := make([]*Announcement, len(acb.builders))
	mutators := make([]Mutator, len(acb.builders))
	for i := range acb.builders {
		func(i int, root context.Context) {
			builder := acb.builders[i]
			var mut Mutator = MutateFunc(func(ctx context.Context, m Mutation) (Value, error) {
				mutation, ok := m.(*AnnouncementMutation)
				if !ok {
					return nil, fmt.Errorf("unexpected mutation type %T", m)
				}
				if err := builder.check(); err != nil {
					return nil, err
				}
				builder.mutation = mutation
				var err error
				nodes[i], specs[i] = builder.createSpec()
				if i < len(mutators)-1 {
					_, err = mutators[i+1].Mutate(root, acb.builders[i+1].mutation)
				} else {
					spec := &sqlgraph.BatchCreateSpec{Nodes: specs}
					// Invoke the actual operation on the latest mutation in the chain.
					if err = sqlgraph.BatchCreate(ctx, acb.driver, spec); err != nil {
						if sqlgraph.IsConstraintError(err) {
							err = &ConstraintError{msg: err.Error(), wrap: err}
						}
					}
				}
				if err != nil {
					return nil, err
				}
				mutation.id = &nodes[i].ID
				if specs[i].ID.Value != nil {
					id := specs[i].ID.Value.(int64)
					nodes[i].ID = int(id)
				}
				mutation.done = true
				return nodes[i], nil
			})
			for i := len(builder.hooks) - 1; i >= 0; i-- {
				mut = builder.hooks[i](mut)
			}
			mutators[i] = mut
		}(i, ctx)
	}
	if len(mutators) > 0 {
		if _, err := mutators[0].Mutate(ctx, acb.builders[0].mutation); err != nil {
			return nil, err
		}
	}
	return nodes, nil
}

// SaveX is like Save, but panics if an error occurs.
func (acb *AnnouncementCreateBulk) SaveX(ctx context.Context) []*Announcement {
	v, err := acb.Save(ctx)
	if err != nil {
		panic(err)
	}
	return v
}

// Exec executes the query.
func (acb *AnnouncementCreateBulk) Exec(ctx context.Context) error {
	_, err := acb.Save(ctx)
	return err
}

// ExecX is like Exec, but panics if an error occurs.
func (acb *AnnouncementCreateBulk) ExecX(ctx context.Context) {
	if err := acb.Exec(ctx); err != nil {
		panic(err)
	}
}
