// Code generated by ent, DO NOT EDIT.

package ent

import (
	"context"
	"errors"
	"fmt"

	"entgo.io/ent/dialect/sql"
	"entgo.io/ent/dialect/sql/sqlgraph"
	"entgo.io/ent/schema/field"
	"kycnot.me/internal/ent/announcement"
	"kycnot.me/internal/ent/predicate"
)

// AnnouncementUpdate is the builder for updating Announcement entities.
type AnnouncementUpdate struct {
	config
	hooks    []Hook
	mutation *AnnouncementMutation
}

// Where appends a list predicates to the AnnouncementUpdate builder.
func (au *AnnouncementUpdate) Where(ps ...predicate.Announcement) *AnnouncementUpdate {
	au.mutation.Where(ps...)
	return au
}

// SetBody sets the "body" field.
func (au *AnnouncementUpdate) SetBody(s string) *AnnouncementUpdate {
	au.mutation.SetBody(s)
	return au
}

// SetNillableBody sets the "body" field if the given value is not nil.
func (au *AnnouncementUpdate) SetNillableBody(s *string) *AnnouncementUpdate {
	if s != nil {
		au.SetBody(*s)
	}
	return au
}

// ClearBody clears the value of the "body" field.
func (au *AnnouncementUpdate) ClearBody() *AnnouncementUpdate {
	au.mutation.ClearBody()
	return au
}

// SetTitle sets the "title" field.
func (au *AnnouncementUpdate) SetTitle(s string) *AnnouncementUpdate {
	au.mutation.SetTitle(s)
	return au
}

// SetNillableTitle sets the "title" field if the given value is not nil.
func (au *AnnouncementUpdate) SetNillableTitle(s *string) *AnnouncementUpdate {
	if s != nil {
		au.SetTitle(*s)
	}
	return au
}

// ClearTitle clears the value of the "title" field.
func (au *AnnouncementUpdate) ClearTitle() *AnnouncementUpdate {
	au.mutation.ClearTitle()
	return au
}

// SetLink sets the "link" field.
func (au *AnnouncementUpdate) SetLink(s string) *AnnouncementUpdate {
	au.mutation.SetLink(s)
	return au
}

// SetNillableLink sets the "link" field if the given value is not nil.
func (au *AnnouncementUpdate) SetNillableLink(s *string) *AnnouncementUpdate {
	if s != nil {
		au.SetLink(*s)
	}
	return au
}

// ClearLink clears the value of the "link" field.
func (au *AnnouncementUpdate) ClearLink() *AnnouncementUpdate {
	au.mutation.ClearLink()
	return au
}

// SetWarning sets the "warning" field.
func (au *AnnouncementUpdate) SetWarning(b bool) *AnnouncementUpdate {
	au.mutation.SetWarning(b)
	return au
}

// SetNillableWarning sets the "warning" field if the given value is not nil.
func (au *AnnouncementUpdate) SetNillableWarning(b *bool) *AnnouncementUpdate {
	if b != nil {
		au.SetWarning(*b)
	}
	return au
}

// ClearWarning clears the value of the "warning" field.
func (au *AnnouncementUpdate) ClearWarning() *AnnouncementUpdate {
	au.mutation.ClearWarning()
	return au
}

// SetActive sets the "active" field.
func (au *AnnouncementUpdate) SetActive(b bool) *AnnouncementUpdate {
	au.mutation.SetActive(b)
	return au
}

// SetNillableActive sets the "active" field if the given value is not nil.
func (au *AnnouncementUpdate) SetNillableActive(b *bool) *AnnouncementUpdate {
	if b != nil {
		au.SetActive(*b)
	}
	return au
}

// ClearActive clears the value of the "active" field.
func (au *AnnouncementUpdate) ClearActive() *AnnouncementUpdate {
	au.mutation.ClearActive()
	return au
}

// Mutation returns the AnnouncementMutation object of the builder.
func (au *AnnouncementUpdate) Mutation() *AnnouncementMutation {
	return au.mutation
}

// Save executes the query and returns the number of nodes affected by the update operation.
func (au *AnnouncementUpdate) Save(ctx context.Context) (int, error) {
	return withHooks(ctx, au.sqlSave, au.mutation, au.hooks)
}

// SaveX is like Save, but panics if an error occurs.
func (au *AnnouncementUpdate) SaveX(ctx context.Context) int {
	affected, err := au.Save(ctx)
	if err != nil {
		panic(err)
	}
	return affected
}

// Exec executes the query.
func (au *AnnouncementUpdate) Exec(ctx context.Context) error {
	_, err := au.Save(ctx)
	return err
}

// ExecX is like Exec, but panics if an error occurs.
func (au *AnnouncementUpdate) ExecX(ctx context.Context) {
	if err := au.Exec(ctx); err != nil {
		panic(err)
	}
}

func (au *AnnouncementUpdate) sqlSave(ctx context.Context) (n int, err error) {
	_spec := sqlgraph.NewUpdateSpec(announcement.Table, announcement.Columns, sqlgraph.NewFieldSpec(announcement.FieldID, field.TypeInt))
	if ps := au.mutation.predicates; len(ps) > 0 {
		_spec.Predicate = func(selector *sql.Selector) {
			for i := range ps {
				ps[i](selector)
			}
		}
	}
	if value, ok := au.mutation.Body(); ok {
		_spec.SetField(announcement.FieldBody, field.TypeString, value)
	}
	if au.mutation.BodyCleared() {
		_spec.ClearField(announcement.FieldBody, field.TypeString)
	}
	if value, ok := au.mutation.Title(); ok {
		_spec.SetField(announcement.FieldTitle, field.TypeString, value)
	}
	if au.mutation.TitleCleared() {
		_spec.ClearField(announcement.FieldTitle, field.TypeString)
	}
	if value, ok := au.mutation.Link(); ok {
		_spec.SetField(announcement.FieldLink, field.TypeString, value)
	}
	if au.mutation.LinkCleared() {
		_spec.ClearField(announcement.FieldLink, field.TypeString)
	}
	if value, ok := au.mutation.Warning(); ok {
		_spec.SetField(announcement.FieldWarning, field.TypeBool, value)
	}
	if au.mutation.WarningCleared() {
		_spec.ClearField(announcement.FieldWarning, field.TypeBool)
	}
	if value, ok := au.mutation.Active(); ok {
		_spec.SetField(announcement.FieldActive, field.TypeBool, value)
	}
	if au.mutation.ActiveCleared() {
		_spec.ClearField(announcement.FieldActive, field.TypeBool)
	}
	if n, err = sqlgraph.UpdateNodes(ctx, au.driver, _spec); err != nil {
		if _, ok := err.(*sqlgraph.NotFoundError); ok {
			err = &NotFoundError{announcement.Label}
		} else if sqlgraph.IsConstraintError(err) {
			err = &ConstraintError{msg: err.Error(), wrap: err}
		}
		return 0, err
	}
	au.mutation.done = true
	return n, nil
}

// AnnouncementUpdateOne is the builder for updating a single Announcement entity.
type AnnouncementUpdateOne struct {
	config
	fields   []string
	hooks    []Hook
	mutation *AnnouncementMutation
}

// SetBody sets the "body" field.
func (auo *AnnouncementUpdateOne) SetBody(s string) *AnnouncementUpdateOne {
	auo.mutation.SetBody(s)
	return auo
}

// SetNillableBody sets the "body" field if the given value is not nil.
func (auo *AnnouncementUpdateOne) SetNillableBody(s *string) *AnnouncementUpdateOne {
	if s != nil {
		auo.SetBody(*s)
	}
	return auo
}

// ClearBody clears the value of the "body" field.
func (auo *AnnouncementUpdateOne) ClearBody() *AnnouncementUpdateOne {
	auo.mutation.ClearBody()
	return auo
}

// SetTitle sets the "title" field.
func (auo *AnnouncementUpdateOne) SetTitle(s string) *AnnouncementUpdateOne {
	auo.mutation.SetTitle(s)
	return auo
}

// SetNillableTitle sets the "title" field if the given value is not nil.
func (auo *AnnouncementUpdateOne) SetNillableTitle(s *string) *AnnouncementUpdateOne {
	if s != nil {
		auo.SetTitle(*s)
	}
	return auo
}

// ClearTitle clears the value of the "title" field.
func (auo *AnnouncementUpdateOne) ClearTitle() *AnnouncementUpdateOne {
	auo.mutation.ClearTitle()
	return auo
}

// SetLink sets the "link" field.
func (auo *AnnouncementUpdateOne) SetLink(s string) *AnnouncementUpdateOne {
	auo.mutation.SetLink(s)
	return auo
}

// SetNillableLink sets the "link" field if the given value is not nil.
func (auo *AnnouncementUpdateOne) SetNillableLink(s *string) *AnnouncementUpdateOne {
	if s != nil {
		auo.SetLink(*s)
	}
	return auo
}

// ClearLink clears the value of the "link" field.
func (auo *AnnouncementUpdateOne) ClearLink() *AnnouncementUpdateOne {
	auo.mutation.ClearLink()
	return auo
}

// SetWarning sets the "warning" field.
func (auo *AnnouncementUpdateOne) SetWarning(b bool) *AnnouncementUpdateOne {
	auo.mutation.SetWarning(b)
	return auo
}

// SetNillableWarning sets the "warning" field if the given value is not nil.
func (auo *AnnouncementUpdateOne) SetNillableWarning(b *bool) *AnnouncementUpdateOne {
	if b != nil {
		auo.SetWarning(*b)
	}
	return auo
}

// ClearWarning clears the value of the "warning" field.
func (auo *AnnouncementUpdateOne) ClearWarning() *AnnouncementUpdateOne {
	auo.mutation.ClearWarning()
	return auo
}

// SetActive sets the "active" field.
func (auo *AnnouncementUpdateOne) SetActive(b bool) *AnnouncementUpdateOne {
	auo.mutation.SetActive(b)
	return auo
}

// SetNillableActive sets the "active" field if the given value is not nil.
func (auo *AnnouncementUpdateOne) SetNillableActive(b *bool) *AnnouncementUpdateOne {
	if b != nil {
		auo.SetActive(*b)
	}
	return auo
}

// ClearActive clears the value of the "active" field.
func (auo *AnnouncementUpdateOne) ClearActive() *AnnouncementUpdateOne {
	auo.mutation.ClearActive()
	return auo
}

// Mutation returns the AnnouncementMutation object of the builder.
func (auo *AnnouncementUpdateOne) Mutation() *AnnouncementMutation {
	return auo.mutation
}

// Where appends a list predicates to the AnnouncementUpdate builder.
func (auo *AnnouncementUpdateOne) Where(ps ...predicate.Announcement) *AnnouncementUpdateOne {
	auo.mutation.Where(ps...)
	return auo
}

// Select allows selecting one or more fields (columns) of the returned entity.
// The default is selecting all fields defined in the entity schema.
func (auo *AnnouncementUpdateOne) Select(field string, fields ...string) *AnnouncementUpdateOne {
	auo.fields = append([]string{field}, fields...)
	return auo
}

// Save executes the query and returns the updated Announcement entity.
func (auo *AnnouncementUpdateOne) Save(ctx context.Context) (*Announcement, error) {
	return withHooks(ctx, auo.sqlSave, auo.mutation, auo.hooks)
}

// SaveX is like Save, but panics if an error occurs.
func (auo *AnnouncementUpdateOne) SaveX(ctx context.Context) *Announcement {
	node, err := auo.Save(ctx)
	if err != nil {
		panic(err)
	}
	return node
}

// Exec executes the query on the entity.
func (auo *AnnouncementUpdateOne) Exec(ctx context.Context) error {
	_, err := auo.Save(ctx)
	return err
}

// ExecX is like Exec, but panics if an error occurs.
func (auo *AnnouncementUpdateOne) ExecX(ctx context.Context) {
	if err := auo.Exec(ctx); err != nil {
		panic(err)
	}
}

func (auo *AnnouncementUpdateOne) sqlSave(ctx context.Context) (_node *Announcement, err error) {
	_spec := sqlgraph.NewUpdateSpec(announcement.Table, announcement.Columns, sqlgraph.NewFieldSpec(announcement.FieldID, field.TypeInt))
	id, ok := auo.mutation.ID()
	if !ok {
		return nil, &ValidationError{Name: "id", err: errors.New(`ent: missing "Announcement.id" for update`)}
	}
	_spec.Node.ID.Value = id
	if fields := auo.fields; len(fields) > 0 {
		_spec.Node.Columns = make([]string, 0, len(fields))
		_spec.Node.Columns = append(_spec.Node.Columns, announcement.FieldID)
		for _, f := range fields {
			if !announcement.ValidColumn(f) {
				return nil, &ValidationError{Name: f, err: fmt.Errorf("ent: invalid field %q for query", f)}
			}
			if f != announcement.FieldID {
				_spec.Node.Columns = append(_spec.Node.Columns, f)
			}
		}
	}
	if ps := auo.mutation.predicates; len(ps) > 0 {
		_spec.Predicate = func(selector *sql.Selector) {
			for i := range ps {
				ps[i](selector)
			}
		}
	}
	if value, ok := auo.mutation.Body(); ok {
		_spec.SetField(announcement.FieldBody, field.TypeString, value)
	}
	if auo.mutation.BodyCleared() {
		_spec.ClearField(announcement.FieldBody, field.TypeString)
	}
	if value, ok := auo.mutation.Title(); ok {
		_spec.SetField(announcement.FieldTitle, field.TypeString, value)
	}
	if auo.mutation.TitleCleared() {
		_spec.ClearField(announcement.FieldTitle, field.TypeString)
	}
	if value, ok := auo.mutation.Link(); ok {
		_spec.SetField(announcement.FieldLink, field.TypeString, value)
	}
	if auo.mutation.LinkCleared() {
		_spec.ClearField(announcement.FieldLink, field.TypeString)
	}
	if value, ok := auo.mutation.Warning(); ok {
		_spec.SetField(announcement.FieldWarning, field.TypeBool, value)
	}
	if auo.mutation.WarningCleared() {
		_spec.ClearField(announcement.FieldWarning, field.TypeBool)
	}
	if value, ok := auo.mutation.Active(); ok {
		_spec.SetField(announcement.FieldActive, field.TypeBool, value)
	}
	if auo.mutation.ActiveCleared() {
		_spec.ClearField(announcement.FieldActive, field.TypeBool)
	}
	_node = &Announcement{config: auo.config}
	_spec.Assign = _node.assignValues
	_spec.ScanValues = _node.scanValues
	if err = sqlgraph.UpdateNode(ctx, auo.driver, _spec); err != nil {
		if _, ok := err.(*sqlgraph.NotFoundError); ok {
			err = &NotFoundError{announcement.Label}
		} else if sqlgraph.IsConstraintError(err) {
			err = &ConstraintError{msg: err.Error(), wrap: err}
		}
		return nil, err
	}
	auo.mutation.done = true
	return _node, nil
}
