// Code generated by ent, DO NOT EDIT.

package attribute

import (
	"fmt"
	"time"

	"entgo.io/ent/dialect/sql"
	"entgo.io/ent/dialect/sql/sqlgraph"
)

const (
	// Label holds the string label denoting the attribute type in the database.
	Label = "attribute"
	// FieldID holds the string denoting the id field in the database.
	FieldID = "id"
	// FieldCreatedAt holds the string denoting the createdat field in the database.
	FieldCreatedAt = "created_at"
	// FieldTitle holds the string denoting the title field in the database.
	FieldTitle = "title"
	// FieldBonus holds the string denoting the bonus field in the database.
	FieldBonus = "bonus"
	// FieldSlug holds the string denoting the slug field in the database.
	FieldSlug = "slug"
	// FieldRating holds the string denoting the rating field in the database.
	FieldRating = "rating"
	// FieldDescription holds the string denoting the description field in the database.
	FieldDescription = "description"
	// EdgeServices holds the string denoting the services edge name in mutations.
	EdgeServices = "services"
	// Table holds the table name of the attribute in the database.
	Table = "attributes"
	// ServicesTable is the table that holds the services relation/edge. The primary key declared below.
	ServicesTable = "service_attributes"
	// ServicesInverseTable is the table name for the Service entity.
	// It exists in this package in order to avoid circular dependency with the "service" package.
	ServicesInverseTable = "services"
)

// Columns holds all SQL columns for attribute fields.
var Columns = []string{
	FieldID,
	FieldCreatedAt,
	FieldTitle,
	FieldBonus,
	FieldSlug,
	FieldRating,
	FieldDescription,
}

var (
	// ServicesPrimaryKey and ServicesColumn2 are the table columns denoting the
	// primary key for the services relation (M2M).
	ServicesPrimaryKey = []string{"service_id", "attribute_id"}
)

// ValidColumn reports if the column name is valid (part of the table columns).
func ValidColumn(column string) bool {
	for i := range Columns {
		if column == Columns[i] {
			return true
		}
	}
	return false
}

var (
	// DefaultCreatedAt holds the default value on creation for the "createdAt" field.
	DefaultCreatedAt func() time.Time
	// DefaultBonus holds the default value on creation for the "bonus" field.
	DefaultBonus float64
	// DefaultID holds the default value on creation for the "id" field.
	DefaultID func() string
)

// Rating defines the type for the "rating" enum field.
type Rating string

// Rating values.
const (
	RatingGood Rating = "good"
	RatingBad  Rating = "bad"
	RatingWarn Rating = "warn"
	RatingInfo Rating = "info"
)

func (r Rating) String() string {
	return string(r)
}

// RatingValidator is a validator for the "rating" field enum values. It is called by the builders before save.
func RatingValidator(r Rating) error {
	switch r {
	case RatingGood, RatingBad, RatingWarn, RatingInfo:
		return nil
	default:
		return fmt.Errorf("attribute: invalid enum value for rating field: %q", r)
	}
}

// OrderOption defines the ordering options for the Attribute queries.
type OrderOption func(*sql.Selector)

// ByID orders the results by the id field.
func ByID(opts ...sql.OrderTermOption) OrderOption {
	return sql.OrderByField(FieldID, opts...).ToFunc()
}

// ByCreatedAt orders the results by the createdAt field.
func ByCreatedAt(opts ...sql.OrderTermOption) OrderOption {
	return sql.OrderByField(FieldCreatedAt, opts...).ToFunc()
}

// ByTitle orders the results by the title field.
func ByTitle(opts ...sql.OrderTermOption) OrderOption {
	return sql.OrderByField(FieldTitle, opts...).ToFunc()
}

// ByBonus orders the results by the bonus field.
func ByBonus(opts ...sql.OrderTermOption) OrderOption {
	return sql.OrderByField(FieldBonus, opts...).ToFunc()
}

// BySlug orders the results by the slug field.
func BySlug(opts ...sql.OrderTermOption) OrderOption {
	return sql.OrderByField(FieldSlug, opts...).ToFunc()
}

// ByRating orders the results by the rating field.
func ByRating(opts ...sql.OrderTermOption) OrderOption {
	return sql.OrderByField(FieldRating, opts...).ToFunc()
}

// ByDescription orders the results by the description field.
func ByDescription(opts ...sql.OrderTermOption) OrderOption {
	return sql.OrderByField(FieldDescription, opts...).ToFunc()
}

// ByServicesCount orders the results by services count.
func ByServicesCount(opts ...sql.OrderTermOption) OrderOption {
	return func(s *sql.Selector) {
		sqlgraph.OrderByNeighborsCount(s, newServicesStep(), opts...)
	}
}

// ByServices orders the results by services terms.
func ByServices(term sql.OrderTerm, terms ...sql.OrderTerm) OrderOption {
	return func(s *sql.Selector) {
		sqlgraph.OrderByNeighborTerms(s, newServicesStep(), append([]sql.OrderTerm{term}, terms...)...)
	}
}
func newServicesStep() *sqlgraph.Step {
	return sqlgraph.NewStep(
		sqlgraph.From(Table, FieldID),
		sqlgraph.To(ServicesInverseTable, FieldID),
		sqlgraph.Edge(sqlgraph.M2M, true, ServicesTable, ServicesPrimaryKey...),
	)
}
