// Code generated by ent, DO NOT EDIT.

package ent

import (
	"context"
	"errors"
	"fmt"
	"time"

	"entgo.io/ent/dialect/sql"
	"entgo.io/ent/dialect/sql/sqlgraph"
	"entgo.io/ent/schema/field"
	"kycnot.me/internal/ent/attribute"
	"kycnot.me/internal/ent/predicate"
	"kycnot.me/internal/ent/service"
)

// AttributeUpdate is the builder for updating Attribute entities.
type AttributeUpdate struct {
	config
	hooks    []Hook
	mutation *AttributeMutation
}

// Where appends a list predicates to the AttributeUpdate builder.
func (au *AttributeUpdate) Where(ps ...predicate.Attribute) *AttributeUpdate {
	au.mutation.Where(ps...)
	return au
}

// SetCreatedAt sets the "createdAt" field.
func (au *AttributeUpdate) SetCreatedAt(t time.Time) *AttributeUpdate {
	au.mutation.SetCreatedAt(t)
	return au
}

// SetNillableCreatedAt sets the "createdAt" field if the given value is not nil.
func (au *AttributeUpdate) SetNillableCreatedAt(t *time.Time) *AttributeUpdate {
	if t != nil {
		au.SetCreatedAt(*t)
	}
	return au
}

// SetTitle sets the "title" field.
func (au *AttributeUpdate) SetTitle(s string) *AttributeUpdate {
	au.mutation.SetTitle(s)
	return au
}

// SetNillableTitle sets the "title" field if the given value is not nil.
func (au *AttributeUpdate) SetNillableTitle(s *string) *AttributeUpdate {
	if s != nil {
		au.SetTitle(*s)
	}
	return au
}

// SetBonus sets the "bonus" field.
func (au *AttributeUpdate) SetBonus(f float64) *AttributeUpdate {
	au.mutation.ResetBonus()
	au.mutation.SetBonus(f)
	return au
}

// SetNillableBonus sets the "bonus" field if the given value is not nil.
func (au *AttributeUpdate) SetNillableBonus(f *float64) *AttributeUpdate {
	if f != nil {
		au.SetBonus(*f)
	}
	return au
}

// AddBonus adds f to the "bonus" field.
func (au *AttributeUpdate) AddBonus(f float64) *AttributeUpdate {
	au.mutation.AddBonus(f)
	return au
}

// SetSlug sets the "slug" field.
func (au *AttributeUpdate) SetSlug(s string) *AttributeUpdate {
	au.mutation.SetSlug(s)
	return au
}

// SetNillableSlug sets the "slug" field if the given value is not nil.
func (au *AttributeUpdate) SetNillableSlug(s *string) *AttributeUpdate {
	if s != nil {
		au.SetSlug(*s)
	}
	return au
}

// SetRating sets the "rating" field.
func (au *AttributeUpdate) SetRating(a attribute.Rating) *AttributeUpdate {
	au.mutation.SetRating(a)
	return au
}

// SetNillableRating sets the "rating" field if the given value is not nil.
func (au *AttributeUpdate) SetNillableRating(a *attribute.Rating) *AttributeUpdate {
	if a != nil {
		au.SetRating(*a)
	}
	return au
}

// SetDescription sets the "description" field.
func (au *AttributeUpdate) SetDescription(s string) *AttributeUpdate {
	au.mutation.SetDescription(s)
	return au
}

// SetNillableDescription sets the "description" field if the given value is not nil.
func (au *AttributeUpdate) SetNillableDescription(s *string) *AttributeUpdate {
	if s != nil {
		au.SetDescription(*s)
	}
	return au
}

// ClearDescription clears the value of the "description" field.
func (au *AttributeUpdate) ClearDescription() *AttributeUpdate {
	au.mutation.ClearDescription()
	return au
}

// AddServiceIDs adds the "services" edge to the Service entity by IDs.
func (au *AttributeUpdate) AddServiceIDs(ids ...string) *AttributeUpdate {
	au.mutation.AddServiceIDs(ids...)
	return au
}

// AddServices adds the "services" edges to the Service entity.
func (au *AttributeUpdate) AddServices(s ...*Service) *AttributeUpdate {
	ids := make([]string, len(s))
	for i := range s {
		ids[i] = s[i].ID
	}
	return au.AddServiceIDs(ids...)
}

// Mutation returns the AttributeMutation object of the builder.
func (au *AttributeUpdate) Mutation() *AttributeMutation {
	return au.mutation
}

// ClearServices clears all "services" edges to the Service entity.
func (au *AttributeUpdate) ClearServices() *AttributeUpdate {
	au.mutation.ClearServices()
	return au
}

// RemoveServiceIDs removes the "services" edge to Service entities by IDs.
func (au *AttributeUpdate) RemoveServiceIDs(ids ...string) *AttributeUpdate {
	au.mutation.RemoveServiceIDs(ids...)
	return au
}

// RemoveServices removes "services" edges to Service entities.
func (au *AttributeUpdate) RemoveServices(s ...*Service) *AttributeUpdate {
	ids := make([]string, len(s))
	for i := range s {
		ids[i] = s[i].ID
	}
	return au.RemoveServiceIDs(ids...)
}

// Save executes the query and returns the number of nodes affected by the update operation.
func (au *AttributeUpdate) Save(ctx context.Context) (int, error) {
	return withHooks(ctx, au.sqlSave, au.mutation, au.hooks)
}

// SaveX is like Save, but panics if an error occurs.
func (au *AttributeUpdate) SaveX(ctx context.Context) int {
	affected, err := au.Save(ctx)
	if err != nil {
		panic(err)
	}
	return affected
}

// Exec executes the query.
func (au *AttributeUpdate) Exec(ctx context.Context) error {
	_, err := au.Save(ctx)
	return err
}

// ExecX is like Exec, but panics if an error occurs.
func (au *AttributeUpdate) ExecX(ctx context.Context) {
	if err := au.Exec(ctx); err != nil {
		panic(err)
	}
}

// check runs all checks and user-defined validators on the builder.
func (au *AttributeUpdate) check() error {
	if v, ok := au.mutation.Rating(); ok {
		if err := attribute.RatingValidator(v); err != nil {
			return &ValidationError{Name: "rating", err: fmt.Errorf(`ent: validator failed for field "Attribute.rating": %w`, err)}
		}
	}
	return nil
}

func (au *AttributeUpdate) sqlSave(ctx context.Context) (n int, err error) {
	if err := au.check(); err != nil {
		return n, err
	}
	_spec := sqlgraph.NewUpdateSpec(attribute.Table, attribute.Columns, sqlgraph.NewFieldSpec(attribute.FieldID, field.TypeString))
	if ps := au.mutation.predicates; len(ps) > 0 {
		_spec.Predicate = func(selector *sql.Selector) {
			for i := range ps {
				ps[i](selector)
			}
		}
	}
	if value, ok := au.mutation.CreatedAt(); ok {
		_spec.SetField(attribute.FieldCreatedAt, field.TypeTime, value)
	}
	if value, ok := au.mutation.Title(); ok {
		_spec.SetField(attribute.FieldTitle, field.TypeString, value)
	}
	if value, ok := au.mutation.Bonus(); ok {
		_spec.SetField(attribute.FieldBonus, field.TypeFloat64, value)
	}
	if value, ok := au.mutation.AddedBonus(); ok {
		_spec.AddField(attribute.FieldBonus, field.TypeFloat64, value)
	}
	if value, ok := au.mutation.Slug(); ok {
		_spec.SetField(attribute.FieldSlug, field.TypeString, value)
	}
	if value, ok := au.mutation.Rating(); ok {
		_spec.SetField(attribute.FieldRating, field.TypeEnum, value)
	}
	if value, ok := au.mutation.Description(); ok {
		_spec.SetField(attribute.FieldDescription, field.TypeString, value)
	}
	if au.mutation.DescriptionCleared() {
		_spec.ClearField(attribute.FieldDescription, field.TypeString)
	}
	if au.mutation.ServicesCleared() {
		edge := &sqlgraph.EdgeSpec{
			Rel:     sqlgraph.M2M,
			Inverse: true,
			Table:   attribute.ServicesTable,
			Columns: attribute.ServicesPrimaryKey,
			Bidi:    false,
			Target: &sqlgraph.EdgeTarget{
				IDSpec: sqlgraph.NewFieldSpec(service.FieldID, field.TypeString),
			},
		}
		_spec.Edges.Clear = append(_spec.Edges.Clear, edge)
	}
	if nodes := au.mutation.RemovedServicesIDs(); len(nodes) > 0 && !au.mutation.ServicesCleared() {
		edge := &sqlgraph.EdgeSpec{
			Rel:     sqlgraph.M2M,
			Inverse: true,
			Table:   attribute.ServicesTable,
			Columns: attribute.ServicesPrimaryKey,
			Bidi:    false,
			Target: &sqlgraph.EdgeTarget{
				IDSpec: sqlgraph.NewFieldSpec(service.FieldID, field.TypeString),
			},
		}
		for _, k := range nodes {
			edge.Target.Nodes = append(edge.Target.Nodes, k)
		}
		_spec.Edges.Clear = append(_spec.Edges.Clear, edge)
	}
	if nodes := au.mutation.ServicesIDs(); len(nodes) > 0 {
		edge := &sqlgraph.EdgeSpec{
			Rel:     sqlgraph.M2M,
			Inverse: true,
			Table:   attribute.ServicesTable,
			Columns: attribute.ServicesPrimaryKey,
			Bidi:    false,
			Target: &sqlgraph.EdgeTarget{
				IDSpec: sqlgraph.NewFieldSpec(service.FieldID, field.TypeString),
			},
		}
		for _, k := range nodes {
			edge.Target.Nodes = append(edge.Target.Nodes, k)
		}
		_spec.Edges.Add = append(_spec.Edges.Add, edge)
	}
	if n, err = sqlgraph.UpdateNodes(ctx, au.driver, _spec); err != nil {
		if _, ok := err.(*sqlgraph.NotFoundError); ok {
			err = &NotFoundError{attribute.Label}
		} else if sqlgraph.IsConstraintError(err) {
			err = &ConstraintError{msg: err.Error(), wrap: err}
		}
		return 0, err
	}
	au.mutation.done = true
	return n, nil
}

// AttributeUpdateOne is the builder for updating a single Attribute entity.
type AttributeUpdateOne struct {
	config
	fields   []string
	hooks    []Hook
	mutation *AttributeMutation
}

// SetCreatedAt sets the "createdAt" field.
func (auo *AttributeUpdateOne) SetCreatedAt(t time.Time) *AttributeUpdateOne {
	auo.mutation.SetCreatedAt(t)
	return auo
}

// SetNillableCreatedAt sets the "createdAt" field if the given value is not nil.
func (auo *AttributeUpdateOne) SetNillableCreatedAt(t *time.Time) *AttributeUpdateOne {
	if t != nil {
		auo.SetCreatedAt(*t)
	}
	return auo
}

// SetTitle sets the "title" field.
func (auo *AttributeUpdateOne) SetTitle(s string) *AttributeUpdateOne {
	auo.mutation.SetTitle(s)
	return auo
}

// SetNillableTitle sets the "title" field if the given value is not nil.
func (auo *AttributeUpdateOne) SetNillableTitle(s *string) *AttributeUpdateOne {
	if s != nil {
		auo.SetTitle(*s)
	}
	return auo
}

// SetBonus sets the "bonus" field.
func (auo *AttributeUpdateOne) SetBonus(f float64) *AttributeUpdateOne {
	auo.mutation.ResetBonus()
	auo.mutation.SetBonus(f)
	return auo
}

// SetNillableBonus sets the "bonus" field if the given value is not nil.
func (auo *AttributeUpdateOne) SetNillableBonus(f *float64) *AttributeUpdateOne {
	if f != nil {
		auo.SetBonus(*f)
	}
	return auo
}

// AddBonus adds f to the "bonus" field.
func (auo *AttributeUpdateOne) AddBonus(f float64) *AttributeUpdateOne {
	auo.mutation.AddBonus(f)
	return auo
}

// SetSlug sets the "slug" field.
func (auo *AttributeUpdateOne) SetSlug(s string) *AttributeUpdateOne {
	auo.mutation.SetSlug(s)
	return auo
}

// SetNillableSlug sets the "slug" field if the given value is not nil.
func (auo *AttributeUpdateOne) SetNillableSlug(s *string) *AttributeUpdateOne {
	if s != nil {
		auo.SetSlug(*s)
	}
	return auo
}

// SetRating sets the "rating" field.
func (auo *AttributeUpdateOne) SetRating(a attribute.Rating) *AttributeUpdateOne {
	auo.mutation.SetRating(a)
	return auo
}

// SetNillableRating sets the "rating" field if the given value is not nil.
func (auo *AttributeUpdateOne) SetNillableRating(a *attribute.Rating) *AttributeUpdateOne {
	if a != nil {
		auo.SetRating(*a)
	}
	return auo
}

// SetDescription sets the "description" field.
func (auo *AttributeUpdateOne) SetDescription(s string) *AttributeUpdateOne {
	auo.mutation.SetDescription(s)
	return auo
}

// SetNillableDescription sets the "description" field if the given value is not nil.
func (auo *AttributeUpdateOne) SetNillableDescription(s *string) *AttributeUpdateOne {
	if s != nil {
		auo.SetDescription(*s)
	}
	return auo
}

// ClearDescription clears the value of the "description" field.
func (auo *AttributeUpdateOne) ClearDescription() *AttributeUpdateOne {
	auo.mutation.ClearDescription()
	return auo
}

// AddServiceIDs adds the "services" edge to the Service entity by IDs.
func (auo *AttributeUpdateOne) AddServiceIDs(ids ...string) *AttributeUpdateOne {
	auo.mutation.AddServiceIDs(ids...)
	return auo
}

// AddServices adds the "services" edges to the Service entity.
func (auo *AttributeUpdateOne) AddServices(s ...*Service) *AttributeUpdateOne {
	ids := make([]string, len(s))
	for i := range s {
		ids[i] = s[i].ID
	}
	return auo.AddServiceIDs(ids...)
}

// Mutation returns the AttributeMutation object of the builder.
func (auo *AttributeUpdateOne) Mutation() *AttributeMutation {
	return auo.mutation
}

// ClearServices clears all "services" edges to the Service entity.
func (auo *AttributeUpdateOne) ClearServices() *AttributeUpdateOne {
	auo.mutation.ClearServices()
	return auo
}

// RemoveServiceIDs removes the "services" edge to Service entities by IDs.
func (auo *AttributeUpdateOne) RemoveServiceIDs(ids ...string) *AttributeUpdateOne {
	auo.mutation.RemoveServiceIDs(ids...)
	return auo
}

// RemoveServices removes "services" edges to Service entities.
func (auo *AttributeUpdateOne) RemoveServices(s ...*Service) *AttributeUpdateOne {
	ids := make([]string, len(s))
	for i := range s {
		ids[i] = s[i].ID
	}
	return auo.RemoveServiceIDs(ids...)
}

// Where appends a list predicates to the AttributeUpdate builder.
func (auo *AttributeUpdateOne) Where(ps ...predicate.Attribute) *AttributeUpdateOne {
	auo.mutation.Where(ps...)
	return auo
}

// Select allows selecting one or more fields (columns) of the returned entity.
// The default is selecting all fields defined in the entity schema.
func (auo *AttributeUpdateOne) Select(field string, fields ...string) *AttributeUpdateOne {
	auo.fields = append([]string{field}, fields...)
	return auo
}

// Save executes the query and returns the updated Attribute entity.
func (auo *AttributeUpdateOne) Save(ctx context.Context) (*Attribute, error) {
	return withHooks(ctx, auo.sqlSave, auo.mutation, auo.hooks)
}

// SaveX is like Save, but panics if an error occurs.
func (auo *AttributeUpdateOne) SaveX(ctx context.Context) *Attribute {
	node, err := auo.Save(ctx)
	if err != nil {
		panic(err)
	}
	return node
}

// Exec executes the query on the entity.
func (auo *AttributeUpdateOne) Exec(ctx context.Context) error {
	_, err := auo.Save(ctx)
	return err
}

// ExecX is like Exec, but panics if an error occurs.
func (auo *AttributeUpdateOne) ExecX(ctx context.Context) {
	if err := auo.Exec(ctx); err != nil {
		panic(err)
	}
}

// check runs all checks and user-defined validators on the builder.
func (auo *AttributeUpdateOne) check() error {
	if v, ok := auo.mutation.Rating(); ok {
		if err := attribute.RatingValidator(v); err != nil {
			return &ValidationError{Name: "rating", err: fmt.Errorf(`ent: validator failed for field "Attribute.rating": %w`, err)}
		}
	}
	return nil
}

func (auo *AttributeUpdateOne) sqlSave(ctx context.Context) (_node *Attribute, err error) {
	if err := auo.check(); err != nil {
		return _node, err
	}
	_spec := sqlgraph.NewUpdateSpec(attribute.Table, attribute.Columns, sqlgraph.NewFieldSpec(attribute.FieldID, field.TypeString))
	id, ok := auo.mutation.ID()
	if !ok {
		return nil, &ValidationError{Name: "id", err: errors.New(`ent: missing "Attribute.id" for update`)}
	}
	_spec.Node.ID.Value = id
	if fields := auo.fields; len(fields) > 0 {
		_spec.Node.Columns = make([]string, 0, len(fields))
		_spec.Node.Columns = append(_spec.Node.Columns, attribute.FieldID)
		for _, f := range fields {
			if !attribute.ValidColumn(f) {
				return nil, &ValidationError{Name: f, err: fmt.Errorf("ent: invalid field %q for query", f)}
			}
			if f != attribute.FieldID {
				_spec.Node.Columns = append(_spec.Node.Columns, f)
			}
		}
	}
	if ps := auo.mutation.predicates; len(ps) > 0 {
		_spec.Predicate = func(selector *sql.Selector) {
			for i := range ps {
				ps[i](selector)
			}
		}
	}
	if value, ok := auo.mutation.CreatedAt(); ok {
		_spec.SetField(attribute.FieldCreatedAt, field.TypeTime, value)
	}
	if value, ok := auo.mutation.Title(); ok {
		_spec.SetField(attribute.FieldTitle, field.TypeString, value)
	}
	if value, ok := auo.mutation.Bonus(); ok {
		_spec.SetField(attribute.FieldBonus, field.TypeFloat64, value)
	}
	if value, ok := auo.mutation.AddedBonus(); ok {
		_spec.AddField(attribute.FieldBonus, field.TypeFloat64, value)
	}
	if value, ok := auo.mutation.Slug(); ok {
		_spec.SetField(attribute.FieldSlug, field.TypeString, value)
	}
	if value, ok := auo.mutation.Rating(); ok {
		_spec.SetField(attribute.FieldRating, field.TypeEnum, value)
	}
	if value, ok := auo.mutation.Description(); ok {
		_spec.SetField(attribute.FieldDescription, field.TypeString, value)
	}
	if auo.mutation.DescriptionCleared() {
		_spec.ClearField(attribute.FieldDescription, field.TypeString)
	}
	if auo.mutation.ServicesCleared() {
		edge := &sqlgraph.EdgeSpec{
			Rel:     sqlgraph.M2M,
			Inverse: true,
			Table:   attribute.ServicesTable,
			Columns: attribute.ServicesPrimaryKey,
			Bidi:    false,
			Target: &sqlgraph.EdgeTarget{
				IDSpec: sqlgraph.NewFieldSpec(service.FieldID, field.TypeString),
			},
		}
		_spec.Edges.Clear = append(_spec.Edges.Clear, edge)
	}
	if nodes := auo.mutation.RemovedServicesIDs(); len(nodes) > 0 && !auo.mutation.ServicesCleared() {
		edge := &sqlgraph.EdgeSpec{
			Rel:     sqlgraph.M2M,
			Inverse: true,
			Table:   attribute.ServicesTable,
			Columns: attribute.ServicesPrimaryKey,
			Bidi:    false,
			Target: &sqlgraph.EdgeTarget{
				IDSpec: sqlgraph.NewFieldSpec(service.FieldID, field.TypeString),
			},
		}
		for _, k := range nodes {
			edge.Target.Nodes = append(edge.Target.Nodes, k)
		}
		_spec.Edges.Clear = append(_spec.Edges.Clear, edge)
	}
	if nodes := auo.mutation.ServicesIDs(); len(nodes) > 0 {
		edge := &sqlgraph.EdgeSpec{
			Rel:     sqlgraph.M2M,
			Inverse: true,
			Table:   attribute.ServicesTable,
			Columns: attribute.ServicesPrimaryKey,
			Bidi:    false,
			Target: &sqlgraph.EdgeTarget{
				IDSpec: sqlgraph.NewFieldSpec(service.FieldID, field.TypeString),
			},
		}
		for _, k := range nodes {
			edge.Target.Nodes = append(edge.Target.Nodes, k)
		}
		_spec.Edges.Add = append(_spec.Edges.Add, edge)
	}
	_node = &Attribute{config: auo.config}
	_spec.Assign = _node.assignValues
	_spec.ScanValues = _node.scanValues
	if err = sqlgraph.UpdateNode(ctx, auo.driver, _spec); err != nil {
		if _, ok := err.(*sqlgraph.NotFoundError); ok {
			err = &NotFoundError{attribute.Label}
		} else if sqlgraph.IsConstraintError(err) {
			err = &ConstraintError{msg: err.Error(), wrap: err}
		}
		return nil, err
	}
	auo.mutation.done = true
	return _node, nil
}
