// Code generated by ent, DO NOT EDIT.

package ent

import (
	"fmt"
	"strings"
	"time"

	"entgo.io/ent"
	"entgo.io/ent/dialect/sql"
	"kycnot.me/internal/ent/change"
	"kycnot.me/internal/ent/service"
)

// Change is the model entity for the Change schema.
type Change struct {
	config `json:"-"`
	// ID of the ent.
	ID int `json:"id,omitempty"`
	// The title of the change
	Title string `json:"Title,omitempty"`
	// A summary of the change
	Summary string `json:"Summary,omitempty"`
	// CreatedAt holds the value of the "createdAt" field.
	CreatedAt time.Time `json:"createdAt"`
	// Warning holds the value of the "warning" field.
	Warning bool `json:"warning"`
	// Edges holds the relations/edges for other nodes in the graph.
	// The values are being populated by the ChangeQuery when eager-loading is set.
	Edges           ChangeEdges `json:"edges"`
	service_changes *string
	selectValues    sql.SelectValues
}

// ChangeEdges holds the relations/edges for other nodes in the graph.
type ChangeEdges struct {
	// The service associated with this change
	Service *Service `json:"service,omitempty"`
	// loadedTypes holds the information for reporting if a
	// type was loaded (or requested) in eager-loading or not.
	loadedTypes [1]bool
}

// ServiceOrErr returns the Service value or an error if the edge
// was not loaded in eager-loading, or loaded but was not found.
func (e ChangeEdges) ServiceOrErr() (*Service, error) {
	if e.Service != nil {
		return e.Service, nil
	} else if e.loadedTypes[0] {
		return nil, &NotFoundError{label: service.Label}
	}
	return nil, &NotLoadedError{edge: "service"}
}

// scanValues returns the types for scanning values from sql.Rows.
func (*Change) scanValues(columns []string) ([]any, error) {
	values := make([]any, len(columns))
	for i := range columns {
		switch columns[i] {
		case change.FieldWarning:
			values[i] = new(sql.NullBool)
		case change.FieldID:
			values[i] = new(sql.NullInt64)
		case change.FieldTitle, change.FieldSummary:
			values[i] = new(sql.NullString)
		case change.FieldCreatedAt:
			values[i] = new(sql.NullTime)
		case change.ForeignKeys[0]: // service_changes
			values[i] = new(sql.NullString)
		default:
			values[i] = new(sql.UnknownType)
		}
	}
	return values, nil
}

// assignValues assigns the values that were returned from sql.Rows (after scanning)
// to the Change fields.
func (c *Change) assignValues(columns []string, values []any) error {
	if m, n := len(values), len(columns); m < n {
		return fmt.Errorf("mismatch number of scan values: %d != %d", m, n)
	}
	for i := range columns {
		switch columns[i] {
		case change.FieldID:
			value, ok := values[i].(*sql.NullInt64)
			if !ok {
				return fmt.Errorf("unexpected type %T for field id", value)
			}
			c.ID = int(value.Int64)
		case change.FieldTitle:
			if value, ok := values[i].(*sql.NullString); !ok {
				return fmt.Errorf("unexpected type %T for field Title", values[i])
			} else if value.Valid {
				c.Title = value.String
			}
		case change.FieldSummary:
			if value, ok := values[i].(*sql.NullString); !ok {
				return fmt.Errorf("unexpected type %T for field Summary", values[i])
			} else if value.Valid {
				c.Summary = value.String
			}
		case change.FieldCreatedAt:
			if value, ok := values[i].(*sql.NullTime); !ok {
				return fmt.Errorf("unexpected type %T for field createdAt", values[i])
			} else if value.Valid {
				c.CreatedAt = value.Time
			}
		case change.FieldWarning:
			if value, ok := values[i].(*sql.NullBool); !ok {
				return fmt.Errorf("unexpected type %T for field warning", values[i])
			} else if value.Valid {
				c.Warning = value.Bool
			}
		case change.ForeignKeys[0]:
			if value, ok := values[i].(*sql.NullString); !ok {
				return fmt.Errorf("unexpected type %T for field service_changes", values[i])
			} else if value.Valid {
				c.service_changes = new(string)
				*c.service_changes = value.String
			}
		default:
			c.selectValues.Set(columns[i], values[i])
		}
	}
	return nil
}

// Value returns the ent.Value that was dynamically selected and assigned to the Change.
// This includes values selected through modifiers, order, etc.
func (c *Change) Value(name string) (ent.Value, error) {
	return c.selectValues.Get(name)
}

// QueryService queries the "service" edge of the Change entity.
func (c *Change) QueryService() *ServiceQuery {
	return NewChangeClient(c.config).QueryService(c)
}

// Update returns a builder for updating this Change.
// Note that you need to call Change.Unwrap() before calling this method if this Change
// was returned from a transaction, and the transaction was committed or rolled back.
func (c *Change) Update() *ChangeUpdateOne {
	return NewChangeClient(c.config).UpdateOne(c)
}

// Unwrap unwraps the Change entity that was returned from a transaction after it was closed,
// so that all future queries will be executed through the driver which created the transaction.
func (c *Change) Unwrap() *Change {
	_tx, ok := c.config.driver.(*txDriver)
	if !ok {
		panic("ent: Change is not a transactional entity")
	}
	c.config.driver = _tx.drv
	return c
}

// String implements the fmt.Stringer.
func (c *Change) String() string {
	var builder strings.Builder
	builder.WriteString("Change(")
	builder.WriteString(fmt.Sprintf("id=%v, ", c.ID))
	builder.WriteString("Title=")
	builder.WriteString(c.Title)
	builder.WriteString(", ")
	builder.WriteString("Summary=")
	builder.WriteString(c.Summary)
	builder.WriteString(", ")
	builder.WriteString("createdAt=")
	builder.WriteString(c.CreatedAt.Format(time.ANSIC))
	builder.WriteString(", ")
	builder.WriteString("warning=")
	builder.WriteString(fmt.Sprintf("%v", c.Warning))
	builder.WriteByte(')')
	return builder.String()
}

// Changes is a parsable slice of Change.
type Changes []*Change
