// Code generated by ent, DO NOT EDIT.

package ent

import (
	"context"
	"errors"
	"fmt"

	"entgo.io/ent/dialect/sql"
	"entgo.io/ent/dialect/sql/sqlgraph"
	"entgo.io/ent/schema/field"
	"kycnot.me/internal/ent/change"
	"kycnot.me/internal/ent/predicate"
	"kycnot.me/internal/ent/service"
)

// ChangeUpdate is the builder for updating Change entities.
type ChangeUpdate struct {
	config
	hooks    []Hook
	mutation *ChangeMutation
}

// Where appends a list predicates to the ChangeUpdate builder.
func (cu *ChangeUpdate) Where(ps ...predicate.Change) *ChangeUpdate {
	cu.mutation.Where(ps...)
	return cu
}

// SetTitle sets the "Title" field.
func (cu *ChangeUpdate) SetTitle(s string) *ChangeUpdate {
	cu.mutation.SetTitle(s)
	return cu
}

// SetNillableTitle sets the "Title" field if the given value is not nil.
func (cu *ChangeUpdate) SetNillableTitle(s *string) *ChangeUpdate {
	if s != nil {
		cu.SetTitle(*s)
	}
	return cu
}

// ClearTitle clears the value of the "Title" field.
func (cu *ChangeUpdate) ClearTitle() *ChangeUpdate {
	cu.mutation.ClearTitle()
	return cu
}

// SetSummary sets the "Summary" field.
func (cu *ChangeUpdate) SetSummary(s string) *ChangeUpdate {
	cu.mutation.SetSummary(s)
	return cu
}

// SetNillableSummary sets the "Summary" field if the given value is not nil.
func (cu *ChangeUpdate) SetNillableSummary(s *string) *ChangeUpdate {
	if s != nil {
		cu.SetSummary(*s)
	}
	return cu
}

// ClearSummary clears the value of the "Summary" field.
func (cu *ChangeUpdate) ClearSummary() *ChangeUpdate {
	cu.mutation.ClearSummary()
	return cu
}

// SetWarning sets the "warning" field.
func (cu *ChangeUpdate) SetWarning(b bool) *ChangeUpdate {
	cu.mutation.SetWarning(b)
	return cu
}

// SetNillableWarning sets the "warning" field if the given value is not nil.
func (cu *ChangeUpdate) SetNillableWarning(b *bool) *ChangeUpdate {
	if b != nil {
		cu.SetWarning(*b)
	}
	return cu
}

// SetServiceID sets the "service" edge to the Service entity by ID.
func (cu *ChangeUpdate) SetServiceID(id string) *ChangeUpdate {
	cu.mutation.SetServiceID(id)
	return cu
}

// SetNillableServiceID sets the "service" edge to the Service entity by ID if the given value is not nil.
func (cu *ChangeUpdate) SetNillableServiceID(id *string) *ChangeUpdate {
	if id != nil {
		cu = cu.SetServiceID(*id)
	}
	return cu
}

// SetService sets the "service" edge to the Service entity.
func (cu *ChangeUpdate) SetService(s *Service) *ChangeUpdate {
	return cu.SetServiceID(s.ID)
}

// Mutation returns the ChangeMutation object of the builder.
func (cu *ChangeUpdate) Mutation() *ChangeMutation {
	return cu.mutation
}

// ClearService clears the "service" edge to the Service entity.
func (cu *ChangeUpdate) ClearService() *ChangeUpdate {
	cu.mutation.ClearService()
	return cu
}

// Save executes the query and returns the number of nodes affected by the update operation.
func (cu *ChangeUpdate) Save(ctx context.Context) (int, error) {
	return withHooks(ctx, cu.sqlSave, cu.mutation, cu.hooks)
}

// SaveX is like Save, but panics if an error occurs.
func (cu *ChangeUpdate) SaveX(ctx context.Context) int {
	affected, err := cu.Save(ctx)
	if err != nil {
		panic(err)
	}
	return affected
}

// Exec executes the query.
func (cu *ChangeUpdate) Exec(ctx context.Context) error {
	_, err := cu.Save(ctx)
	return err
}

// ExecX is like Exec, but panics if an error occurs.
func (cu *ChangeUpdate) ExecX(ctx context.Context) {
	if err := cu.Exec(ctx); err != nil {
		panic(err)
	}
}

func (cu *ChangeUpdate) sqlSave(ctx context.Context) (n int, err error) {
	_spec := sqlgraph.NewUpdateSpec(change.Table, change.Columns, sqlgraph.NewFieldSpec(change.FieldID, field.TypeInt))
	if ps := cu.mutation.predicates; len(ps) > 0 {
		_spec.Predicate = func(selector *sql.Selector) {
			for i := range ps {
				ps[i](selector)
			}
		}
	}
	if value, ok := cu.mutation.Title(); ok {
		_spec.SetField(change.FieldTitle, field.TypeString, value)
	}
	if cu.mutation.TitleCleared() {
		_spec.ClearField(change.FieldTitle, field.TypeString)
	}
	if value, ok := cu.mutation.Summary(); ok {
		_spec.SetField(change.FieldSummary, field.TypeString, value)
	}
	if cu.mutation.SummaryCleared() {
		_spec.ClearField(change.FieldSummary, field.TypeString)
	}
	if value, ok := cu.mutation.Warning(); ok {
		_spec.SetField(change.FieldWarning, field.TypeBool, value)
	}
	if cu.mutation.ServiceCleared() {
		edge := &sqlgraph.EdgeSpec{
			Rel:     sqlgraph.M2O,
			Inverse: true,
			Table:   change.ServiceTable,
			Columns: []string{change.ServiceColumn},
			Bidi:    false,
			Target: &sqlgraph.EdgeTarget{
				IDSpec: sqlgraph.NewFieldSpec(service.FieldID, field.TypeString),
			},
		}
		_spec.Edges.Clear = append(_spec.Edges.Clear, edge)
	}
	if nodes := cu.mutation.ServiceIDs(); len(nodes) > 0 {
		edge := &sqlgraph.EdgeSpec{
			Rel:     sqlgraph.M2O,
			Inverse: true,
			Table:   change.ServiceTable,
			Columns: []string{change.ServiceColumn},
			Bidi:    false,
			Target: &sqlgraph.EdgeTarget{
				IDSpec: sqlgraph.NewFieldSpec(service.FieldID, field.TypeString),
			},
		}
		for _, k := range nodes {
			edge.Target.Nodes = append(edge.Target.Nodes, k)
		}
		_spec.Edges.Add = append(_spec.Edges.Add, edge)
	}
	if n, err = sqlgraph.UpdateNodes(ctx, cu.driver, _spec); err != nil {
		if _, ok := err.(*sqlgraph.NotFoundError); ok {
			err = &NotFoundError{change.Label}
		} else if sqlgraph.IsConstraintError(err) {
			err = &ConstraintError{msg: err.Error(), wrap: err}
		}
		return 0, err
	}
	cu.mutation.done = true
	return n, nil
}

// ChangeUpdateOne is the builder for updating a single Change entity.
type ChangeUpdateOne struct {
	config
	fields   []string
	hooks    []Hook
	mutation *ChangeMutation
}

// SetTitle sets the "Title" field.
func (cuo *ChangeUpdateOne) SetTitle(s string) *ChangeUpdateOne {
	cuo.mutation.SetTitle(s)
	return cuo
}

// SetNillableTitle sets the "Title" field if the given value is not nil.
func (cuo *ChangeUpdateOne) SetNillableTitle(s *string) *ChangeUpdateOne {
	if s != nil {
		cuo.SetTitle(*s)
	}
	return cuo
}

// ClearTitle clears the value of the "Title" field.
func (cuo *ChangeUpdateOne) ClearTitle() *ChangeUpdateOne {
	cuo.mutation.ClearTitle()
	return cuo
}

// SetSummary sets the "Summary" field.
func (cuo *ChangeUpdateOne) SetSummary(s string) *ChangeUpdateOne {
	cuo.mutation.SetSummary(s)
	return cuo
}

// SetNillableSummary sets the "Summary" field if the given value is not nil.
func (cuo *ChangeUpdateOne) SetNillableSummary(s *string) *ChangeUpdateOne {
	if s != nil {
		cuo.SetSummary(*s)
	}
	return cuo
}

// ClearSummary clears the value of the "Summary" field.
func (cuo *ChangeUpdateOne) ClearSummary() *ChangeUpdateOne {
	cuo.mutation.ClearSummary()
	return cuo
}

// SetWarning sets the "warning" field.
func (cuo *ChangeUpdateOne) SetWarning(b bool) *ChangeUpdateOne {
	cuo.mutation.SetWarning(b)
	return cuo
}

// SetNillableWarning sets the "warning" field if the given value is not nil.
func (cuo *ChangeUpdateOne) SetNillableWarning(b *bool) *ChangeUpdateOne {
	if b != nil {
		cuo.SetWarning(*b)
	}
	return cuo
}

// SetServiceID sets the "service" edge to the Service entity by ID.
func (cuo *ChangeUpdateOne) SetServiceID(id string) *ChangeUpdateOne {
	cuo.mutation.SetServiceID(id)
	return cuo
}

// SetNillableServiceID sets the "service" edge to the Service entity by ID if the given value is not nil.
func (cuo *ChangeUpdateOne) SetNillableServiceID(id *string) *ChangeUpdateOne {
	if id != nil {
		cuo = cuo.SetServiceID(*id)
	}
	return cuo
}

// SetService sets the "service" edge to the Service entity.
func (cuo *ChangeUpdateOne) SetService(s *Service) *ChangeUpdateOne {
	return cuo.SetServiceID(s.ID)
}

// Mutation returns the ChangeMutation object of the builder.
func (cuo *ChangeUpdateOne) Mutation() *ChangeMutation {
	return cuo.mutation
}

// ClearService clears the "service" edge to the Service entity.
func (cuo *ChangeUpdateOne) ClearService() *ChangeUpdateOne {
	cuo.mutation.ClearService()
	return cuo
}

// Where appends a list predicates to the ChangeUpdate builder.
func (cuo *ChangeUpdateOne) Where(ps ...predicate.Change) *ChangeUpdateOne {
	cuo.mutation.Where(ps...)
	return cuo
}

// Select allows selecting one or more fields (columns) of the returned entity.
// The default is selecting all fields defined in the entity schema.
func (cuo *ChangeUpdateOne) Select(field string, fields ...string) *ChangeUpdateOne {
	cuo.fields = append([]string{field}, fields...)
	return cuo
}

// Save executes the query and returns the updated Change entity.
func (cuo *ChangeUpdateOne) Save(ctx context.Context) (*Change, error) {
	return withHooks(ctx, cuo.sqlSave, cuo.mutation, cuo.hooks)
}

// SaveX is like Save, but panics if an error occurs.
func (cuo *ChangeUpdateOne) SaveX(ctx context.Context) *Change {
	node, err := cuo.Save(ctx)
	if err != nil {
		panic(err)
	}
	return node
}

// Exec executes the query on the entity.
func (cuo *ChangeUpdateOne) Exec(ctx context.Context) error {
	_, err := cuo.Save(ctx)
	return err
}

// ExecX is like Exec, but panics if an error occurs.
func (cuo *ChangeUpdateOne) ExecX(ctx context.Context) {
	if err := cuo.Exec(ctx); err != nil {
		panic(err)
	}
}

func (cuo *ChangeUpdateOne) sqlSave(ctx context.Context) (_node *Change, err error) {
	_spec := sqlgraph.NewUpdateSpec(change.Table, change.Columns, sqlgraph.NewFieldSpec(change.FieldID, field.TypeInt))
	id, ok := cuo.mutation.ID()
	if !ok {
		return nil, &ValidationError{Name: "id", err: errors.New(`ent: missing "Change.id" for update`)}
	}
	_spec.Node.ID.Value = id
	if fields := cuo.fields; len(fields) > 0 {
		_spec.Node.Columns = make([]string, 0, len(fields))
		_spec.Node.Columns = append(_spec.Node.Columns, change.FieldID)
		for _, f := range fields {
			if !change.ValidColumn(f) {
				return nil, &ValidationError{Name: f, err: fmt.Errorf("ent: invalid field %q for query", f)}
			}
			if f != change.FieldID {
				_spec.Node.Columns = append(_spec.Node.Columns, f)
			}
		}
	}
	if ps := cuo.mutation.predicates; len(ps) > 0 {
		_spec.Predicate = func(selector *sql.Selector) {
			for i := range ps {
				ps[i](selector)
			}
		}
	}
	if value, ok := cuo.mutation.Title(); ok {
		_spec.SetField(change.FieldTitle, field.TypeString, value)
	}
	if cuo.mutation.TitleCleared() {
		_spec.ClearField(change.FieldTitle, field.TypeString)
	}
	if value, ok := cuo.mutation.Summary(); ok {
		_spec.SetField(change.FieldSummary, field.TypeString, value)
	}
	if cuo.mutation.SummaryCleared() {
		_spec.ClearField(change.FieldSummary, field.TypeString)
	}
	if value, ok := cuo.mutation.Warning(); ok {
		_spec.SetField(change.FieldWarning, field.TypeBool, value)
	}
	if cuo.mutation.ServiceCleared() {
		edge := &sqlgraph.EdgeSpec{
			Rel:     sqlgraph.M2O,
			Inverse: true,
			Table:   change.ServiceTable,
			Columns: []string{change.ServiceColumn},
			Bidi:    false,
			Target: &sqlgraph.EdgeTarget{
				IDSpec: sqlgraph.NewFieldSpec(service.FieldID, field.TypeString),
			},
		}
		_spec.Edges.Clear = append(_spec.Edges.Clear, edge)
	}
	if nodes := cuo.mutation.ServiceIDs(); len(nodes) > 0 {
		edge := &sqlgraph.EdgeSpec{
			Rel:     sqlgraph.M2O,
			Inverse: true,
			Table:   change.ServiceTable,
			Columns: []string{change.ServiceColumn},
			Bidi:    false,
			Target: &sqlgraph.EdgeTarget{
				IDSpec: sqlgraph.NewFieldSpec(service.FieldID, field.TypeString),
			},
		}
		for _, k := range nodes {
			edge.Target.Nodes = append(edge.Target.Nodes, k)
		}
		_spec.Edges.Add = append(_spec.Edges.Add, edge)
	}
	_node = &Change{config: cuo.config}
	_spec.Assign = _node.assignValues
	_spec.ScanValues = _node.scanValues
	if err = sqlgraph.UpdateNode(ctx, cuo.driver, _spec); err != nil {
		if _, ok := err.(*sqlgraph.NotFoundError); ok {
			err = &NotFoundError{change.Label}
		} else if sqlgraph.IsConstraintError(err) {
			err = &ConstraintError{msg: err.Error(), wrap: err}
		}
		return nil, err
	}
	cuo.mutation.done = true
	return _node, nil
}
