// Code generated by ent, DO NOT EDIT.

package migrate

import (
	"entgo.io/ent/dialect/sql/schema"
	"entgo.io/ent/schema/field"
)

var (
	// AnnouncementsColumns holds the columns for the "announcements" table.
	AnnouncementsColumns = []*schema.Column{
		{Name: "id", Type: field.TypeInt, Increment: true},
		{Name: "body", Type: field.TypeString, Nullable: true, Size: 2147483647},
		{Name: "title", Type: field.TypeString, Nullable: true},
		{Name: "link", Type: field.TypeString, Nullable: true},
		{Name: "warning", Type: field.TypeBool, Nullable: true},
		{Name: "active", Type: field.TypeBool, Nullable: true},
	}
	// AnnouncementsTable holds the schema information for the "announcements" table.
	AnnouncementsTable = &schema.Table{
		Name:       "announcements",
		Columns:    AnnouncementsColumns,
		PrimaryKey: []*schema.Column{AnnouncementsColumns[0]},
		Indexes: []*schema.Index{
			{
				Name:    "announcement_active",
				Unique:  false,
				Columns: []*schema.Column{AnnouncementsColumns[5]},
			},
		},
	}
	// AttributesColumns holds the columns for the "attributes" table.
	AttributesColumns = []*schema.Column{
		{Name: "id", Type: field.TypeString},
		{Name: "created_at", Type: field.TypeTime, Default: "CURRENT_TIMESTAMP"},
		{Name: "title", Type: field.TypeString},
		{Name: "bonus", Type: field.TypeFloat64, Default: 0},
		{Name: "slug", Type: field.TypeString, Unique: true},
		{Name: "rating", Type: field.TypeEnum, Enums: []string{"good", "bad", "warn", "info"}},
		{Name: "description", Type: field.TypeString, Nullable: true, Size: 2147483647},
	}
	// AttributesTable holds the schema information for the "attributes" table.
	AttributesTable = &schema.Table{
		Name:       "attributes",
		Columns:    AttributesColumns,
		PrimaryKey: []*schema.Column{AttributesColumns[0]},
		Indexes: []*schema.Index{
			{
				Name:    "attribute_title_rating",
				Unique:  false,
				Columns: []*schema.Column{AttributesColumns[2], AttributesColumns[5]},
			},
			{
				Name:    "attribute_slug",
				Unique:  false,
				Columns: []*schema.Column{AttributesColumns[4]},
			},
		},
	}
	// ChangesColumns holds the columns for the "changes" table.
	ChangesColumns = []*schema.Column{
		{Name: "id", Type: field.TypeInt, Increment: true},
		{Name: "title", Type: field.TypeString, Nullable: true},
		{Name: "summary", Type: field.TypeString, Nullable: true, Size: 2147483647},
		{Name: "created_at", Type: field.TypeTime, Default: "CURRENT_TIMESTAMP"},
		{Name: "warning", Type: field.TypeBool, Default: false},
		{Name: "service_changes", Type: field.TypeString, Nullable: true},
	}
	// ChangesTable holds the schema information for the "changes" table.
	ChangesTable = &schema.Table{
		Name:       "changes",
		Columns:    ChangesColumns,
		PrimaryKey: []*schema.Column{ChangesColumns[0]},
		ForeignKeys: []*schema.ForeignKey{
			{
				Symbol:     "changes_services_changes",
				Columns:    []*schema.Column{ChangesColumns[5]},
				RefColumns: []*schema.Column{ServicesColumns[0]},
				OnDelete:   schema.SetNull,
			},
		},
	}
	// ServicesColumns holds the columns for the "services" table.
	ServicesColumns = []*schema.Column{
		{Name: "id", Type: field.TypeString},
		{Name: "created_at", Type: field.TypeTime, Default: "CURRENT_TIMESTAMP"},
		{Name: "name", Type: field.TypeString},
		{Name: "slug", Type: field.TypeString, Unique: true},
		{Name: "description", Type: field.TypeString, Size: 532},
		{Name: "logo_url", Type: field.TypeString, Nullable: true},
		{Name: "tos_urls", Type: field.TypeJSON, Nullable: true},
		{Name: "onion_urls", Type: field.TypeJSON, Nullable: true},
		{Name: "category", Type: field.TypeString, Nullable: true},
		{Name: "comments", Type: field.TypeJSON, Nullable: true},
		{Name: "tos_reviews", Type: field.TypeJSON, Nullable: true},
		{Name: "urls", Type: field.TypeJSON},
		{Name: "tags", Type: field.TypeJSON, Nullable: true},
		{Name: "kyc_level", Type: field.TypeInt, Nullable: true},
		{Name: "type", Type: field.TypeEnum, Enums: []string{"exchange", "service"}, Default: "exchange"},
		{Name: "listed", Type: field.TypeBool, Default: false},
		{Name: "verified", Type: field.TypeBool, Default: false},
		{Name: "pending", Type: field.TypeBool, Default: true},
		{Name: "xmr", Type: field.TypeBool, Default: false},
		{Name: "btc", Type: field.TypeBool, Default: false},
		{Name: "lightning", Type: field.TypeBool, Default: false},
		{Name: "cash", Type: field.TypeBool, Default: false},
		{Name: "fiat", Type: field.TypeBool, Default: false},
		{Name: "last_tos_review", Type: field.TypeTime, Nullable: true},
		{Name: "referral", Type: field.TypeString, Nullable: true},
		{Name: "score", Type: field.TypeInt, Nullable: true},
		{Name: "potential_scam", Type: field.TypeBool, Default: false},
		{Name: "notes", Type: field.TypeJSON, Nullable: true},
		{Name: "support", Type: field.TypeJSON, Nullable: true},
	}
	// ServicesTable holds the schema information for the "services" table.
	ServicesTable = &schema.Table{
		Name:       "services",
		Columns:    ServicesColumns,
		PrimaryKey: []*schema.Column{ServicesColumns[0]},
		Indexes: []*schema.Index{
			{
				Name:    "service_name_category",
				Unique:  false,
				Columns: []*schema.Column{ServicesColumns[2], ServicesColumns[8]},
			},
			{
				Name:    "service_slug_category",
				Unique:  false,
				Columns: []*schema.Column{ServicesColumns[3], ServicesColumns[8]},
			},
			{
				Name:    "service_slug",
				Unique:  false,
				Columns: []*schema.Column{ServicesColumns[3]},
			},
			{
				Name:    "service_type_listed_verified",
				Unique:  false,
				Columns: []*schema.Column{ServicesColumns[14], ServicesColumns[15], ServicesColumns[16]},
			},
			{
				Name:    "service_xmr_btc_lightning_cash_fiat",
				Unique:  false,
				Columns: []*schema.Column{ServicesColumns[18], ServicesColumns[19], ServicesColumns[20], ServicesColumns[21], ServicesColumns[22]},
			},
			{
				Name:    "service_kyc_level_score",
				Unique:  false,
				Columns: []*schema.Column{ServicesColumns[13], ServicesColumns[25]},
			},
		},
	}
	// ServiceAttributesColumns holds the columns for the "service_attributes" table.
	ServiceAttributesColumns = []*schema.Column{
		{Name: "service_id", Type: field.TypeString},
		{Name: "attribute_id", Type: field.TypeString},
	}
	// ServiceAttributesTable holds the schema information for the "service_attributes" table.
	ServiceAttributesTable = &schema.Table{
		Name:       "service_attributes",
		Columns:    ServiceAttributesColumns,
		PrimaryKey: []*schema.Column{ServiceAttributesColumns[0], ServiceAttributesColumns[1]},
		ForeignKeys: []*schema.ForeignKey{
			{
				Symbol:     "service_attributes_service_id",
				Columns:    []*schema.Column{ServiceAttributesColumns[0]},
				RefColumns: []*schema.Column{ServicesColumns[0]},
				OnDelete:   schema.Cascade,
			},
			{
				Symbol:     "service_attributes_attribute_id",
				Columns:    []*schema.Column{ServiceAttributesColumns[1]},
				RefColumns: []*schema.Column{AttributesColumns[0]},
				OnDelete:   schema.Cascade,
			},
		},
	}
	// Tables holds all the tables in the schema.
	Tables = []*schema.Table{
		AnnouncementsTable,
		AttributesTable,
		ChangesTable,
		ServicesTable,
		ServiceAttributesTable,
	}
)

func init() {
	ChangesTable.ForeignKeys[0].RefTable = ServicesTable
	ServiceAttributesTable.ForeignKeys[0].RefTable = ServicesTable
	ServiceAttributesTable.ForeignKeys[1].RefTable = AttributesTable
}
