// Code generated by ent, DO NOT EDIT.

package service

import (
	"fmt"
	"time"

	"entgo.io/ent/dialect/sql"
	"entgo.io/ent/dialect/sql/sqlgraph"
)

const (
	// Label holds the string label denoting the service type in the database.
	Label = "service"
	// FieldID holds the string denoting the id field in the database.
	FieldID = "id"
	// FieldCreatedAt holds the string denoting the createdat field in the database.
	FieldCreatedAt = "created_at"
	// FieldName holds the string denoting the name field in the database.
	FieldName = "name"
	// FieldSlug holds the string denoting the slug field in the database.
	FieldSlug = "slug"
	// FieldDescription holds the string denoting the description field in the database.
	FieldDescription = "description"
	// FieldLogoURL holds the string denoting the logo_url field in the database.
	FieldLogoURL = "logo_url"
	// FieldTosUrls holds the string denoting the tos_urls field in the database.
	FieldTosUrls = "tos_urls"
	// FieldOnionUrls holds the string denoting the onion_urls field in the database.
	FieldOnionUrls = "onion_urls"
	// FieldCategory holds the string denoting the category field in the database.
	FieldCategory = "category"
	// FieldComments holds the string denoting the comments field in the database.
	FieldComments = "comments"
	// FieldTosReviews holds the string denoting the tos_reviews field in the database.
	FieldTosReviews = "tos_reviews"
	// FieldUrls holds the string denoting the urls field in the database.
	FieldUrls = "urls"
	// FieldTags holds the string denoting the tags field in the database.
	FieldTags = "tags"
	// FieldKycLevel holds the string denoting the kyc_level field in the database.
	FieldKycLevel = "kyc_level"
	// FieldType holds the string denoting the type field in the database.
	FieldType = "type"
	// FieldListed holds the string denoting the listed field in the database.
	FieldListed = "listed"
	// FieldVerified holds the string denoting the verified field in the database.
	FieldVerified = "verified"
	// FieldPending holds the string denoting the pending field in the database.
	FieldPending = "pending"
	// FieldXmr holds the string denoting the xmr field in the database.
	FieldXmr = "xmr"
	// FieldBtc holds the string denoting the btc field in the database.
	FieldBtc = "btc"
	// FieldLightning holds the string denoting the lightning field in the database.
	FieldLightning = "lightning"
	// FieldCash holds the string denoting the cash field in the database.
	FieldCash = "cash"
	// FieldFiat holds the string denoting the fiat field in the database.
	FieldFiat = "fiat"
	// FieldLastTosReview holds the string denoting the last_tos_review field in the database.
	FieldLastTosReview = "last_tos_review"
	// FieldReferral holds the string denoting the referral field in the database.
	FieldReferral = "referral"
	// FieldScore holds the string denoting the score field in the database.
	FieldScore = "score"
	// FieldPotentialScam holds the string denoting the potential_scam field in the database.
	FieldPotentialScam = "potential_scam"
	// FieldNotes holds the string denoting the notes field in the database.
	FieldNotes = "notes"
	// FieldSupport holds the string denoting the support field in the database.
	FieldSupport = "support"
	// EdgeAttributes holds the string denoting the attributes edge name in mutations.
	EdgeAttributes = "attributes"
	// EdgeChanges holds the string denoting the changes edge name in mutations.
	EdgeChanges = "changes"
	// Table holds the table name of the service in the database.
	Table = "services"
	// AttributesTable is the table that holds the attributes relation/edge. The primary key declared below.
	AttributesTable = "service_attributes"
	// AttributesInverseTable is the table name for the Attribute entity.
	// It exists in this package in order to avoid circular dependency with the "attribute" package.
	AttributesInverseTable = "attributes"
	// ChangesTable is the table that holds the changes relation/edge.
	ChangesTable = "changes"
	// ChangesInverseTable is the table name for the Change entity.
	// It exists in this package in order to avoid circular dependency with the "change" package.
	ChangesInverseTable = "changes"
	// ChangesColumn is the table column denoting the changes relation/edge.
	ChangesColumn = "service_changes"
)

// Columns holds all SQL columns for service fields.
var Columns = []string{
	FieldID,
	FieldCreatedAt,
	FieldName,
	FieldSlug,
	FieldDescription,
	FieldLogoURL,
	FieldTosUrls,
	FieldOnionUrls,
	FieldCategory,
	FieldComments,
	FieldTosReviews,
	FieldUrls,
	FieldTags,
	FieldKycLevel,
	FieldType,
	FieldListed,
	FieldVerified,
	FieldPending,
	FieldXmr,
	FieldBtc,
	FieldLightning,
	FieldCash,
	FieldFiat,
	FieldLastTosReview,
	FieldReferral,
	FieldScore,
	FieldPotentialScam,
	FieldNotes,
	FieldSupport,
}

var (
	// AttributesPrimaryKey and AttributesColumn2 are the table columns denoting the
	// primary key for the attributes relation (M2M).
	AttributesPrimaryKey = []string{"service_id", "attribute_id"}
)

// ValidColumn reports if the column name is valid (part of the table columns).
func ValidColumn(column string) bool {
	for i := range Columns {
		if column == Columns[i] {
			return true
		}
	}
	return false
}

var (
	// DefaultCreatedAt holds the default value on creation for the "createdAt" field.
	DefaultCreatedAt func() time.Time
	// SlugValidator is a validator for the "slug" field. It is called by the builders before save.
	SlugValidator func(string) error
	// DescriptionValidator is a validator for the "description" field. It is called by the builders before save.
	DescriptionValidator func(string) error
	// KycLevelValidator is a validator for the "kyc_level" field. It is called by the builders before save.
	KycLevelValidator func(int) error
	// DefaultListed holds the default value on creation for the "listed" field.
	DefaultListed bool
	// DefaultVerified holds the default value on creation for the "verified" field.
	DefaultVerified bool
	// DefaultPending holds the default value on creation for the "pending" field.
	DefaultPending bool
	// DefaultXmr holds the default value on creation for the "xmr" field.
	DefaultXmr bool
	// DefaultBtc holds the default value on creation for the "btc" field.
	DefaultBtc bool
	// DefaultLightning holds the default value on creation for the "lightning" field.
	DefaultLightning bool
	// DefaultCash holds the default value on creation for the "cash" field.
	DefaultCash bool
	// DefaultFiat holds the default value on creation for the "fiat" field.
	DefaultFiat bool
	// ScoreValidator is a validator for the "score" field. It is called by the builders before save.
	ScoreValidator func(int) error
	// DefaultPotentialScam holds the default value on creation for the "potential_scam" field.
	DefaultPotentialScam bool
	// DefaultID holds the default value on creation for the "id" field.
	DefaultID func() string
)

// Type defines the type for the "type" enum field.
type Type string

// TypeExchange is the default value of the Type enum.
const DefaultType = TypeExchange

// Type values.
const (
	TypeExchange Type = "exchange"
	TypeService  Type = "service"
)

func (_type Type) String() string {
	return string(_type)
}

// TypeValidator is a validator for the "type" field enum values. It is called by the builders before save.
func TypeValidator(_type Type) error {
	switch _type {
	case TypeExchange, TypeService:
		return nil
	default:
		return fmt.Errorf("service: invalid enum value for type field: %q", _type)
	}
}

// OrderOption defines the ordering options for the Service queries.
type OrderOption func(*sql.Selector)

// ByID orders the results by the id field.
func ByID(opts ...sql.OrderTermOption) OrderOption {
	return sql.OrderByField(FieldID, opts...).ToFunc()
}

// ByCreatedAt orders the results by the createdAt field.
func ByCreatedAt(opts ...sql.OrderTermOption) OrderOption {
	return sql.OrderByField(FieldCreatedAt, opts...).ToFunc()
}

// ByName orders the results by the name field.
func ByName(opts ...sql.OrderTermOption) OrderOption {
	return sql.OrderByField(FieldName, opts...).ToFunc()
}

// BySlug orders the results by the slug field.
func BySlug(opts ...sql.OrderTermOption) OrderOption {
	return sql.OrderByField(FieldSlug, opts...).ToFunc()
}

// ByDescription orders the results by the description field.
func ByDescription(opts ...sql.OrderTermOption) OrderOption {
	return sql.OrderByField(FieldDescription, opts...).ToFunc()
}

// ByLogoURL orders the results by the logo_url field.
func ByLogoURL(opts ...sql.OrderTermOption) OrderOption {
	return sql.OrderByField(FieldLogoURL, opts...).ToFunc()
}

// ByCategory orders the results by the category field.
func ByCategory(opts ...sql.OrderTermOption) OrderOption {
	return sql.OrderByField(FieldCategory, opts...).ToFunc()
}

// ByKycLevel orders the results by the kyc_level field.
func ByKycLevel(opts ...sql.OrderTermOption) OrderOption {
	return sql.OrderByField(FieldKycLevel, opts...).ToFunc()
}

// ByType orders the results by the type field.
func ByType(opts ...sql.OrderTermOption) OrderOption {
	return sql.OrderByField(FieldType, opts...).ToFunc()
}

// ByListed orders the results by the listed field.
func ByListed(opts ...sql.OrderTermOption) OrderOption {
	return sql.OrderByField(FieldListed, opts...).ToFunc()
}

// ByVerified orders the results by the verified field.
func ByVerified(opts ...sql.OrderTermOption) OrderOption {
	return sql.OrderByField(FieldVerified, opts...).ToFunc()
}

// ByPending orders the results by the pending field.
func ByPending(opts ...sql.OrderTermOption) OrderOption {
	return sql.OrderByField(FieldPending, opts...).ToFunc()
}

// ByXmr orders the results by the xmr field.
func ByXmr(opts ...sql.OrderTermOption) OrderOption {
	return sql.OrderByField(FieldXmr, opts...).ToFunc()
}

// ByBtc orders the results by the btc field.
func ByBtc(opts ...sql.OrderTermOption) OrderOption {
	return sql.OrderByField(FieldBtc, opts...).ToFunc()
}

// ByLightning orders the results by the lightning field.
func ByLightning(opts ...sql.OrderTermOption) OrderOption {
	return sql.OrderByField(FieldLightning, opts...).ToFunc()
}

// ByCash orders the results by the cash field.
func ByCash(opts ...sql.OrderTermOption) OrderOption {
	return sql.OrderByField(FieldCash, opts...).ToFunc()
}

// ByFiat orders the results by the fiat field.
func ByFiat(opts ...sql.OrderTermOption) OrderOption {
	return sql.OrderByField(FieldFiat, opts...).ToFunc()
}

// ByLastTosReview orders the results by the last_tos_review field.
func ByLastTosReview(opts ...sql.OrderTermOption) OrderOption {
	return sql.OrderByField(FieldLastTosReview, opts...).ToFunc()
}

// ByReferral orders the results by the referral field.
func ByReferral(opts ...sql.OrderTermOption) OrderOption {
	return sql.OrderByField(FieldReferral, opts...).ToFunc()
}

// ByScore orders the results by the score field.
func ByScore(opts ...sql.OrderTermOption) OrderOption {
	return sql.OrderByField(FieldScore, opts...).ToFunc()
}

// ByPotentialScam orders the results by the potential_scam field.
func ByPotentialScam(opts ...sql.OrderTermOption) OrderOption {
	return sql.OrderByField(FieldPotentialScam, opts...).ToFunc()
}

// ByAttributesCount orders the results by attributes count.
func ByAttributesCount(opts ...sql.OrderTermOption) OrderOption {
	return func(s *sql.Selector) {
		sqlgraph.OrderByNeighborsCount(s, newAttributesStep(), opts...)
	}
}

// ByAttributes orders the results by attributes terms.
func ByAttributes(term sql.OrderTerm, terms ...sql.OrderTerm) OrderOption {
	return func(s *sql.Selector) {
		sqlgraph.OrderByNeighborTerms(s, newAttributesStep(), append([]sql.OrderTerm{term}, terms...)...)
	}
}

// ByChangesCount orders the results by changes count.
func ByChangesCount(opts ...sql.OrderTermOption) OrderOption {
	return func(s *sql.Selector) {
		sqlgraph.OrderByNeighborsCount(s, newChangesStep(), opts...)
	}
}

// ByChanges orders the results by changes terms.
func ByChanges(term sql.OrderTerm, terms ...sql.OrderTerm) OrderOption {
	return func(s *sql.Selector) {
		sqlgraph.OrderByNeighborTerms(s, newChangesStep(), append([]sql.OrderTerm{term}, terms...)...)
	}
}
func newAttributesStep() *sqlgraph.Step {
	return sqlgraph.NewStep(
		sqlgraph.From(Table, FieldID),
		sqlgraph.To(AttributesInverseTable, FieldID),
		sqlgraph.Edge(sqlgraph.M2M, false, AttributesTable, AttributesPrimaryKey...),
	)
}
func newChangesStep() *sqlgraph.Step {
	return sqlgraph.NewStep(
		sqlgraph.From(Table, FieldID),
		sqlgraph.To(ChangesInverseTable, FieldID),
		sqlgraph.Edge(sqlgraph.O2M, false, ChangesTable, ChangesColumn),
	)
}
