// Code generated by ent, DO NOT EDIT.

package service

import (
	"time"

	"entgo.io/ent/dialect/sql"
	"entgo.io/ent/dialect/sql/sqlgraph"
	"kycnot.me/internal/ent/predicate"
)

// ID filters vertices based on their ID field.
func ID(id string) predicate.Service {
	return predicate.Service(sql.FieldEQ(FieldID, id))
}

// IDEQ applies the EQ predicate on the ID field.
func IDEQ(id string) predicate.Service {
	return predicate.Service(sql.FieldEQ(FieldID, id))
}

// IDNEQ applies the NEQ predicate on the ID field.
func IDNEQ(id string) predicate.Service {
	return predicate.Service(sql.FieldNEQ(FieldID, id))
}

// IDIn applies the In predicate on the ID field.
func IDIn(ids ...string) predicate.Service {
	return predicate.Service(sql.FieldIn(FieldID, ids...))
}

// IDNotIn applies the NotIn predicate on the ID field.
func IDNotIn(ids ...string) predicate.Service {
	return predicate.Service(sql.FieldNotIn(FieldID, ids...))
}

// IDGT applies the GT predicate on the ID field.
func IDGT(id string) predicate.Service {
	return predicate.Service(sql.FieldGT(FieldID, id))
}

// IDGTE applies the GTE predicate on the ID field.
func IDGTE(id string) predicate.Service {
	return predicate.Service(sql.FieldGTE(FieldID, id))
}

// IDLT applies the LT predicate on the ID field.
func IDLT(id string) predicate.Service {
	return predicate.Service(sql.FieldLT(FieldID, id))
}

// IDLTE applies the LTE predicate on the ID field.
func IDLTE(id string) predicate.Service {
	return predicate.Service(sql.FieldLTE(FieldID, id))
}

// IDEqualFold applies the EqualFold predicate on the ID field.
func IDEqualFold(id string) predicate.Service {
	return predicate.Service(sql.FieldEqualFold(FieldID, id))
}

// IDContainsFold applies the ContainsFold predicate on the ID field.
func IDContainsFold(id string) predicate.Service {
	return predicate.Service(sql.FieldContainsFold(FieldID, id))
}

// CreatedAt applies equality check predicate on the "createdAt" field. It's identical to CreatedAtEQ.
func CreatedAt(v time.Time) predicate.Service {
	return predicate.Service(sql.FieldEQ(FieldCreatedAt, v))
}

// Name applies equality check predicate on the "name" field. It's identical to NameEQ.
func Name(v string) predicate.Service {
	return predicate.Service(sql.FieldEQ(FieldName, v))
}

// Slug applies equality check predicate on the "slug" field. It's identical to SlugEQ.
func Slug(v string) predicate.Service {
	return predicate.Service(sql.FieldEQ(FieldSlug, v))
}

// Description applies equality check predicate on the "description" field. It's identical to DescriptionEQ.
func Description(v string) predicate.Service {
	return predicate.Service(sql.FieldEQ(FieldDescription, v))
}

// LogoURL applies equality check predicate on the "logo_url" field. It's identical to LogoURLEQ.
func LogoURL(v string) predicate.Service {
	return predicate.Service(sql.FieldEQ(FieldLogoURL, v))
}

// Category applies equality check predicate on the "category" field. It's identical to CategoryEQ.
func Category(v string) predicate.Service {
	return predicate.Service(sql.FieldEQ(FieldCategory, v))
}

// KycLevel applies equality check predicate on the "kyc_level" field. It's identical to KycLevelEQ.
func KycLevel(v int) predicate.Service {
	return predicate.Service(sql.FieldEQ(FieldKycLevel, v))
}

// Listed applies equality check predicate on the "listed" field. It's identical to ListedEQ.
func Listed(v bool) predicate.Service {
	return predicate.Service(sql.FieldEQ(FieldListed, v))
}

// Verified applies equality check predicate on the "verified" field. It's identical to VerifiedEQ.
func Verified(v bool) predicate.Service {
	return predicate.Service(sql.FieldEQ(FieldVerified, v))
}

// Pending applies equality check predicate on the "pending" field. It's identical to PendingEQ.
func Pending(v bool) predicate.Service {
	return predicate.Service(sql.FieldEQ(FieldPending, v))
}

// Xmr applies equality check predicate on the "xmr" field. It's identical to XmrEQ.
func Xmr(v bool) predicate.Service {
	return predicate.Service(sql.FieldEQ(FieldXmr, v))
}

// Btc applies equality check predicate on the "btc" field. It's identical to BtcEQ.
func Btc(v bool) predicate.Service {
	return predicate.Service(sql.FieldEQ(FieldBtc, v))
}

// Lightning applies equality check predicate on the "lightning" field. It's identical to LightningEQ.
func Lightning(v bool) predicate.Service {
	return predicate.Service(sql.FieldEQ(FieldLightning, v))
}

// Cash applies equality check predicate on the "cash" field. It's identical to CashEQ.
func Cash(v bool) predicate.Service {
	return predicate.Service(sql.FieldEQ(FieldCash, v))
}

// Fiat applies equality check predicate on the "fiat" field. It's identical to FiatEQ.
func Fiat(v bool) predicate.Service {
	return predicate.Service(sql.FieldEQ(FieldFiat, v))
}

// LastTosReview applies equality check predicate on the "last_tos_review" field. It's identical to LastTosReviewEQ.
func LastTosReview(v time.Time) predicate.Service {
	return predicate.Service(sql.FieldEQ(FieldLastTosReview, v))
}

// Referral applies equality check predicate on the "referral" field. It's identical to ReferralEQ.
func Referral(v string) predicate.Service {
	return predicate.Service(sql.FieldEQ(FieldReferral, v))
}

// Score applies equality check predicate on the "score" field. It's identical to ScoreEQ.
func Score(v int) predicate.Service {
	return predicate.Service(sql.FieldEQ(FieldScore, v))
}

// PotentialScam applies equality check predicate on the "potential_scam" field. It's identical to PotentialScamEQ.
func PotentialScam(v bool) predicate.Service {
	return predicate.Service(sql.FieldEQ(FieldPotentialScam, v))
}

// CreatedAtEQ applies the EQ predicate on the "createdAt" field.
func CreatedAtEQ(v time.Time) predicate.Service {
	return predicate.Service(sql.FieldEQ(FieldCreatedAt, v))
}

// CreatedAtNEQ applies the NEQ predicate on the "createdAt" field.
func CreatedAtNEQ(v time.Time) predicate.Service {
	return predicate.Service(sql.FieldNEQ(FieldCreatedAt, v))
}

// CreatedAtIn applies the In predicate on the "createdAt" field.
func CreatedAtIn(vs ...time.Time) predicate.Service {
	return predicate.Service(sql.FieldIn(FieldCreatedAt, vs...))
}

// CreatedAtNotIn applies the NotIn predicate on the "createdAt" field.
func CreatedAtNotIn(vs ...time.Time) predicate.Service {
	return predicate.Service(sql.FieldNotIn(FieldCreatedAt, vs...))
}

// CreatedAtGT applies the GT predicate on the "createdAt" field.
func CreatedAtGT(v time.Time) predicate.Service {
	return predicate.Service(sql.FieldGT(FieldCreatedAt, v))
}

// CreatedAtGTE applies the GTE predicate on the "createdAt" field.
func CreatedAtGTE(v time.Time) predicate.Service {
	return predicate.Service(sql.FieldGTE(FieldCreatedAt, v))
}

// CreatedAtLT applies the LT predicate on the "createdAt" field.
func CreatedAtLT(v time.Time) predicate.Service {
	return predicate.Service(sql.FieldLT(FieldCreatedAt, v))
}

// CreatedAtLTE applies the LTE predicate on the "createdAt" field.
func CreatedAtLTE(v time.Time) predicate.Service {
	return predicate.Service(sql.FieldLTE(FieldCreatedAt, v))
}

// NameEQ applies the EQ predicate on the "name" field.
func NameEQ(v string) predicate.Service {
	return predicate.Service(sql.FieldEQ(FieldName, v))
}

// NameNEQ applies the NEQ predicate on the "name" field.
func NameNEQ(v string) predicate.Service {
	return predicate.Service(sql.FieldNEQ(FieldName, v))
}

// NameIn applies the In predicate on the "name" field.
func NameIn(vs ...string) predicate.Service {
	return predicate.Service(sql.FieldIn(FieldName, vs...))
}

// NameNotIn applies the NotIn predicate on the "name" field.
func NameNotIn(vs ...string) predicate.Service {
	return predicate.Service(sql.FieldNotIn(FieldName, vs...))
}

// NameGT applies the GT predicate on the "name" field.
func NameGT(v string) predicate.Service {
	return predicate.Service(sql.FieldGT(FieldName, v))
}

// NameGTE applies the GTE predicate on the "name" field.
func NameGTE(v string) predicate.Service {
	return predicate.Service(sql.FieldGTE(FieldName, v))
}

// NameLT applies the LT predicate on the "name" field.
func NameLT(v string) predicate.Service {
	return predicate.Service(sql.FieldLT(FieldName, v))
}

// NameLTE applies the LTE predicate on the "name" field.
func NameLTE(v string) predicate.Service {
	return predicate.Service(sql.FieldLTE(FieldName, v))
}

// NameContains applies the Contains predicate on the "name" field.
func NameContains(v string) predicate.Service {
	return predicate.Service(sql.FieldContains(FieldName, v))
}

// NameHasPrefix applies the HasPrefix predicate on the "name" field.
func NameHasPrefix(v string) predicate.Service {
	return predicate.Service(sql.FieldHasPrefix(FieldName, v))
}

// NameHasSuffix applies the HasSuffix predicate on the "name" field.
func NameHasSuffix(v string) predicate.Service {
	return predicate.Service(sql.FieldHasSuffix(FieldName, v))
}

// NameEqualFold applies the EqualFold predicate on the "name" field.
func NameEqualFold(v string) predicate.Service {
	return predicate.Service(sql.FieldEqualFold(FieldName, v))
}

// NameContainsFold applies the ContainsFold predicate on the "name" field.
func NameContainsFold(v string) predicate.Service {
	return predicate.Service(sql.FieldContainsFold(FieldName, v))
}

// SlugEQ applies the EQ predicate on the "slug" field.
func SlugEQ(v string) predicate.Service {
	return predicate.Service(sql.FieldEQ(FieldSlug, v))
}

// SlugNEQ applies the NEQ predicate on the "slug" field.
func SlugNEQ(v string) predicate.Service {
	return predicate.Service(sql.FieldNEQ(FieldSlug, v))
}

// SlugIn applies the In predicate on the "slug" field.
func SlugIn(vs ...string) predicate.Service {
	return predicate.Service(sql.FieldIn(FieldSlug, vs...))
}

// SlugNotIn applies the NotIn predicate on the "slug" field.
func SlugNotIn(vs ...string) predicate.Service {
	return predicate.Service(sql.FieldNotIn(FieldSlug, vs...))
}

// SlugGT applies the GT predicate on the "slug" field.
func SlugGT(v string) predicate.Service {
	return predicate.Service(sql.FieldGT(FieldSlug, v))
}

// SlugGTE applies the GTE predicate on the "slug" field.
func SlugGTE(v string) predicate.Service {
	return predicate.Service(sql.FieldGTE(FieldSlug, v))
}

// SlugLT applies the LT predicate on the "slug" field.
func SlugLT(v string) predicate.Service {
	return predicate.Service(sql.FieldLT(FieldSlug, v))
}

// SlugLTE applies the LTE predicate on the "slug" field.
func SlugLTE(v string) predicate.Service {
	return predicate.Service(sql.FieldLTE(FieldSlug, v))
}

// SlugContains applies the Contains predicate on the "slug" field.
func SlugContains(v string) predicate.Service {
	return predicate.Service(sql.FieldContains(FieldSlug, v))
}

// SlugHasPrefix applies the HasPrefix predicate on the "slug" field.
func SlugHasPrefix(v string) predicate.Service {
	return predicate.Service(sql.FieldHasPrefix(FieldSlug, v))
}

// SlugHasSuffix applies the HasSuffix predicate on the "slug" field.
func SlugHasSuffix(v string) predicate.Service {
	return predicate.Service(sql.FieldHasSuffix(FieldSlug, v))
}

// SlugEqualFold applies the EqualFold predicate on the "slug" field.
func SlugEqualFold(v string) predicate.Service {
	return predicate.Service(sql.FieldEqualFold(FieldSlug, v))
}

// SlugContainsFold applies the ContainsFold predicate on the "slug" field.
func SlugContainsFold(v string) predicate.Service {
	return predicate.Service(sql.FieldContainsFold(FieldSlug, v))
}

// DescriptionEQ applies the EQ predicate on the "description" field.
func DescriptionEQ(v string) predicate.Service {
	return predicate.Service(sql.FieldEQ(FieldDescription, v))
}

// DescriptionNEQ applies the NEQ predicate on the "description" field.
func DescriptionNEQ(v string) predicate.Service {
	return predicate.Service(sql.FieldNEQ(FieldDescription, v))
}

// DescriptionIn applies the In predicate on the "description" field.
func DescriptionIn(vs ...string) predicate.Service {
	return predicate.Service(sql.FieldIn(FieldDescription, vs...))
}

// DescriptionNotIn applies the NotIn predicate on the "description" field.
func DescriptionNotIn(vs ...string) predicate.Service {
	return predicate.Service(sql.FieldNotIn(FieldDescription, vs...))
}

// DescriptionGT applies the GT predicate on the "description" field.
func DescriptionGT(v string) predicate.Service {
	return predicate.Service(sql.FieldGT(FieldDescription, v))
}

// DescriptionGTE applies the GTE predicate on the "description" field.
func DescriptionGTE(v string) predicate.Service {
	return predicate.Service(sql.FieldGTE(FieldDescription, v))
}

// DescriptionLT applies the LT predicate on the "description" field.
func DescriptionLT(v string) predicate.Service {
	return predicate.Service(sql.FieldLT(FieldDescription, v))
}

// DescriptionLTE applies the LTE predicate on the "description" field.
func DescriptionLTE(v string) predicate.Service {
	return predicate.Service(sql.FieldLTE(FieldDescription, v))
}

// DescriptionContains applies the Contains predicate on the "description" field.
func DescriptionContains(v string) predicate.Service {
	return predicate.Service(sql.FieldContains(FieldDescription, v))
}

// DescriptionHasPrefix applies the HasPrefix predicate on the "description" field.
func DescriptionHasPrefix(v string) predicate.Service {
	return predicate.Service(sql.FieldHasPrefix(FieldDescription, v))
}

// DescriptionHasSuffix applies the HasSuffix predicate on the "description" field.
func DescriptionHasSuffix(v string) predicate.Service {
	return predicate.Service(sql.FieldHasSuffix(FieldDescription, v))
}

// DescriptionEqualFold applies the EqualFold predicate on the "description" field.
func DescriptionEqualFold(v string) predicate.Service {
	return predicate.Service(sql.FieldEqualFold(FieldDescription, v))
}

// DescriptionContainsFold applies the ContainsFold predicate on the "description" field.
func DescriptionContainsFold(v string) predicate.Service {
	return predicate.Service(sql.FieldContainsFold(FieldDescription, v))
}

// LogoURLEQ applies the EQ predicate on the "logo_url" field.
func LogoURLEQ(v string) predicate.Service {
	return predicate.Service(sql.FieldEQ(FieldLogoURL, v))
}

// LogoURLNEQ applies the NEQ predicate on the "logo_url" field.
func LogoURLNEQ(v string) predicate.Service {
	return predicate.Service(sql.FieldNEQ(FieldLogoURL, v))
}

// LogoURLIn applies the In predicate on the "logo_url" field.
func LogoURLIn(vs ...string) predicate.Service {
	return predicate.Service(sql.FieldIn(FieldLogoURL, vs...))
}

// LogoURLNotIn applies the NotIn predicate on the "logo_url" field.
func LogoURLNotIn(vs ...string) predicate.Service {
	return predicate.Service(sql.FieldNotIn(FieldLogoURL, vs...))
}

// LogoURLGT applies the GT predicate on the "logo_url" field.
func LogoURLGT(v string) predicate.Service {
	return predicate.Service(sql.FieldGT(FieldLogoURL, v))
}

// LogoURLGTE applies the GTE predicate on the "logo_url" field.
func LogoURLGTE(v string) predicate.Service {
	return predicate.Service(sql.FieldGTE(FieldLogoURL, v))
}

// LogoURLLT applies the LT predicate on the "logo_url" field.
func LogoURLLT(v string) predicate.Service {
	return predicate.Service(sql.FieldLT(FieldLogoURL, v))
}

// LogoURLLTE applies the LTE predicate on the "logo_url" field.
func LogoURLLTE(v string) predicate.Service {
	return predicate.Service(sql.FieldLTE(FieldLogoURL, v))
}

// LogoURLContains applies the Contains predicate on the "logo_url" field.
func LogoURLContains(v string) predicate.Service {
	return predicate.Service(sql.FieldContains(FieldLogoURL, v))
}

// LogoURLHasPrefix applies the HasPrefix predicate on the "logo_url" field.
func LogoURLHasPrefix(v string) predicate.Service {
	return predicate.Service(sql.FieldHasPrefix(FieldLogoURL, v))
}

// LogoURLHasSuffix applies the HasSuffix predicate on the "logo_url" field.
func LogoURLHasSuffix(v string) predicate.Service {
	return predicate.Service(sql.FieldHasSuffix(FieldLogoURL, v))
}

// LogoURLIsNil applies the IsNil predicate on the "logo_url" field.
func LogoURLIsNil() predicate.Service {
	return predicate.Service(sql.FieldIsNull(FieldLogoURL))
}

// LogoURLNotNil applies the NotNil predicate on the "logo_url" field.
func LogoURLNotNil() predicate.Service {
	return predicate.Service(sql.FieldNotNull(FieldLogoURL))
}

// LogoURLEqualFold applies the EqualFold predicate on the "logo_url" field.
func LogoURLEqualFold(v string) predicate.Service {
	return predicate.Service(sql.FieldEqualFold(FieldLogoURL, v))
}

// LogoURLContainsFold applies the ContainsFold predicate on the "logo_url" field.
func LogoURLContainsFold(v string) predicate.Service {
	return predicate.Service(sql.FieldContainsFold(FieldLogoURL, v))
}

// TosUrlsIsNil applies the IsNil predicate on the "tos_urls" field.
func TosUrlsIsNil() predicate.Service {
	return predicate.Service(sql.FieldIsNull(FieldTosUrls))
}

// TosUrlsNotNil applies the NotNil predicate on the "tos_urls" field.
func TosUrlsNotNil() predicate.Service {
	return predicate.Service(sql.FieldNotNull(FieldTosUrls))
}

// OnionUrlsIsNil applies the IsNil predicate on the "onion_urls" field.
func OnionUrlsIsNil() predicate.Service {
	return predicate.Service(sql.FieldIsNull(FieldOnionUrls))
}

// OnionUrlsNotNil applies the NotNil predicate on the "onion_urls" field.
func OnionUrlsNotNil() predicate.Service {
	return predicate.Service(sql.FieldNotNull(FieldOnionUrls))
}

// CategoryEQ applies the EQ predicate on the "category" field.
func CategoryEQ(v string) predicate.Service {
	return predicate.Service(sql.FieldEQ(FieldCategory, v))
}

// CategoryNEQ applies the NEQ predicate on the "category" field.
func CategoryNEQ(v string) predicate.Service {
	return predicate.Service(sql.FieldNEQ(FieldCategory, v))
}

// CategoryIn applies the In predicate on the "category" field.
func CategoryIn(vs ...string) predicate.Service {
	return predicate.Service(sql.FieldIn(FieldCategory, vs...))
}

// CategoryNotIn applies the NotIn predicate on the "category" field.
func CategoryNotIn(vs ...string) predicate.Service {
	return predicate.Service(sql.FieldNotIn(FieldCategory, vs...))
}

// CategoryGT applies the GT predicate on the "category" field.
func CategoryGT(v string) predicate.Service {
	return predicate.Service(sql.FieldGT(FieldCategory, v))
}

// CategoryGTE applies the GTE predicate on the "category" field.
func CategoryGTE(v string) predicate.Service {
	return predicate.Service(sql.FieldGTE(FieldCategory, v))
}

// CategoryLT applies the LT predicate on the "category" field.
func CategoryLT(v string) predicate.Service {
	return predicate.Service(sql.FieldLT(FieldCategory, v))
}

// CategoryLTE applies the LTE predicate on the "category" field.
func CategoryLTE(v string) predicate.Service {
	return predicate.Service(sql.FieldLTE(FieldCategory, v))
}

// CategoryContains applies the Contains predicate on the "category" field.
func CategoryContains(v string) predicate.Service {
	return predicate.Service(sql.FieldContains(FieldCategory, v))
}

// CategoryHasPrefix applies the HasPrefix predicate on the "category" field.
func CategoryHasPrefix(v string) predicate.Service {
	return predicate.Service(sql.FieldHasPrefix(FieldCategory, v))
}

// CategoryHasSuffix applies the HasSuffix predicate on the "category" field.
func CategoryHasSuffix(v string) predicate.Service {
	return predicate.Service(sql.FieldHasSuffix(FieldCategory, v))
}

// CategoryIsNil applies the IsNil predicate on the "category" field.
func CategoryIsNil() predicate.Service {
	return predicate.Service(sql.FieldIsNull(FieldCategory))
}

// CategoryNotNil applies the NotNil predicate on the "category" field.
func CategoryNotNil() predicate.Service {
	return predicate.Service(sql.FieldNotNull(FieldCategory))
}

// CategoryEqualFold applies the EqualFold predicate on the "category" field.
func CategoryEqualFold(v string) predicate.Service {
	return predicate.Service(sql.FieldEqualFold(FieldCategory, v))
}

// CategoryContainsFold applies the ContainsFold predicate on the "category" field.
func CategoryContainsFold(v string) predicate.Service {
	return predicate.Service(sql.FieldContainsFold(FieldCategory, v))
}

// CommentsIsNil applies the IsNil predicate on the "comments" field.
func CommentsIsNil() predicate.Service {
	return predicate.Service(sql.FieldIsNull(FieldComments))
}

// CommentsNotNil applies the NotNil predicate on the "comments" field.
func CommentsNotNil() predicate.Service {
	return predicate.Service(sql.FieldNotNull(FieldComments))
}

// TosReviewsIsNil applies the IsNil predicate on the "tos_reviews" field.
func TosReviewsIsNil() predicate.Service {
	return predicate.Service(sql.FieldIsNull(FieldTosReviews))
}

// TosReviewsNotNil applies the NotNil predicate on the "tos_reviews" field.
func TosReviewsNotNil() predicate.Service {
	return predicate.Service(sql.FieldNotNull(FieldTosReviews))
}

// TagsIsNil applies the IsNil predicate on the "tags" field.
func TagsIsNil() predicate.Service {
	return predicate.Service(sql.FieldIsNull(FieldTags))
}

// TagsNotNil applies the NotNil predicate on the "tags" field.
func TagsNotNil() predicate.Service {
	return predicate.Service(sql.FieldNotNull(FieldTags))
}

// KycLevelEQ applies the EQ predicate on the "kyc_level" field.
func KycLevelEQ(v int) predicate.Service {
	return predicate.Service(sql.FieldEQ(FieldKycLevel, v))
}

// KycLevelNEQ applies the NEQ predicate on the "kyc_level" field.
func KycLevelNEQ(v int) predicate.Service {
	return predicate.Service(sql.FieldNEQ(FieldKycLevel, v))
}

// KycLevelIn applies the In predicate on the "kyc_level" field.
func KycLevelIn(vs ...int) predicate.Service {
	return predicate.Service(sql.FieldIn(FieldKycLevel, vs...))
}

// KycLevelNotIn applies the NotIn predicate on the "kyc_level" field.
func KycLevelNotIn(vs ...int) predicate.Service {
	return predicate.Service(sql.FieldNotIn(FieldKycLevel, vs...))
}

// KycLevelGT applies the GT predicate on the "kyc_level" field.
func KycLevelGT(v int) predicate.Service {
	return predicate.Service(sql.FieldGT(FieldKycLevel, v))
}

// KycLevelGTE applies the GTE predicate on the "kyc_level" field.
func KycLevelGTE(v int) predicate.Service {
	return predicate.Service(sql.FieldGTE(FieldKycLevel, v))
}

// KycLevelLT applies the LT predicate on the "kyc_level" field.
func KycLevelLT(v int) predicate.Service {
	return predicate.Service(sql.FieldLT(FieldKycLevel, v))
}

// KycLevelLTE applies the LTE predicate on the "kyc_level" field.
func KycLevelLTE(v int) predicate.Service {
	return predicate.Service(sql.FieldLTE(FieldKycLevel, v))
}

// KycLevelIsNil applies the IsNil predicate on the "kyc_level" field.
func KycLevelIsNil() predicate.Service {
	return predicate.Service(sql.FieldIsNull(FieldKycLevel))
}

// KycLevelNotNil applies the NotNil predicate on the "kyc_level" field.
func KycLevelNotNil() predicate.Service {
	return predicate.Service(sql.FieldNotNull(FieldKycLevel))
}

// TypeEQ applies the EQ predicate on the "type" field.
func TypeEQ(v Type) predicate.Service {
	return predicate.Service(sql.FieldEQ(FieldType, v))
}

// TypeNEQ applies the NEQ predicate on the "type" field.
func TypeNEQ(v Type) predicate.Service {
	return predicate.Service(sql.FieldNEQ(FieldType, v))
}

// TypeIn applies the In predicate on the "type" field.
func TypeIn(vs ...Type) predicate.Service {
	return predicate.Service(sql.FieldIn(FieldType, vs...))
}

// TypeNotIn applies the NotIn predicate on the "type" field.
func TypeNotIn(vs ...Type) predicate.Service {
	return predicate.Service(sql.FieldNotIn(FieldType, vs...))
}

// ListedEQ applies the EQ predicate on the "listed" field.
func ListedEQ(v bool) predicate.Service {
	return predicate.Service(sql.FieldEQ(FieldListed, v))
}

// ListedNEQ applies the NEQ predicate on the "listed" field.
func ListedNEQ(v bool) predicate.Service {
	return predicate.Service(sql.FieldNEQ(FieldListed, v))
}

// VerifiedEQ applies the EQ predicate on the "verified" field.
func VerifiedEQ(v bool) predicate.Service {
	return predicate.Service(sql.FieldEQ(FieldVerified, v))
}

// VerifiedNEQ applies the NEQ predicate on the "verified" field.
func VerifiedNEQ(v bool) predicate.Service {
	return predicate.Service(sql.FieldNEQ(FieldVerified, v))
}

// PendingEQ applies the EQ predicate on the "pending" field.
func PendingEQ(v bool) predicate.Service {
	return predicate.Service(sql.FieldEQ(FieldPending, v))
}

// PendingNEQ applies the NEQ predicate on the "pending" field.
func PendingNEQ(v bool) predicate.Service {
	return predicate.Service(sql.FieldNEQ(FieldPending, v))
}

// XmrEQ applies the EQ predicate on the "xmr" field.
func XmrEQ(v bool) predicate.Service {
	return predicate.Service(sql.FieldEQ(FieldXmr, v))
}

// XmrNEQ applies the NEQ predicate on the "xmr" field.
func XmrNEQ(v bool) predicate.Service {
	return predicate.Service(sql.FieldNEQ(FieldXmr, v))
}

// BtcEQ applies the EQ predicate on the "btc" field.
func BtcEQ(v bool) predicate.Service {
	return predicate.Service(sql.FieldEQ(FieldBtc, v))
}

// BtcNEQ applies the NEQ predicate on the "btc" field.
func BtcNEQ(v bool) predicate.Service {
	return predicate.Service(sql.FieldNEQ(FieldBtc, v))
}

// LightningEQ applies the EQ predicate on the "lightning" field.
func LightningEQ(v bool) predicate.Service {
	return predicate.Service(sql.FieldEQ(FieldLightning, v))
}

// LightningNEQ applies the NEQ predicate on the "lightning" field.
func LightningNEQ(v bool) predicate.Service {
	return predicate.Service(sql.FieldNEQ(FieldLightning, v))
}

// CashEQ applies the EQ predicate on the "cash" field.
func CashEQ(v bool) predicate.Service {
	return predicate.Service(sql.FieldEQ(FieldCash, v))
}

// CashNEQ applies the NEQ predicate on the "cash" field.
func CashNEQ(v bool) predicate.Service {
	return predicate.Service(sql.FieldNEQ(FieldCash, v))
}

// FiatEQ applies the EQ predicate on the "fiat" field.
func FiatEQ(v bool) predicate.Service {
	return predicate.Service(sql.FieldEQ(FieldFiat, v))
}

// FiatNEQ applies the NEQ predicate on the "fiat" field.
func FiatNEQ(v bool) predicate.Service {
	return predicate.Service(sql.FieldNEQ(FieldFiat, v))
}

// LastTosReviewEQ applies the EQ predicate on the "last_tos_review" field.
func LastTosReviewEQ(v time.Time) predicate.Service {
	return predicate.Service(sql.FieldEQ(FieldLastTosReview, v))
}

// LastTosReviewNEQ applies the NEQ predicate on the "last_tos_review" field.
func LastTosReviewNEQ(v time.Time) predicate.Service {
	return predicate.Service(sql.FieldNEQ(FieldLastTosReview, v))
}

// LastTosReviewIn applies the In predicate on the "last_tos_review" field.
func LastTosReviewIn(vs ...time.Time) predicate.Service {
	return predicate.Service(sql.FieldIn(FieldLastTosReview, vs...))
}

// LastTosReviewNotIn applies the NotIn predicate on the "last_tos_review" field.
func LastTosReviewNotIn(vs ...time.Time) predicate.Service {
	return predicate.Service(sql.FieldNotIn(FieldLastTosReview, vs...))
}

// LastTosReviewGT applies the GT predicate on the "last_tos_review" field.
func LastTosReviewGT(v time.Time) predicate.Service {
	return predicate.Service(sql.FieldGT(FieldLastTosReview, v))
}

// LastTosReviewGTE applies the GTE predicate on the "last_tos_review" field.
func LastTosReviewGTE(v time.Time) predicate.Service {
	return predicate.Service(sql.FieldGTE(FieldLastTosReview, v))
}

// LastTosReviewLT applies the LT predicate on the "last_tos_review" field.
func LastTosReviewLT(v time.Time) predicate.Service {
	return predicate.Service(sql.FieldLT(FieldLastTosReview, v))
}

// LastTosReviewLTE applies the LTE predicate on the "last_tos_review" field.
func LastTosReviewLTE(v time.Time) predicate.Service {
	return predicate.Service(sql.FieldLTE(FieldLastTosReview, v))
}

// LastTosReviewIsNil applies the IsNil predicate on the "last_tos_review" field.
func LastTosReviewIsNil() predicate.Service {
	return predicate.Service(sql.FieldIsNull(FieldLastTosReview))
}

// LastTosReviewNotNil applies the NotNil predicate on the "last_tos_review" field.
func LastTosReviewNotNil() predicate.Service {
	return predicate.Service(sql.FieldNotNull(FieldLastTosReview))
}

// ReferralEQ applies the EQ predicate on the "referral" field.
func ReferralEQ(v string) predicate.Service {
	return predicate.Service(sql.FieldEQ(FieldReferral, v))
}

// ReferralNEQ applies the NEQ predicate on the "referral" field.
func ReferralNEQ(v string) predicate.Service {
	return predicate.Service(sql.FieldNEQ(FieldReferral, v))
}

// ReferralIn applies the In predicate on the "referral" field.
func ReferralIn(vs ...string) predicate.Service {
	return predicate.Service(sql.FieldIn(FieldReferral, vs...))
}

// ReferralNotIn applies the NotIn predicate on the "referral" field.
func ReferralNotIn(vs ...string) predicate.Service {
	return predicate.Service(sql.FieldNotIn(FieldReferral, vs...))
}

// ReferralGT applies the GT predicate on the "referral" field.
func ReferralGT(v string) predicate.Service {
	return predicate.Service(sql.FieldGT(FieldReferral, v))
}

// ReferralGTE applies the GTE predicate on the "referral" field.
func ReferralGTE(v string) predicate.Service {
	return predicate.Service(sql.FieldGTE(FieldReferral, v))
}

// ReferralLT applies the LT predicate on the "referral" field.
func ReferralLT(v string) predicate.Service {
	return predicate.Service(sql.FieldLT(FieldReferral, v))
}

// ReferralLTE applies the LTE predicate on the "referral" field.
func ReferralLTE(v string) predicate.Service {
	return predicate.Service(sql.FieldLTE(FieldReferral, v))
}

// ReferralContains applies the Contains predicate on the "referral" field.
func ReferralContains(v string) predicate.Service {
	return predicate.Service(sql.FieldContains(FieldReferral, v))
}

// ReferralHasPrefix applies the HasPrefix predicate on the "referral" field.
func ReferralHasPrefix(v string) predicate.Service {
	return predicate.Service(sql.FieldHasPrefix(FieldReferral, v))
}

// ReferralHasSuffix applies the HasSuffix predicate on the "referral" field.
func ReferralHasSuffix(v string) predicate.Service {
	return predicate.Service(sql.FieldHasSuffix(FieldReferral, v))
}

// ReferralIsNil applies the IsNil predicate on the "referral" field.
func ReferralIsNil() predicate.Service {
	return predicate.Service(sql.FieldIsNull(FieldReferral))
}

// ReferralNotNil applies the NotNil predicate on the "referral" field.
func ReferralNotNil() predicate.Service {
	return predicate.Service(sql.FieldNotNull(FieldReferral))
}

// ReferralEqualFold applies the EqualFold predicate on the "referral" field.
func ReferralEqualFold(v string) predicate.Service {
	return predicate.Service(sql.FieldEqualFold(FieldReferral, v))
}

// ReferralContainsFold applies the ContainsFold predicate on the "referral" field.
func ReferralContainsFold(v string) predicate.Service {
	return predicate.Service(sql.FieldContainsFold(FieldReferral, v))
}

// ScoreEQ applies the EQ predicate on the "score" field.
func ScoreEQ(v int) predicate.Service {
	return predicate.Service(sql.FieldEQ(FieldScore, v))
}

// ScoreNEQ applies the NEQ predicate on the "score" field.
func ScoreNEQ(v int) predicate.Service {
	return predicate.Service(sql.FieldNEQ(FieldScore, v))
}

// ScoreIn applies the In predicate on the "score" field.
func ScoreIn(vs ...int) predicate.Service {
	return predicate.Service(sql.FieldIn(FieldScore, vs...))
}

// ScoreNotIn applies the NotIn predicate on the "score" field.
func ScoreNotIn(vs ...int) predicate.Service {
	return predicate.Service(sql.FieldNotIn(FieldScore, vs...))
}

// ScoreGT applies the GT predicate on the "score" field.
func ScoreGT(v int) predicate.Service {
	return predicate.Service(sql.FieldGT(FieldScore, v))
}

// ScoreGTE applies the GTE predicate on the "score" field.
func ScoreGTE(v int) predicate.Service {
	return predicate.Service(sql.FieldGTE(FieldScore, v))
}

// ScoreLT applies the LT predicate on the "score" field.
func ScoreLT(v int) predicate.Service {
	return predicate.Service(sql.FieldLT(FieldScore, v))
}

// ScoreLTE applies the LTE predicate on the "score" field.
func ScoreLTE(v int) predicate.Service {
	return predicate.Service(sql.FieldLTE(FieldScore, v))
}

// ScoreIsNil applies the IsNil predicate on the "score" field.
func ScoreIsNil() predicate.Service {
	return predicate.Service(sql.FieldIsNull(FieldScore))
}

// ScoreNotNil applies the NotNil predicate on the "score" field.
func ScoreNotNil() predicate.Service {
	return predicate.Service(sql.FieldNotNull(FieldScore))
}

// PotentialScamEQ applies the EQ predicate on the "potential_scam" field.
func PotentialScamEQ(v bool) predicate.Service {
	return predicate.Service(sql.FieldEQ(FieldPotentialScam, v))
}

// PotentialScamNEQ applies the NEQ predicate on the "potential_scam" field.
func PotentialScamNEQ(v bool) predicate.Service {
	return predicate.Service(sql.FieldNEQ(FieldPotentialScam, v))
}

// NotesIsNil applies the IsNil predicate on the "notes" field.
func NotesIsNil() predicate.Service {
	return predicate.Service(sql.FieldIsNull(FieldNotes))
}

// NotesNotNil applies the NotNil predicate on the "notes" field.
func NotesNotNil() predicate.Service {
	return predicate.Service(sql.FieldNotNull(FieldNotes))
}

// SupportIsNil applies the IsNil predicate on the "support" field.
func SupportIsNil() predicate.Service {
	return predicate.Service(sql.FieldIsNull(FieldSupport))
}

// SupportNotNil applies the NotNil predicate on the "support" field.
func SupportNotNil() predicate.Service {
	return predicate.Service(sql.FieldNotNull(FieldSupport))
}

// HasAttributes applies the HasEdge predicate on the "attributes" edge.
func HasAttributes() predicate.Service {
	return predicate.Service(func(s *sql.Selector) {
		step := sqlgraph.NewStep(
			sqlgraph.From(Table, FieldID),
			sqlgraph.Edge(sqlgraph.M2M, false, AttributesTable, AttributesPrimaryKey...),
		)
		sqlgraph.HasNeighbors(s, step)
	})
}

// HasAttributesWith applies the HasEdge predicate on the "attributes" edge with a given conditions (other predicates).
func HasAttributesWith(preds ...predicate.Attribute) predicate.Service {
	return predicate.Service(func(s *sql.Selector) {
		step := newAttributesStep()
		sqlgraph.HasNeighborsWith(s, step, func(s *sql.Selector) {
			for _, p := range preds {
				p(s)
			}
		})
	})
}

// HasChanges applies the HasEdge predicate on the "changes" edge.
func HasChanges() predicate.Service {
	return predicate.Service(func(s *sql.Selector) {
		step := sqlgraph.NewStep(
			sqlgraph.From(Table, FieldID),
			sqlgraph.Edge(sqlgraph.O2M, false, ChangesTable, ChangesColumn),
		)
		sqlgraph.HasNeighbors(s, step)
	})
}

// HasChangesWith applies the HasEdge predicate on the "changes" edge with a given conditions (other predicates).
func HasChangesWith(preds ...predicate.Change) predicate.Service {
	return predicate.Service(func(s *sql.Selector) {
		step := newChangesStep()
		sqlgraph.HasNeighborsWith(s, step, func(s *sql.Selector) {
			for _, p := range preds {
				p(s)
			}
		})
	})
}

// And groups predicates with the AND operator between them.
func And(predicates ...predicate.Service) predicate.Service {
	return predicate.Service(sql.AndPredicates(predicates...))
}

// Or groups predicates with the OR operator between them.
func Or(predicates ...predicate.Service) predicate.Service {
	return predicate.Service(sql.OrPredicates(predicates...))
}

// Not applies the not operator on the given predicate.
func Not(p predicate.Service) predicate.Service {
	return predicate.Service(sql.NotPredicates(p))
}
