// Code generated by ent, DO NOT EDIT.

package ent

import (
	"context"
	"errors"
	"fmt"
	"time"

	"entgo.io/ent/dialect/sql/sqlgraph"
	"entgo.io/ent/schema/field"
	"kycnot.me/internal/ent/attribute"
	"kycnot.me/internal/ent/change"
	"kycnot.me/internal/ent/schema"
	"kycnot.me/internal/ent/service"
)

// ServiceCreate is the builder for creating a Service entity.
type ServiceCreate struct {
	config
	mutation *ServiceMutation
	hooks    []Hook
}

// SetCreatedAt sets the "createdAt" field.
func (sc *ServiceCreate) SetCreatedAt(t time.Time) *ServiceCreate {
	sc.mutation.SetCreatedAt(t)
	return sc
}

// SetNillableCreatedAt sets the "createdAt" field if the given value is not nil.
func (sc *ServiceCreate) SetNillableCreatedAt(t *time.Time) *ServiceCreate {
	if t != nil {
		sc.SetCreatedAt(*t)
	}
	return sc
}

// SetName sets the "name" field.
func (sc *ServiceCreate) SetName(s string) *ServiceCreate {
	sc.mutation.SetName(s)
	return sc
}

// SetSlug sets the "slug" field.
func (sc *ServiceCreate) SetSlug(s string) *ServiceCreate {
	sc.mutation.SetSlug(s)
	return sc
}

// SetDescription sets the "description" field.
func (sc *ServiceCreate) SetDescription(s string) *ServiceCreate {
	sc.mutation.SetDescription(s)
	return sc
}

// SetLogoURL sets the "logo_url" field.
func (sc *ServiceCreate) SetLogoURL(s string) *ServiceCreate {
	sc.mutation.SetLogoURL(s)
	return sc
}

// SetNillableLogoURL sets the "logo_url" field if the given value is not nil.
func (sc *ServiceCreate) SetNillableLogoURL(s *string) *ServiceCreate {
	if s != nil {
		sc.SetLogoURL(*s)
	}
	return sc
}

// SetTosUrls sets the "tos_urls" field.
func (sc *ServiceCreate) SetTosUrls(s []string) *ServiceCreate {
	sc.mutation.SetTosUrls(s)
	return sc
}

// SetOnionUrls sets the "onion_urls" field.
func (sc *ServiceCreate) SetOnionUrls(s []string) *ServiceCreate {
	sc.mutation.SetOnionUrls(s)
	return sc
}

// SetCategory sets the "category" field.
func (sc *ServiceCreate) SetCategory(s string) *ServiceCreate {
	sc.mutation.SetCategory(s)
	return sc
}

// SetNillableCategory sets the "category" field if the given value is not nil.
func (sc *ServiceCreate) SetNillableCategory(s *string) *ServiceCreate {
	if s != nil {
		sc.SetCategory(*s)
	}
	return sc
}

// SetComments sets the "comments" field.
func (sc *ServiceCreate) SetComments(s []string) *ServiceCreate {
	sc.mutation.SetComments(s)
	return sc
}

// SetTosReviews sets the "tos_reviews" field.
func (sc *ServiceCreate) SetTosReviews(sr []schema.TosReview) *ServiceCreate {
	sc.mutation.SetTosReviews(sr)
	return sc
}

// SetUrls sets the "urls" field.
func (sc *ServiceCreate) SetUrls(s []string) *ServiceCreate {
	sc.mutation.SetUrls(s)
	return sc
}

// SetTags sets the "tags" field.
func (sc *ServiceCreate) SetTags(s []string) *ServiceCreate {
	sc.mutation.SetTags(s)
	return sc
}

// SetKycLevel sets the "kyc_level" field.
func (sc *ServiceCreate) SetKycLevel(i int) *ServiceCreate {
	sc.mutation.SetKycLevel(i)
	return sc
}

// SetNillableKycLevel sets the "kyc_level" field if the given value is not nil.
func (sc *ServiceCreate) SetNillableKycLevel(i *int) *ServiceCreate {
	if i != nil {
		sc.SetKycLevel(*i)
	}
	return sc
}

// SetType sets the "type" field.
func (sc *ServiceCreate) SetType(s service.Type) *ServiceCreate {
	sc.mutation.SetType(s)
	return sc
}

// SetNillableType sets the "type" field if the given value is not nil.
func (sc *ServiceCreate) SetNillableType(s *service.Type) *ServiceCreate {
	if s != nil {
		sc.SetType(*s)
	}
	return sc
}

// SetListed sets the "listed" field.
func (sc *ServiceCreate) SetListed(b bool) *ServiceCreate {
	sc.mutation.SetListed(b)
	return sc
}

// SetNillableListed sets the "listed" field if the given value is not nil.
func (sc *ServiceCreate) SetNillableListed(b *bool) *ServiceCreate {
	if b != nil {
		sc.SetListed(*b)
	}
	return sc
}

// SetVerified sets the "verified" field.
func (sc *ServiceCreate) SetVerified(b bool) *ServiceCreate {
	sc.mutation.SetVerified(b)
	return sc
}

// SetNillableVerified sets the "verified" field if the given value is not nil.
func (sc *ServiceCreate) SetNillableVerified(b *bool) *ServiceCreate {
	if b != nil {
		sc.SetVerified(*b)
	}
	return sc
}

// SetPending sets the "pending" field.
func (sc *ServiceCreate) SetPending(b bool) *ServiceCreate {
	sc.mutation.SetPending(b)
	return sc
}

// SetNillablePending sets the "pending" field if the given value is not nil.
func (sc *ServiceCreate) SetNillablePending(b *bool) *ServiceCreate {
	if b != nil {
		sc.SetPending(*b)
	}
	return sc
}

// SetXmr sets the "xmr" field.
func (sc *ServiceCreate) SetXmr(b bool) *ServiceCreate {
	sc.mutation.SetXmr(b)
	return sc
}

// SetNillableXmr sets the "xmr" field if the given value is not nil.
func (sc *ServiceCreate) SetNillableXmr(b *bool) *ServiceCreate {
	if b != nil {
		sc.SetXmr(*b)
	}
	return sc
}

// SetBtc sets the "btc" field.
func (sc *ServiceCreate) SetBtc(b bool) *ServiceCreate {
	sc.mutation.SetBtc(b)
	return sc
}

// SetNillableBtc sets the "btc" field if the given value is not nil.
func (sc *ServiceCreate) SetNillableBtc(b *bool) *ServiceCreate {
	if b != nil {
		sc.SetBtc(*b)
	}
	return sc
}

// SetLightning sets the "lightning" field.
func (sc *ServiceCreate) SetLightning(b bool) *ServiceCreate {
	sc.mutation.SetLightning(b)
	return sc
}

// SetNillableLightning sets the "lightning" field if the given value is not nil.
func (sc *ServiceCreate) SetNillableLightning(b *bool) *ServiceCreate {
	if b != nil {
		sc.SetLightning(*b)
	}
	return sc
}

// SetCash sets the "cash" field.
func (sc *ServiceCreate) SetCash(b bool) *ServiceCreate {
	sc.mutation.SetCash(b)
	return sc
}

// SetNillableCash sets the "cash" field if the given value is not nil.
func (sc *ServiceCreate) SetNillableCash(b *bool) *ServiceCreate {
	if b != nil {
		sc.SetCash(*b)
	}
	return sc
}

// SetFiat sets the "fiat" field.
func (sc *ServiceCreate) SetFiat(b bool) *ServiceCreate {
	sc.mutation.SetFiat(b)
	return sc
}

// SetNillableFiat sets the "fiat" field if the given value is not nil.
func (sc *ServiceCreate) SetNillableFiat(b *bool) *ServiceCreate {
	if b != nil {
		sc.SetFiat(*b)
	}
	return sc
}

// SetLastTosReview sets the "last_tos_review" field.
func (sc *ServiceCreate) SetLastTosReview(t time.Time) *ServiceCreate {
	sc.mutation.SetLastTosReview(t)
	return sc
}

// SetNillableLastTosReview sets the "last_tos_review" field if the given value is not nil.
func (sc *ServiceCreate) SetNillableLastTosReview(t *time.Time) *ServiceCreate {
	if t != nil {
		sc.SetLastTosReview(*t)
	}
	return sc
}

// SetReferral sets the "referral" field.
func (sc *ServiceCreate) SetReferral(s string) *ServiceCreate {
	sc.mutation.SetReferral(s)
	return sc
}

// SetNillableReferral sets the "referral" field if the given value is not nil.
func (sc *ServiceCreate) SetNillableReferral(s *string) *ServiceCreate {
	if s != nil {
		sc.SetReferral(*s)
	}
	return sc
}

// SetScore sets the "score" field.
func (sc *ServiceCreate) SetScore(i int) *ServiceCreate {
	sc.mutation.SetScore(i)
	return sc
}

// SetNillableScore sets the "score" field if the given value is not nil.
func (sc *ServiceCreate) SetNillableScore(i *int) *ServiceCreate {
	if i != nil {
		sc.SetScore(*i)
	}
	return sc
}

// SetPotentialScam sets the "potential_scam" field.
func (sc *ServiceCreate) SetPotentialScam(b bool) *ServiceCreate {
	sc.mutation.SetPotentialScam(b)
	return sc
}

// SetNillablePotentialScam sets the "potential_scam" field if the given value is not nil.
func (sc *ServiceCreate) SetNillablePotentialScam(b *bool) *ServiceCreate {
	if b != nil {
		sc.SetPotentialScam(*b)
	}
	return sc
}

// SetNotes sets the "notes" field.
func (sc *ServiceCreate) SetNotes(s []string) *ServiceCreate {
	sc.mutation.SetNotes(s)
	return sc
}

// SetSupport sets the "support" field.
func (sc *ServiceCreate) SetSupport(sm []schema.SupportMethod) *ServiceCreate {
	sc.mutation.SetSupport(sm)
	return sc
}

// SetID sets the "id" field.
func (sc *ServiceCreate) SetID(s string) *ServiceCreate {
	sc.mutation.SetID(s)
	return sc
}

// SetNillableID sets the "id" field if the given value is not nil.
func (sc *ServiceCreate) SetNillableID(s *string) *ServiceCreate {
	if s != nil {
		sc.SetID(*s)
	}
	return sc
}

// AddAttributeIDs adds the "attributes" edge to the Attribute entity by IDs.
func (sc *ServiceCreate) AddAttributeIDs(ids ...string) *ServiceCreate {
	sc.mutation.AddAttributeIDs(ids...)
	return sc
}

// AddAttributes adds the "attributes" edges to the Attribute entity.
func (sc *ServiceCreate) AddAttributes(a ...*Attribute) *ServiceCreate {
	ids := make([]string, len(a))
	for i := range a {
		ids[i] = a[i].ID
	}
	return sc.AddAttributeIDs(ids...)
}

// AddChangeIDs adds the "changes" edge to the Change entity by IDs.
func (sc *ServiceCreate) AddChangeIDs(ids ...int) *ServiceCreate {
	sc.mutation.AddChangeIDs(ids...)
	return sc
}

// AddChanges adds the "changes" edges to the Change entity.
func (sc *ServiceCreate) AddChanges(c ...*Change) *ServiceCreate {
	ids := make([]int, len(c))
	for i := range c {
		ids[i] = c[i].ID
	}
	return sc.AddChangeIDs(ids...)
}

// Mutation returns the ServiceMutation object of the builder.
func (sc *ServiceCreate) Mutation() *ServiceMutation {
	return sc.mutation
}

// Save creates the Service in the database.
func (sc *ServiceCreate) Save(ctx context.Context) (*Service, error) {
	sc.defaults()
	return withHooks(ctx, sc.sqlSave, sc.mutation, sc.hooks)
}

// SaveX calls Save and panics if Save returns an error.
func (sc *ServiceCreate) SaveX(ctx context.Context) *Service {
	v, err := sc.Save(ctx)
	if err != nil {
		panic(err)
	}
	return v
}

// Exec executes the query.
func (sc *ServiceCreate) Exec(ctx context.Context) error {
	_, err := sc.Save(ctx)
	return err
}

// ExecX is like Exec, but panics if an error occurs.
func (sc *ServiceCreate) ExecX(ctx context.Context) {
	if err := sc.Exec(ctx); err != nil {
		panic(err)
	}
}

// defaults sets the default values of the builder before save.
func (sc *ServiceCreate) defaults() {
	if _, ok := sc.mutation.CreatedAt(); !ok {
		v := service.DefaultCreatedAt()
		sc.mutation.SetCreatedAt(v)
	}
	if _, ok := sc.mutation.GetType(); !ok {
		v := service.DefaultType
		sc.mutation.SetType(v)
	}
	if _, ok := sc.mutation.Listed(); !ok {
		v := service.DefaultListed
		sc.mutation.SetListed(v)
	}
	if _, ok := sc.mutation.Verified(); !ok {
		v := service.DefaultVerified
		sc.mutation.SetVerified(v)
	}
	if _, ok := sc.mutation.Pending(); !ok {
		v := service.DefaultPending
		sc.mutation.SetPending(v)
	}
	if _, ok := sc.mutation.Xmr(); !ok {
		v := service.DefaultXmr
		sc.mutation.SetXmr(v)
	}
	if _, ok := sc.mutation.Btc(); !ok {
		v := service.DefaultBtc
		sc.mutation.SetBtc(v)
	}
	if _, ok := sc.mutation.Lightning(); !ok {
		v := service.DefaultLightning
		sc.mutation.SetLightning(v)
	}
	if _, ok := sc.mutation.Cash(); !ok {
		v := service.DefaultCash
		sc.mutation.SetCash(v)
	}
	if _, ok := sc.mutation.Fiat(); !ok {
		v := service.DefaultFiat
		sc.mutation.SetFiat(v)
	}
	if _, ok := sc.mutation.PotentialScam(); !ok {
		v := service.DefaultPotentialScam
		sc.mutation.SetPotentialScam(v)
	}
	if _, ok := sc.mutation.ID(); !ok {
		v := service.DefaultID()
		sc.mutation.SetID(v)
	}
}

// check runs all checks and user-defined validators on the builder.
func (sc *ServiceCreate) check() error {
	if _, ok := sc.mutation.CreatedAt(); !ok {
		return &ValidationError{Name: "createdAt", err: errors.New(`ent: missing required field "Service.createdAt"`)}
	}
	if _, ok := sc.mutation.Name(); !ok {
		return &ValidationError{Name: "name", err: errors.New(`ent: missing required field "Service.name"`)}
	}
	if _, ok := sc.mutation.Slug(); !ok {
		return &ValidationError{Name: "slug", err: errors.New(`ent: missing required field "Service.slug"`)}
	}
	if v, ok := sc.mutation.Slug(); ok {
		if err := service.SlugValidator(v); err != nil {
			return &ValidationError{Name: "slug", err: fmt.Errorf(`ent: validator failed for field "Service.slug": %w`, err)}
		}
	}
	if _, ok := sc.mutation.Description(); !ok {
		return &ValidationError{Name: "description", err: errors.New(`ent: missing required field "Service.description"`)}
	}
	if v, ok := sc.mutation.Description(); ok {
		if err := service.DescriptionValidator(v); err != nil {
			return &ValidationError{Name: "description", err: fmt.Errorf(`ent: validator failed for field "Service.description": %w`, err)}
		}
	}
	if _, ok := sc.mutation.Urls(); !ok {
		return &ValidationError{Name: "urls", err: errors.New(`ent: missing required field "Service.urls"`)}
	}
	if v, ok := sc.mutation.KycLevel(); ok {
		if err := service.KycLevelValidator(v); err != nil {
			return &ValidationError{Name: "kyc_level", err: fmt.Errorf(`ent: validator failed for field "Service.kyc_level": %w`, err)}
		}
	}
	if _, ok := sc.mutation.GetType(); !ok {
		return &ValidationError{Name: "type", err: errors.New(`ent: missing required field "Service.type"`)}
	}
	if v, ok := sc.mutation.GetType(); ok {
		if err := service.TypeValidator(v); err != nil {
			return &ValidationError{Name: "type", err: fmt.Errorf(`ent: validator failed for field "Service.type": %w`, err)}
		}
	}
	if _, ok := sc.mutation.Listed(); !ok {
		return &ValidationError{Name: "listed", err: errors.New(`ent: missing required field "Service.listed"`)}
	}
	if _, ok := sc.mutation.Verified(); !ok {
		return &ValidationError{Name: "verified", err: errors.New(`ent: missing required field "Service.verified"`)}
	}
	if _, ok := sc.mutation.Pending(); !ok {
		return &ValidationError{Name: "pending", err: errors.New(`ent: missing required field "Service.pending"`)}
	}
	if _, ok := sc.mutation.Xmr(); !ok {
		return &ValidationError{Name: "xmr", err: errors.New(`ent: missing required field "Service.xmr"`)}
	}
	if _, ok := sc.mutation.Btc(); !ok {
		return &ValidationError{Name: "btc", err: errors.New(`ent: missing required field "Service.btc"`)}
	}
	if _, ok := sc.mutation.Lightning(); !ok {
		return &ValidationError{Name: "lightning", err: errors.New(`ent: missing required field "Service.lightning"`)}
	}
	if _, ok := sc.mutation.Cash(); !ok {
		return &ValidationError{Name: "cash", err: errors.New(`ent: missing required field "Service.cash"`)}
	}
	if _, ok := sc.mutation.Fiat(); !ok {
		return &ValidationError{Name: "fiat", err: errors.New(`ent: missing required field "Service.fiat"`)}
	}
	if v, ok := sc.mutation.Score(); ok {
		if err := service.ScoreValidator(v); err != nil {
			return &ValidationError{Name: "score", err: fmt.Errorf(`ent: validator failed for field "Service.score": %w`, err)}
		}
	}
	if _, ok := sc.mutation.PotentialScam(); !ok {
		return &ValidationError{Name: "potential_scam", err: errors.New(`ent: missing required field "Service.potential_scam"`)}
	}
	return nil
}

func (sc *ServiceCreate) sqlSave(ctx context.Context) (*Service, error) {
	if err := sc.check(); err != nil {
		return nil, err
	}
	_node, _spec := sc.createSpec()
	if err := sqlgraph.CreateNode(ctx, sc.driver, _spec); err != nil {
		if sqlgraph.IsConstraintError(err) {
			err = &ConstraintError{msg: err.Error(), wrap: err}
		}
		return nil, err
	}
	if _spec.ID.Value != nil {
		if id, ok := _spec.ID.Value.(string); ok {
			_node.ID = id
		} else {
			return nil, fmt.Errorf("unexpected Service.ID type: %T", _spec.ID.Value)
		}
	}
	sc.mutation.id = &_node.ID
	sc.mutation.done = true
	return _node, nil
}

func (sc *ServiceCreate) createSpec() (*Service, *sqlgraph.CreateSpec) {
	var (
		_node = &Service{config: sc.config}
		_spec = sqlgraph.NewCreateSpec(service.Table, sqlgraph.NewFieldSpec(service.FieldID, field.TypeString))
	)
	if id, ok := sc.mutation.ID(); ok {
		_node.ID = id
		_spec.ID.Value = id
	}
	if value, ok := sc.mutation.CreatedAt(); ok {
		_spec.SetField(service.FieldCreatedAt, field.TypeTime, value)
		_node.CreatedAt = value
	}
	if value, ok := sc.mutation.Name(); ok {
		_spec.SetField(service.FieldName, field.TypeString, value)
		_node.Name = value
	}
	if value, ok := sc.mutation.Slug(); ok {
		_spec.SetField(service.FieldSlug, field.TypeString, value)
		_node.Slug = value
	}
	if value, ok := sc.mutation.Description(); ok {
		_spec.SetField(service.FieldDescription, field.TypeString, value)
		_node.Description = value
	}
	if value, ok := sc.mutation.LogoURL(); ok {
		_spec.SetField(service.FieldLogoURL, field.TypeString, value)
		_node.LogoURL = value
	}
	if value, ok := sc.mutation.TosUrls(); ok {
		_spec.SetField(service.FieldTosUrls, field.TypeJSON, value)
		_node.TosUrls = value
	}
	if value, ok := sc.mutation.OnionUrls(); ok {
		_spec.SetField(service.FieldOnionUrls, field.TypeJSON, value)
		_node.OnionUrls = value
	}
	if value, ok := sc.mutation.Category(); ok {
		_spec.SetField(service.FieldCategory, field.TypeString, value)
		_node.Category = value
	}
	if value, ok := sc.mutation.Comments(); ok {
		_spec.SetField(service.FieldComments, field.TypeJSON, value)
		_node.Comments = value
	}
	if value, ok := sc.mutation.TosReviews(); ok {
		_spec.SetField(service.FieldTosReviews, field.TypeJSON, value)
		_node.TosReviews = value
	}
	if value, ok := sc.mutation.Urls(); ok {
		_spec.SetField(service.FieldUrls, field.TypeJSON, value)
		_node.Urls = value
	}
	if value, ok := sc.mutation.Tags(); ok {
		_spec.SetField(service.FieldTags, field.TypeJSON, value)
		_node.Tags = value
	}
	if value, ok := sc.mutation.KycLevel(); ok {
		_spec.SetField(service.FieldKycLevel, field.TypeInt, value)
		_node.KycLevel = value
	}
	if value, ok := sc.mutation.GetType(); ok {
		_spec.SetField(service.FieldType, field.TypeEnum, value)
		_node.Type = value
	}
	if value, ok := sc.mutation.Listed(); ok {
		_spec.SetField(service.FieldListed, field.TypeBool, value)
		_node.Listed = value
	}
	if value, ok := sc.mutation.Verified(); ok {
		_spec.SetField(service.FieldVerified, field.TypeBool, value)
		_node.Verified = value
	}
	if value, ok := sc.mutation.Pending(); ok {
		_spec.SetField(service.FieldPending, field.TypeBool, value)
		_node.Pending = value
	}
	if value, ok := sc.mutation.Xmr(); ok {
		_spec.SetField(service.FieldXmr, field.TypeBool, value)
		_node.Xmr = value
	}
	if value, ok := sc.mutation.Btc(); ok {
		_spec.SetField(service.FieldBtc, field.TypeBool, value)
		_node.Btc = value
	}
	if value, ok := sc.mutation.Lightning(); ok {
		_spec.SetField(service.FieldLightning, field.TypeBool, value)
		_node.Lightning = value
	}
	if value, ok := sc.mutation.Cash(); ok {
		_spec.SetField(service.FieldCash, field.TypeBool, value)
		_node.Cash = value
	}
	if value, ok := sc.mutation.Fiat(); ok {
		_spec.SetField(service.FieldFiat, field.TypeBool, value)
		_node.Fiat = value
	}
	if value, ok := sc.mutation.LastTosReview(); ok {
		_spec.SetField(service.FieldLastTosReview, field.TypeTime, value)
		_node.LastTosReview = value
	}
	if value, ok := sc.mutation.Referral(); ok {
		_spec.SetField(service.FieldReferral, field.TypeString, value)
		_node.Referral = value
	}
	if value, ok := sc.mutation.Score(); ok {
		_spec.SetField(service.FieldScore, field.TypeInt, value)
		_node.Score = value
	}
	if value, ok := sc.mutation.PotentialScam(); ok {
		_spec.SetField(service.FieldPotentialScam, field.TypeBool, value)
		_node.PotentialScam = value
	}
	if value, ok := sc.mutation.Notes(); ok {
		_spec.SetField(service.FieldNotes, field.TypeJSON, value)
		_node.Notes = value
	}
	if value, ok := sc.mutation.Support(); ok {
		_spec.SetField(service.FieldSupport, field.TypeJSON, value)
		_node.Support = value
	}
	if nodes := sc.mutation.AttributesIDs(); len(nodes) > 0 {
		edge := &sqlgraph.EdgeSpec{
			Rel:     sqlgraph.M2M,
			Inverse: false,
			Table:   service.AttributesTable,
			Columns: service.AttributesPrimaryKey,
			Bidi:    false,
			Target: &sqlgraph.EdgeTarget{
				IDSpec: sqlgraph.NewFieldSpec(attribute.FieldID, field.TypeString),
			},
		}
		for _, k := range nodes {
			edge.Target.Nodes = append(edge.Target.Nodes, k)
		}
		_spec.Edges = append(_spec.Edges, edge)
	}
	if nodes := sc.mutation.ChangesIDs(); len(nodes) > 0 {
		edge := &sqlgraph.EdgeSpec{
			Rel:     sqlgraph.O2M,
			Inverse: false,
			Table:   service.ChangesTable,
			Columns: []string{service.ChangesColumn},
			Bidi:    false,
			Target: &sqlgraph.EdgeTarget{
				IDSpec: sqlgraph.NewFieldSpec(change.FieldID, field.TypeInt),
			},
		}
		for _, k := range nodes {
			edge.Target.Nodes = append(edge.Target.Nodes, k)
		}
		_spec.Edges = append(_spec.Edges, edge)
	}
	return _node, _spec
}

// ServiceCreateBulk is the builder for creating many Service entities in bulk.
type ServiceCreateBulk struct {
	config
	err      error
	builders []*ServiceCreate
}

// Save creates the Service entities in the database.
func (scb *ServiceCreateBulk) Save(ctx context.Context) ([]*Service, error) {
	if scb.err != nil {
		return nil, scb.err
	}
	specs := make([]*sqlgraph.CreateSpec, len(scb.builders))
	nodes := make([]*Service, len(scb.builders))
	mutators := make([]Mutator, len(scb.builders))
	for i := range scb.builders {
		func(i int, root context.Context) {
			builder := scb.builders[i]
			builder.defaults()
			var mut Mutator = MutateFunc(func(ctx context.Context, m Mutation) (Value, error) {
				mutation, ok := m.(*ServiceMutation)
				if !ok {
					return nil, fmt.Errorf("unexpected mutation type %T", m)
				}
				if err := builder.check(); err != nil {
					return nil, err
				}
				builder.mutation = mutation
				var err error
				nodes[i], specs[i] = builder.createSpec()
				if i < len(mutators)-1 {
					_, err = mutators[i+1].Mutate(root, scb.builders[i+1].mutation)
				} else {
					spec := &sqlgraph.BatchCreateSpec{Nodes: specs}
					// Invoke the actual operation on the latest mutation in the chain.
					if err = sqlgraph.BatchCreate(ctx, scb.driver, spec); err != nil {
						if sqlgraph.IsConstraintError(err) {
							err = &ConstraintError{msg: err.Error(), wrap: err}
						}
					}
				}
				if err != nil {
					return nil, err
				}
				mutation.id = &nodes[i].ID
				mutation.done = true
				return nodes[i], nil
			})
			for i := len(builder.hooks) - 1; i >= 0; i-- {
				mut = builder.hooks[i](mut)
			}
			mutators[i] = mut
		}(i, ctx)
	}
	if len(mutators) > 0 {
		if _, err := mutators[0].Mutate(ctx, scb.builders[0].mutation); err != nil {
			return nil, err
		}
	}
	return nodes, nil
}

// SaveX is like Save, but panics if an error occurs.
func (scb *ServiceCreateBulk) SaveX(ctx context.Context) []*Service {
	v, err := scb.Save(ctx)
	if err != nil {
		panic(err)
	}
	return v
}

// Exec executes the query.
func (scb *ServiceCreateBulk) Exec(ctx context.Context) error {
	_, err := scb.Save(ctx)
	return err
}

// ExecX is like Exec, but panics if an error occurs.
func (scb *ServiceCreateBulk) ExecX(ctx context.Context) {
	if err := scb.Exec(ctx); err != nil {
		panic(err)
	}
}
