// Code generated by ent, DO NOT EDIT.

package ent

import (
	"context"
	"errors"
	"fmt"
	"time"

	"entgo.io/ent/dialect/sql"
	"entgo.io/ent/dialect/sql/sqlgraph"
	"entgo.io/ent/dialect/sql/sqljson"
	"entgo.io/ent/schema/field"
	"kycnot.me/internal/ent/attribute"
	"kycnot.me/internal/ent/change"
	"kycnot.me/internal/ent/predicate"
	"kycnot.me/internal/ent/schema"
	"kycnot.me/internal/ent/service"
)

// ServiceUpdate is the builder for updating Service entities.
type ServiceUpdate struct {
	config
	hooks    []Hook
	mutation *ServiceMutation
}

// Where appends a list predicates to the ServiceUpdate builder.
func (su *ServiceUpdate) Where(ps ...predicate.Service) *ServiceUpdate {
	su.mutation.Where(ps...)
	return su
}

// SetCreatedAt sets the "createdAt" field.
func (su *ServiceUpdate) SetCreatedAt(t time.Time) *ServiceUpdate {
	su.mutation.SetCreatedAt(t)
	return su
}

// SetNillableCreatedAt sets the "createdAt" field if the given value is not nil.
func (su *ServiceUpdate) SetNillableCreatedAt(t *time.Time) *ServiceUpdate {
	if t != nil {
		su.SetCreatedAt(*t)
	}
	return su
}

// SetName sets the "name" field.
func (su *ServiceUpdate) SetName(s string) *ServiceUpdate {
	su.mutation.SetName(s)
	return su
}

// SetNillableName sets the "name" field if the given value is not nil.
func (su *ServiceUpdate) SetNillableName(s *string) *ServiceUpdate {
	if s != nil {
		su.SetName(*s)
	}
	return su
}

// SetSlug sets the "slug" field.
func (su *ServiceUpdate) SetSlug(s string) *ServiceUpdate {
	su.mutation.SetSlug(s)
	return su
}

// SetNillableSlug sets the "slug" field if the given value is not nil.
func (su *ServiceUpdate) SetNillableSlug(s *string) *ServiceUpdate {
	if s != nil {
		su.SetSlug(*s)
	}
	return su
}

// SetDescription sets the "description" field.
func (su *ServiceUpdate) SetDescription(s string) *ServiceUpdate {
	su.mutation.SetDescription(s)
	return su
}

// SetNillableDescription sets the "description" field if the given value is not nil.
func (su *ServiceUpdate) SetNillableDescription(s *string) *ServiceUpdate {
	if s != nil {
		su.SetDescription(*s)
	}
	return su
}

// SetLogoURL sets the "logo_url" field.
func (su *ServiceUpdate) SetLogoURL(s string) *ServiceUpdate {
	su.mutation.SetLogoURL(s)
	return su
}

// SetNillableLogoURL sets the "logo_url" field if the given value is not nil.
func (su *ServiceUpdate) SetNillableLogoURL(s *string) *ServiceUpdate {
	if s != nil {
		su.SetLogoURL(*s)
	}
	return su
}

// ClearLogoURL clears the value of the "logo_url" field.
func (su *ServiceUpdate) ClearLogoURL() *ServiceUpdate {
	su.mutation.ClearLogoURL()
	return su
}

// SetTosUrls sets the "tos_urls" field.
func (su *ServiceUpdate) SetTosUrls(s []string) *ServiceUpdate {
	su.mutation.SetTosUrls(s)
	return su
}

// AppendTosUrls appends s to the "tos_urls" field.
func (su *ServiceUpdate) AppendTosUrls(s []string) *ServiceUpdate {
	su.mutation.AppendTosUrls(s)
	return su
}

// ClearTosUrls clears the value of the "tos_urls" field.
func (su *ServiceUpdate) ClearTosUrls() *ServiceUpdate {
	su.mutation.ClearTosUrls()
	return su
}

// SetOnionUrls sets the "onion_urls" field.
func (su *ServiceUpdate) SetOnionUrls(s []string) *ServiceUpdate {
	su.mutation.SetOnionUrls(s)
	return su
}

// AppendOnionUrls appends s to the "onion_urls" field.
func (su *ServiceUpdate) AppendOnionUrls(s []string) *ServiceUpdate {
	su.mutation.AppendOnionUrls(s)
	return su
}

// ClearOnionUrls clears the value of the "onion_urls" field.
func (su *ServiceUpdate) ClearOnionUrls() *ServiceUpdate {
	su.mutation.ClearOnionUrls()
	return su
}

// SetCategory sets the "category" field.
func (su *ServiceUpdate) SetCategory(s string) *ServiceUpdate {
	su.mutation.SetCategory(s)
	return su
}

// SetNillableCategory sets the "category" field if the given value is not nil.
func (su *ServiceUpdate) SetNillableCategory(s *string) *ServiceUpdate {
	if s != nil {
		su.SetCategory(*s)
	}
	return su
}

// ClearCategory clears the value of the "category" field.
func (su *ServiceUpdate) ClearCategory() *ServiceUpdate {
	su.mutation.ClearCategory()
	return su
}

// SetComments sets the "comments" field.
func (su *ServiceUpdate) SetComments(s []string) *ServiceUpdate {
	su.mutation.SetComments(s)
	return su
}

// AppendComments appends s to the "comments" field.
func (su *ServiceUpdate) AppendComments(s []string) *ServiceUpdate {
	su.mutation.AppendComments(s)
	return su
}

// ClearComments clears the value of the "comments" field.
func (su *ServiceUpdate) ClearComments() *ServiceUpdate {
	su.mutation.ClearComments()
	return su
}

// SetTosReviews sets the "tos_reviews" field.
func (su *ServiceUpdate) SetTosReviews(sr []schema.TosReview) *ServiceUpdate {
	su.mutation.SetTosReviews(sr)
	return su
}

// AppendTosReviews appends sr to the "tos_reviews" field.
func (su *ServiceUpdate) AppendTosReviews(sr []schema.TosReview) *ServiceUpdate {
	su.mutation.AppendTosReviews(sr)
	return su
}

// ClearTosReviews clears the value of the "tos_reviews" field.
func (su *ServiceUpdate) ClearTosReviews() *ServiceUpdate {
	su.mutation.ClearTosReviews()
	return su
}

// SetUrls sets the "urls" field.
func (su *ServiceUpdate) SetUrls(s []string) *ServiceUpdate {
	su.mutation.SetUrls(s)
	return su
}

// AppendUrls appends s to the "urls" field.
func (su *ServiceUpdate) AppendUrls(s []string) *ServiceUpdate {
	su.mutation.AppendUrls(s)
	return su
}

// SetTags sets the "tags" field.
func (su *ServiceUpdate) SetTags(s []string) *ServiceUpdate {
	su.mutation.SetTags(s)
	return su
}

// AppendTags appends s to the "tags" field.
func (su *ServiceUpdate) AppendTags(s []string) *ServiceUpdate {
	su.mutation.AppendTags(s)
	return su
}

// ClearTags clears the value of the "tags" field.
func (su *ServiceUpdate) ClearTags() *ServiceUpdate {
	su.mutation.ClearTags()
	return su
}

// SetKycLevel sets the "kyc_level" field.
func (su *ServiceUpdate) SetKycLevel(i int) *ServiceUpdate {
	su.mutation.ResetKycLevel()
	su.mutation.SetKycLevel(i)
	return su
}

// SetNillableKycLevel sets the "kyc_level" field if the given value is not nil.
func (su *ServiceUpdate) SetNillableKycLevel(i *int) *ServiceUpdate {
	if i != nil {
		su.SetKycLevel(*i)
	}
	return su
}

// AddKycLevel adds i to the "kyc_level" field.
func (su *ServiceUpdate) AddKycLevel(i int) *ServiceUpdate {
	su.mutation.AddKycLevel(i)
	return su
}

// ClearKycLevel clears the value of the "kyc_level" field.
func (su *ServiceUpdate) ClearKycLevel() *ServiceUpdate {
	su.mutation.ClearKycLevel()
	return su
}

// SetType sets the "type" field.
func (su *ServiceUpdate) SetType(s service.Type) *ServiceUpdate {
	su.mutation.SetType(s)
	return su
}

// SetNillableType sets the "type" field if the given value is not nil.
func (su *ServiceUpdate) SetNillableType(s *service.Type) *ServiceUpdate {
	if s != nil {
		su.SetType(*s)
	}
	return su
}

// SetListed sets the "listed" field.
func (su *ServiceUpdate) SetListed(b bool) *ServiceUpdate {
	su.mutation.SetListed(b)
	return su
}

// SetNillableListed sets the "listed" field if the given value is not nil.
func (su *ServiceUpdate) SetNillableListed(b *bool) *ServiceUpdate {
	if b != nil {
		su.SetListed(*b)
	}
	return su
}

// SetVerified sets the "verified" field.
func (su *ServiceUpdate) SetVerified(b bool) *ServiceUpdate {
	su.mutation.SetVerified(b)
	return su
}

// SetNillableVerified sets the "verified" field if the given value is not nil.
func (su *ServiceUpdate) SetNillableVerified(b *bool) *ServiceUpdate {
	if b != nil {
		su.SetVerified(*b)
	}
	return su
}

// SetPending sets the "pending" field.
func (su *ServiceUpdate) SetPending(b bool) *ServiceUpdate {
	su.mutation.SetPending(b)
	return su
}

// SetNillablePending sets the "pending" field if the given value is not nil.
func (su *ServiceUpdate) SetNillablePending(b *bool) *ServiceUpdate {
	if b != nil {
		su.SetPending(*b)
	}
	return su
}

// SetXmr sets the "xmr" field.
func (su *ServiceUpdate) SetXmr(b bool) *ServiceUpdate {
	su.mutation.SetXmr(b)
	return su
}

// SetNillableXmr sets the "xmr" field if the given value is not nil.
func (su *ServiceUpdate) SetNillableXmr(b *bool) *ServiceUpdate {
	if b != nil {
		su.SetXmr(*b)
	}
	return su
}

// SetBtc sets the "btc" field.
func (su *ServiceUpdate) SetBtc(b bool) *ServiceUpdate {
	su.mutation.SetBtc(b)
	return su
}

// SetNillableBtc sets the "btc" field if the given value is not nil.
func (su *ServiceUpdate) SetNillableBtc(b *bool) *ServiceUpdate {
	if b != nil {
		su.SetBtc(*b)
	}
	return su
}

// SetLightning sets the "lightning" field.
func (su *ServiceUpdate) SetLightning(b bool) *ServiceUpdate {
	su.mutation.SetLightning(b)
	return su
}

// SetNillableLightning sets the "lightning" field if the given value is not nil.
func (su *ServiceUpdate) SetNillableLightning(b *bool) *ServiceUpdate {
	if b != nil {
		su.SetLightning(*b)
	}
	return su
}

// SetCash sets the "cash" field.
func (su *ServiceUpdate) SetCash(b bool) *ServiceUpdate {
	su.mutation.SetCash(b)
	return su
}

// SetNillableCash sets the "cash" field if the given value is not nil.
func (su *ServiceUpdate) SetNillableCash(b *bool) *ServiceUpdate {
	if b != nil {
		su.SetCash(*b)
	}
	return su
}

// SetFiat sets the "fiat" field.
func (su *ServiceUpdate) SetFiat(b bool) *ServiceUpdate {
	su.mutation.SetFiat(b)
	return su
}

// SetNillableFiat sets the "fiat" field if the given value is not nil.
func (su *ServiceUpdate) SetNillableFiat(b *bool) *ServiceUpdate {
	if b != nil {
		su.SetFiat(*b)
	}
	return su
}

// SetLastTosReview sets the "last_tos_review" field.
func (su *ServiceUpdate) SetLastTosReview(t time.Time) *ServiceUpdate {
	su.mutation.SetLastTosReview(t)
	return su
}

// SetNillableLastTosReview sets the "last_tos_review" field if the given value is not nil.
func (su *ServiceUpdate) SetNillableLastTosReview(t *time.Time) *ServiceUpdate {
	if t != nil {
		su.SetLastTosReview(*t)
	}
	return su
}

// ClearLastTosReview clears the value of the "last_tos_review" field.
func (su *ServiceUpdate) ClearLastTosReview() *ServiceUpdate {
	su.mutation.ClearLastTosReview()
	return su
}

// SetReferral sets the "referral" field.
func (su *ServiceUpdate) SetReferral(s string) *ServiceUpdate {
	su.mutation.SetReferral(s)
	return su
}

// SetNillableReferral sets the "referral" field if the given value is not nil.
func (su *ServiceUpdate) SetNillableReferral(s *string) *ServiceUpdate {
	if s != nil {
		su.SetReferral(*s)
	}
	return su
}

// ClearReferral clears the value of the "referral" field.
func (su *ServiceUpdate) ClearReferral() *ServiceUpdate {
	su.mutation.ClearReferral()
	return su
}

// SetScore sets the "score" field.
func (su *ServiceUpdate) SetScore(i int) *ServiceUpdate {
	su.mutation.ResetScore()
	su.mutation.SetScore(i)
	return su
}

// SetNillableScore sets the "score" field if the given value is not nil.
func (su *ServiceUpdate) SetNillableScore(i *int) *ServiceUpdate {
	if i != nil {
		su.SetScore(*i)
	}
	return su
}

// AddScore adds i to the "score" field.
func (su *ServiceUpdate) AddScore(i int) *ServiceUpdate {
	su.mutation.AddScore(i)
	return su
}

// ClearScore clears the value of the "score" field.
func (su *ServiceUpdate) ClearScore() *ServiceUpdate {
	su.mutation.ClearScore()
	return su
}

// SetPotentialScam sets the "potential_scam" field.
func (su *ServiceUpdate) SetPotentialScam(b bool) *ServiceUpdate {
	su.mutation.SetPotentialScam(b)
	return su
}

// SetNillablePotentialScam sets the "potential_scam" field if the given value is not nil.
func (su *ServiceUpdate) SetNillablePotentialScam(b *bool) *ServiceUpdate {
	if b != nil {
		su.SetPotentialScam(*b)
	}
	return su
}

// SetNotes sets the "notes" field.
func (su *ServiceUpdate) SetNotes(s []string) *ServiceUpdate {
	su.mutation.SetNotes(s)
	return su
}

// AppendNotes appends s to the "notes" field.
func (su *ServiceUpdate) AppendNotes(s []string) *ServiceUpdate {
	su.mutation.AppendNotes(s)
	return su
}

// ClearNotes clears the value of the "notes" field.
func (su *ServiceUpdate) ClearNotes() *ServiceUpdate {
	su.mutation.ClearNotes()
	return su
}

// SetSupport sets the "support" field.
func (su *ServiceUpdate) SetSupport(sm []schema.SupportMethod) *ServiceUpdate {
	su.mutation.SetSupport(sm)
	return su
}

// AppendSupport appends sm to the "support" field.
func (su *ServiceUpdate) AppendSupport(sm []schema.SupportMethod) *ServiceUpdate {
	su.mutation.AppendSupport(sm)
	return su
}

// ClearSupport clears the value of the "support" field.
func (su *ServiceUpdate) ClearSupport() *ServiceUpdate {
	su.mutation.ClearSupport()
	return su
}

// AddAttributeIDs adds the "attributes" edge to the Attribute entity by IDs.
func (su *ServiceUpdate) AddAttributeIDs(ids ...string) *ServiceUpdate {
	su.mutation.AddAttributeIDs(ids...)
	return su
}

// AddAttributes adds the "attributes" edges to the Attribute entity.
func (su *ServiceUpdate) AddAttributes(a ...*Attribute) *ServiceUpdate {
	ids := make([]string, len(a))
	for i := range a {
		ids[i] = a[i].ID
	}
	return su.AddAttributeIDs(ids...)
}

// AddChangeIDs adds the "changes" edge to the Change entity by IDs.
func (su *ServiceUpdate) AddChangeIDs(ids ...int) *ServiceUpdate {
	su.mutation.AddChangeIDs(ids...)
	return su
}

// AddChanges adds the "changes" edges to the Change entity.
func (su *ServiceUpdate) AddChanges(c ...*Change) *ServiceUpdate {
	ids := make([]int, len(c))
	for i := range c {
		ids[i] = c[i].ID
	}
	return su.AddChangeIDs(ids...)
}

// Mutation returns the ServiceMutation object of the builder.
func (su *ServiceUpdate) Mutation() *ServiceMutation {
	return su.mutation
}

// ClearAttributes clears all "attributes" edges to the Attribute entity.
func (su *ServiceUpdate) ClearAttributes() *ServiceUpdate {
	su.mutation.ClearAttributes()
	return su
}

// RemoveAttributeIDs removes the "attributes" edge to Attribute entities by IDs.
func (su *ServiceUpdate) RemoveAttributeIDs(ids ...string) *ServiceUpdate {
	su.mutation.RemoveAttributeIDs(ids...)
	return su
}

// RemoveAttributes removes "attributes" edges to Attribute entities.
func (su *ServiceUpdate) RemoveAttributes(a ...*Attribute) *ServiceUpdate {
	ids := make([]string, len(a))
	for i := range a {
		ids[i] = a[i].ID
	}
	return su.RemoveAttributeIDs(ids...)
}

// ClearChanges clears all "changes" edges to the Change entity.
func (su *ServiceUpdate) ClearChanges() *ServiceUpdate {
	su.mutation.ClearChanges()
	return su
}

// RemoveChangeIDs removes the "changes" edge to Change entities by IDs.
func (su *ServiceUpdate) RemoveChangeIDs(ids ...int) *ServiceUpdate {
	su.mutation.RemoveChangeIDs(ids...)
	return su
}

// RemoveChanges removes "changes" edges to Change entities.
func (su *ServiceUpdate) RemoveChanges(c ...*Change) *ServiceUpdate {
	ids := make([]int, len(c))
	for i := range c {
		ids[i] = c[i].ID
	}
	return su.RemoveChangeIDs(ids...)
}

// Save executes the query and returns the number of nodes affected by the update operation.
func (su *ServiceUpdate) Save(ctx context.Context) (int, error) {
	return withHooks(ctx, su.sqlSave, su.mutation, su.hooks)
}

// SaveX is like Save, but panics if an error occurs.
func (su *ServiceUpdate) SaveX(ctx context.Context) int {
	affected, err := su.Save(ctx)
	if err != nil {
		panic(err)
	}
	return affected
}

// Exec executes the query.
func (su *ServiceUpdate) Exec(ctx context.Context) error {
	_, err := su.Save(ctx)
	return err
}

// ExecX is like Exec, but panics if an error occurs.
func (su *ServiceUpdate) ExecX(ctx context.Context) {
	if err := su.Exec(ctx); err != nil {
		panic(err)
	}
}

// check runs all checks and user-defined validators on the builder.
func (su *ServiceUpdate) check() error {
	if v, ok := su.mutation.Slug(); ok {
		if err := service.SlugValidator(v); err != nil {
			return &ValidationError{Name: "slug", err: fmt.Errorf(`ent: validator failed for field "Service.slug": %w`, err)}
		}
	}
	if v, ok := su.mutation.Description(); ok {
		if err := service.DescriptionValidator(v); err != nil {
			return &ValidationError{Name: "description", err: fmt.Errorf(`ent: validator failed for field "Service.description": %w`, err)}
		}
	}
	if v, ok := su.mutation.KycLevel(); ok {
		if err := service.KycLevelValidator(v); err != nil {
			return &ValidationError{Name: "kyc_level", err: fmt.Errorf(`ent: validator failed for field "Service.kyc_level": %w`, err)}
		}
	}
	if v, ok := su.mutation.GetType(); ok {
		if err := service.TypeValidator(v); err != nil {
			return &ValidationError{Name: "type", err: fmt.Errorf(`ent: validator failed for field "Service.type": %w`, err)}
		}
	}
	if v, ok := su.mutation.Score(); ok {
		if err := service.ScoreValidator(v); err != nil {
			return &ValidationError{Name: "score", err: fmt.Errorf(`ent: validator failed for field "Service.score": %w`, err)}
		}
	}
	return nil
}

func (su *ServiceUpdate) sqlSave(ctx context.Context) (n int, err error) {
	if err := su.check(); err != nil {
		return n, err
	}
	_spec := sqlgraph.NewUpdateSpec(service.Table, service.Columns, sqlgraph.NewFieldSpec(service.FieldID, field.TypeString))
	if ps := su.mutation.predicates; len(ps) > 0 {
		_spec.Predicate = func(selector *sql.Selector) {
			for i := range ps {
				ps[i](selector)
			}
		}
	}
	if value, ok := su.mutation.CreatedAt(); ok {
		_spec.SetField(service.FieldCreatedAt, field.TypeTime, value)
	}
	if value, ok := su.mutation.Name(); ok {
		_spec.SetField(service.FieldName, field.TypeString, value)
	}
	if value, ok := su.mutation.Slug(); ok {
		_spec.SetField(service.FieldSlug, field.TypeString, value)
	}
	if value, ok := su.mutation.Description(); ok {
		_spec.SetField(service.FieldDescription, field.TypeString, value)
	}
	if value, ok := su.mutation.LogoURL(); ok {
		_spec.SetField(service.FieldLogoURL, field.TypeString, value)
	}
	if su.mutation.LogoURLCleared() {
		_spec.ClearField(service.FieldLogoURL, field.TypeString)
	}
	if value, ok := su.mutation.TosUrls(); ok {
		_spec.SetField(service.FieldTosUrls, field.TypeJSON, value)
	}
	if value, ok := su.mutation.AppendedTosUrls(); ok {
		_spec.AddModifier(func(u *sql.UpdateBuilder) {
			sqljson.Append(u, service.FieldTosUrls, value)
		})
	}
	if su.mutation.TosUrlsCleared() {
		_spec.ClearField(service.FieldTosUrls, field.TypeJSON)
	}
	if value, ok := su.mutation.OnionUrls(); ok {
		_spec.SetField(service.FieldOnionUrls, field.TypeJSON, value)
	}
	if value, ok := su.mutation.AppendedOnionUrls(); ok {
		_spec.AddModifier(func(u *sql.UpdateBuilder) {
			sqljson.Append(u, service.FieldOnionUrls, value)
		})
	}
	if su.mutation.OnionUrlsCleared() {
		_spec.ClearField(service.FieldOnionUrls, field.TypeJSON)
	}
	if value, ok := su.mutation.Category(); ok {
		_spec.SetField(service.FieldCategory, field.TypeString, value)
	}
	if su.mutation.CategoryCleared() {
		_spec.ClearField(service.FieldCategory, field.TypeString)
	}
	if value, ok := su.mutation.Comments(); ok {
		_spec.SetField(service.FieldComments, field.TypeJSON, value)
	}
	if value, ok := su.mutation.AppendedComments(); ok {
		_spec.AddModifier(func(u *sql.UpdateBuilder) {
			sqljson.Append(u, service.FieldComments, value)
		})
	}
	if su.mutation.CommentsCleared() {
		_spec.ClearField(service.FieldComments, field.TypeJSON)
	}
	if value, ok := su.mutation.TosReviews(); ok {
		_spec.SetField(service.FieldTosReviews, field.TypeJSON, value)
	}
	if value, ok := su.mutation.AppendedTosReviews(); ok {
		_spec.AddModifier(func(u *sql.UpdateBuilder) {
			sqljson.Append(u, service.FieldTosReviews, value)
		})
	}
	if su.mutation.TosReviewsCleared() {
		_spec.ClearField(service.FieldTosReviews, field.TypeJSON)
	}
	if value, ok := su.mutation.Urls(); ok {
		_spec.SetField(service.FieldUrls, field.TypeJSON, value)
	}
	if value, ok := su.mutation.AppendedUrls(); ok {
		_spec.AddModifier(func(u *sql.UpdateBuilder) {
			sqljson.Append(u, service.FieldUrls, value)
		})
	}
	if value, ok := su.mutation.Tags(); ok {
		_spec.SetField(service.FieldTags, field.TypeJSON, value)
	}
	if value, ok := su.mutation.AppendedTags(); ok {
		_spec.AddModifier(func(u *sql.UpdateBuilder) {
			sqljson.Append(u, service.FieldTags, value)
		})
	}
	if su.mutation.TagsCleared() {
		_spec.ClearField(service.FieldTags, field.TypeJSON)
	}
	if value, ok := su.mutation.KycLevel(); ok {
		_spec.SetField(service.FieldKycLevel, field.TypeInt, value)
	}
	if value, ok := su.mutation.AddedKycLevel(); ok {
		_spec.AddField(service.FieldKycLevel, field.TypeInt, value)
	}
	if su.mutation.KycLevelCleared() {
		_spec.ClearField(service.FieldKycLevel, field.TypeInt)
	}
	if value, ok := su.mutation.GetType(); ok {
		_spec.SetField(service.FieldType, field.TypeEnum, value)
	}
	if value, ok := su.mutation.Listed(); ok {
		_spec.SetField(service.FieldListed, field.TypeBool, value)
	}
	if value, ok := su.mutation.Verified(); ok {
		_spec.SetField(service.FieldVerified, field.TypeBool, value)
	}
	if value, ok := su.mutation.Pending(); ok {
		_spec.SetField(service.FieldPending, field.TypeBool, value)
	}
	if value, ok := su.mutation.Xmr(); ok {
		_spec.SetField(service.FieldXmr, field.TypeBool, value)
	}
	if value, ok := su.mutation.Btc(); ok {
		_spec.SetField(service.FieldBtc, field.TypeBool, value)
	}
	if value, ok := su.mutation.Lightning(); ok {
		_spec.SetField(service.FieldLightning, field.TypeBool, value)
	}
	if value, ok := su.mutation.Cash(); ok {
		_spec.SetField(service.FieldCash, field.TypeBool, value)
	}
	if value, ok := su.mutation.Fiat(); ok {
		_spec.SetField(service.FieldFiat, field.TypeBool, value)
	}
	if value, ok := su.mutation.LastTosReview(); ok {
		_spec.SetField(service.FieldLastTosReview, field.TypeTime, value)
	}
	if su.mutation.LastTosReviewCleared() {
		_spec.ClearField(service.FieldLastTosReview, field.TypeTime)
	}
	if value, ok := su.mutation.Referral(); ok {
		_spec.SetField(service.FieldReferral, field.TypeString, value)
	}
	if su.mutation.ReferralCleared() {
		_spec.ClearField(service.FieldReferral, field.TypeString)
	}
	if value, ok := su.mutation.Score(); ok {
		_spec.SetField(service.FieldScore, field.TypeInt, value)
	}
	if value, ok := su.mutation.AddedScore(); ok {
		_spec.AddField(service.FieldScore, field.TypeInt, value)
	}
	if su.mutation.ScoreCleared() {
		_spec.ClearField(service.FieldScore, field.TypeInt)
	}
	if value, ok := su.mutation.PotentialScam(); ok {
		_spec.SetField(service.FieldPotentialScam, field.TypeBool, value)
	}
	if value, ok := su.mutation.Notes(); ok {
		_spec.SetField(service.FieldNotes, field.TypeJSON, value)
	}
	if value, ok := su.mutation.AppendedNotes(); ok {
		_spec.AddModifier(func(u *sql.UpdateBuilder) {
			sqljson.Append(u, service.FieldNotes, value)
		})
	}
	if su.mutation.NotesCleared() {
		_spec.ClearField(service.FieldNotes, field.TypeJSON)
	}
	if value, ok := su.mutation.Support(); ok {
		_spec.SetField(service.FieldSupport, field.TypeJSON, value)
	}
	if value, ok := su.mutation.AppendedSupport(); ok {
		_spec.AddModifier(func(u *sql.UpdateBuilder) {
			sqljson.Append(u, service.FieldSupport, value)
		})
	}
	if su.mutation.SupportCleared() {
		_spec.ClearField(service.FieldSupport, field.TypeJSON)
	}
	if su.mutation.AttributesCleared() {
		edge := &sqlgraph.EdgeSpec{
			Rel:     sqlgraph.M2M,
			Inverse: false,
			Table:   service.AttributesTable,
			Columns: service.AttributesPrimaryKey,
			Bidi:    false,
			Target: &sqlgraph.EdgeTarget{
				IDSpec: sqlgraph.NewFieldSpec(attribute.FieldID, field.TypeString),
			},
		}
		_spec.Edges.Clear = append(_spec.Edges.Clear, edge)
	}
	if nodes := su.mutation.RemovedAttributesIDs(); len(nodes) > 0 && !su.mutation.AttributesCleared() {
		edge := &sqlgraph.EdgeSpec{
			Rel:     sqlgraph.M2M,
			Inverse: false,
			Table:   service.AttributesTable,
			Columns: service.AttributesPrimaryKey,
			Bidi:    false,
			Target: &sqlgraph.EdgeTarget{
				IDSpec: sqlgraph.NewFieldSpec(attribute.FieldID, field.TypeString),
			},
		}
		for _, k := range nodes {
			edge.Target.Nodes = append(edge.Target.Nodes, k)
		}
		_spec.Edges.Clear = append(_spec.Edges.Clear, edge)
	}
	if nodes := su.mutation.AttributesIDs(); len(nodes) > 0 {
		edge := &sqlgraph.EdgeSpec{
			Rel:     sqlgraph.M2M,
			Inverse: false,
			Table:   service.AttributesTable,
			Columns: service.AttributesPrimaryKey,
			Bidi:    false,
			Target: &sqlgraph.EdgeTarget{
				IDSpec: sqlgraph.NewFieldSpec(attribute.FieldID, field.TypeString),
			},
		}
		for _, k := range nodes {
			edge.Target.Nodes = append(edge.Target.Nodes, k)
		}
		_spec.Edges.Add = append(_spec.Edges.Add, edge)
	}
	if su.mutation.ChangesCleared() {
		edge := &sqlgraph.EdgeSpec{
			Rel:     sqlgraph.O2M,
			Inverse: false,
			Table:   service.ChangesTable,
			Columns: []string{service.ChangesColumn},
			Bidi:    false,
			Target: &sqlgraph.EdgeTarget{
				IDSpec: sqlgraph.NewFieldSpec(change.FieldID, field.TypeInt),
			},
		}
		_spec.Edges.Clear = append(_spec.Edges.Clear, edge)
	}
	if nodes := su.mutation.RemovedChangesIDs(); len(nodes) > 0 && !su.mutation.ChangesCleared() {
		edge := &sqlgraph.EdgeSpec{
			Rel:     sqlgraph.O2M,
			Inverse: false,
			Table:   service.ChangesTable,
			Columns: []string{service.ChangesColumn},
			Bidi:    false,
			Target: &sqlgraph.EdgeTarget{
				IDSpec: sqlgraph.NewFieldSpec(change.FieldID, field.TypeInt),
			},
		}
		for _, k := range nodes {
			edge.Target.Nodes = append(edge.Target.Nodes, k)
		}
		_spec.Edges.Clear = append(_spec.Edges.Clear, edge)
	}
	if nodes := su.mutation.ChangesIDs(); len(nodes) > 0 {
		edge := &sqlgraph.EdgeSpec{
			Rel:     sqlgraph.O2M,
			Inverse: false,
			Table:   service.ChangesTable,
			Columns: []string{service.ChangesColumn},
			Bidi:    false,
			Target: &sqlgraph.EdgeTarget{
				IDSpec: sqlgraph.NewFieldSpec(change.FieldID, field.TypeInt),
			},
		}
		for _, k := range nodes {
			edge.Target.Nodes = append(edge.Target.Nodes, k)
		}
		_spec.Edges.Add = append(_spec.Edges.Add, edge)
	}
	if n, err = sqlgraph.UpdateNodes(ctx, su.driver, _spec); err != nil {
		if _, ok := err.(*sqlgraph.NotFoundError); ok {
			err = &NotFoundError{service.Label}
		} else if sqlgraph.IsConstraintError(err) {
			err = &ConstraintError{msg: err.Error(), wrap: err}
		}
		return 0, err
	}
	su.mutation.done = true
	return n, nil
}

// ServiceUpdateOne is the builder for updating a single Service entity.
type ServiceUpdateOne struct {
	config
	fields   []string
	hooks    []Hook
	mutation *ServiceMutation
}

// SetCreatedAt sets the "createdAt" field.
func (suo *ServiceUpdateOne) SetCreatedAt(t time.Time) *ServiceUpdateOne {
	suo.mutation.SetCreatedAt(t)
	return suo
}

// SetNillableCreatedAt sets the "createdAt" field if the given value is not nil.
func (suo *ServiceUpdateOne) SetNillableCreatedAt(t *time.Time) *ServiceUpdateOne {
	if t != nil {
		suo.SetCreatedAt(*t)
	}
	return suo
}

// SetName sets the "name" field.
func (suo *ServiceUpdateOne) SetName(s string) *ServiceUpdateOne {
	suo.mutation.SetName(s)
	return suo
}

// SetNillableName sets the "name" field if the given value is not nil.
func (suo *ServiceUpdateOne) SetNillableName(s *string) *ServiceUpdateOne {
	if s != nil {
		suo.SetName(*s)
	}
	return suo
}

// SetSlug sets the "slug" field.
func (suo *ServiceUpdateOne) SetSlug(s string) *ServiceUpdateOne {
	suo.mutation.SetSlug(s)
	return suo
}

// SetNillableSlug sets the "slug" field if the given value is not nil.
func (suo *ServiceUpdateOne) SetNillableSlug(s *string) *ServiceUpdateOne {
	if s != nil {
		suo.SetSlug(*s)
	}
	return suo
}

// SetDescription sets the "description" field.
func (suo *ServiceUpdateOne) SetDescription(s string) *ServiceUpdateOne {
	suo.mutation.SetDescription(s)
	return suo
}

// SetNillableDescription sets the "description" field if the given value is not nil.
func (suo *ServiceUpdateOne) SetNillableDescription(s *string) *ServiceUpdateOne {
	if s != nil {
		suo.SetDescription(*s)
	}
	return suo
}

// SetLogoURL sets the "logo_url" field.
func (suo *ServiceUpdateOne) SetLogoURL(s string) *ServiceUpdateOne {
	suo.mutation.SetLogoURL(s)
	return suo
}

// SetNillableLogoURL sets the "logo_url" field if the given value is not nil.
func (suo *ServiceUpdateOne) SetNillableLogoURL(s *string) *ServiceUpdateOne {
	if s != nil {
		suo.SetLogoURL(*s)
	}
	return suo
}

// ClearLogoURL clears the value of the "logo_url" field.
func (suo *ServiceUpdateOne) ClearLogoURL() *ServiceUpdateOne {
	suo.mutation.ClearLogoURL()
	return suo
}

// SetTosUrls sets the "tos_urls" field.
func (suo *ServiceUpdateOne) SetTosUrls(s []string) *ServiceUpdateOne {
	suo.mutation.SetTosUrls(s)
	return suo
}

// AppendTosUrls appends s to the "tos_urls" field.
func (suo *ServiceUpdateOne) AppendTosUrls(s []string) *ServiceUpdateOne {
	suo.mutation.AppendTosUrls(s)
	return suo
}

// ClearTosUrls clears the value of the "tos_urls" field.
func (suo *ServiceUpdateOne) ClearTosUrls() *ServiceUpdateOne {
	suo.mutation.ClearTosUrls()
	return suo
}

// SetOnionUrls sets the "onion_urls" field.
func (suo *ServiceUpdateOne) SetOnionUrls(s []string) *ServiceUpdateOne {
	suo.mutation.SetOnionUrls(s)
	return suo
}

// AppendOnionUrls appends s to the "onion_urls" field.
func (suo *ServiceUpdateOne) AppendOnionUrls(s []string) *ServiceUpdateOne {
	suo.mutation.AppendOnionUrls(s)
	return suo
}

// ClearOnionUrls clears the value of the "onion_urls" field.
func (suo *ServiceUpdateOne) ClearOnionUrls() *ServiceUpdateOne {
	suo.mutation.ClearOnionUrls()
	return suo
}

// SetCategory sets the "category" field.
func (suo *ServiceUpdateOne) SetCategory(s string) *ServiceUpdateOne {
	suo.mutation.SetCategory(s)
	return suo
}

// SetNillableCategory sets the "category" field if the given value is not nil.
func (suo *ServiceUpdateOne) SetNillableCategory(s *string) *ServiceUpdateOne {
	if s != nil {
		suo.SetCategory(*s)
	}
	return suo
}

// ClearCategory clears the value of the "category" field.
func (suo *ServiceUpdateOne) ClearCategory() *ServiceUpdateOne {
	suo.mutation.ClearCategory()
	return suo
}

// SetComments sets the "comments" field.
func (suo *ServiceUpdateOne) SetComments(s []string) *ServiceUpdateOne {
	suo.mutation.SetComments(s)
	return suo
}

// AppendComments appends s to the "comments" field.
func (suo *ServiceUpdateOne) AppendComments(s []string) *ServiceUpdateOne {
	suo.mutation.AppendComments(s)
	return suo
}

// ClearComments clears the value of the "comments" field.
func (suo *ServiceUpdateOne) ClearComments() *ServiceUpdateOne {
	suo.mutation.ClearComments()
	return suo
}

// SetTosReviews sets the "tos_reviews" field.
func (suo *ServiceUpdateOne) SetTosReviews(sr []schema.TosReview) *ServiceUpdateOne {
	suo.mutation.SetTosReviews(sr)
	return suo
}

// AppendTosReviews appends sr to the "tos_reviews" field.
func (suo *ServiceUpdateOne) AppendTosReviews(sr []schema.TosReview) *ServiceUpdateOne {
	suo.mutation.AppendTosReviews(sr)
	return suo
}

// ClearTosReviews clears the value of the "tos_reviews" field.
func (suo *ServiceUpdateOne) ClearTosReviews() *ServiceUpdateOne {
	suo.mutation.ClearTosReviews()
	return suo
}

// SetUrls sets the "urls" field.
func (suo *ServiceUpdateOne) SetUrls(s []string) *ServiceUpdateOne {
	suo.mutation.SetUrls(s)
	return suo
}

// AppendUrls appends s to the "urls" field.
func (suo *ServiceUpdateOne) AppendUrls(s []string) *ServiceUpdateOne {
	suo.mutation.AppendUrls(s)
	return suo
}

// SetTags sets the "tags" field.
func (suo *ServiceUpdateOne) SetTags(s []string) *ServiceUpdateOne {
	suo.mutation.SetTags(s)
	return suo
}

// AppendTags appends s to the "tags" field.
func (suo *ServiceUpdateOne) AppendTags(s []string) *ServiceUpdateOne {
	suo.mutation.AppendTags(s)
	return suo
}

// ClearTags clears the value of the "tags" field.
func (suo *ServiceUpdateOne) ClearTags() *ServiceUpdateOne {
	suo.mutation.ClearTags()
	return suo
}

// SetKycLevel sets the "kyc_level" field.
func (suo *ServiceUpdateOne) SetKycLevel(i int) *ServiceUpdateOne {
	suo.mutation.ResetKycLevel()
	suo.mutation.SetKycLevel(i)
	return suo
}

// SetNillableKycLevel sets the "kyc_level" field if the given value is not nil.
func (suo *ServiceUpdateOne) SetNillableKycLevel(i *int) *ServiceUpdateOne {
	if i != nil {
		suo.SetKycLevel(*i)
	}
	return suo
}

// AddKycLevel adds i to the "kyc_level" field.
func (suo *ServiceUpdateOne) AddKycLevel(i int) *ServiceUpdateOne {
	suo.mutation.AddKycLevel(i)
	return suo
}

// ClearKycLevel clears the value of the "kyc_level" field.
func (suo *ServiceUpdateOne) ClearKycLevel() *ServiceUpdateOne {
	suo.mutation.ClearKycLevel()
	return suo
}

// SetType sets the "type" field.
func (suo *ServiceUpdateOne) SetType(s service.Type) *ServiceUpdateOne {
	suo.mutation.SetType(s)
	return suo
}

// SetNillableType sets the "type" field if the given value is not nil.
func (suo *ServiceUpdateOne) SetNillableType(s *service.Type) *ServiceUpdateOne {
	if s != nil {
		suo.SetType(*s)
	}
	return suo
}

// SetListed sets the "listed" field.
func (suo *ServiceUpdateOne) SetListed(b bool) *ServiceUpdateOne {
	suo.mutation.SetListed(b)
	return suo
}

// SetNillableListed sets the "listed" field if the given value is not nil.
func (suo *ServiceUpdateOne) SetNillableListed(b *bool) *ServiceUpdateOne {
	if b != nil {
		suo.SetListed(*b)
	}
	return suo
}

// SetVerified sets the "verified" field.
func (suo *ServiceUpdateOne) SetVerified(b bool) *ServiceUpdateOne {
	suo.mutation.SetVerified(b)
	return suo
}

// SetNillableVerified sets the "verified" field if the given value is not nil.
func (suo *ServiceUpdateOne) SetNillableVerified(b *bool) *ServiceUpdateOne {
	if b != nil {
		suo.SetVerified(*b)
	}
	return suo
}

// SetPending sets the "pending" field.
func (suo *ServiceUpdateOne) SetPending(b bool) *ServiceUpdateOne {
	suo.mutation.SetPending(b)
	return suo
}

// SetNillablePending sets the "pending" field if the given value is not nil.
func (suo *ServiceUpdateOne) SetNillablePending(b *bool) *ServiceUpdateOne {
	if b != nil {
		suo.SetPending(*b)
	}
	return suo
}

// SetXmr sets the "xmr" field.
func (suo *ServiceUpdateOne) SetXmr(b bool) *ServiceUpdateOne {
	suo.mutation.SetXmr(b)
	return suo
}

// SetNillableXmr sets the "xmr" field if the given value is not nil.
func (suo *ServiceUpdateOne) SetNillableXmr(b *bool) *ServiceUpdateOne {
	if b != nil {
		suo.SetXmr(*b)
	}
	return suo
}

// SetBtc sets the "btc" field.
func (suo *ServiceUpdateOne) SetBtc(b bool) *ServiceUpdateOne {
	suo.mutation.SetBtc(b)
	return suo
}

// SetNillableBtc sets the "btc" field if the given value is not nil.
func (suo *ServiceUpdateOne) SetNillableBtc(b *bool) *ServiceUpdateOne {
	if b != nil {
		suo.SetBtc(*b)
	}
	return suo
}

// SetLightning sets the "lightning" field.
func (suo *ServiceUpdateOne) SetLightning(b bool) *ServiceUpdateOne {
	suo.mutation.SetLightning(b)
	return suo
}

// SetNillableLightning sets the "lightning" field if the given value is not nil.
func (suo *ServiceUpdateOne) SetNillableLightning(b *bool) *ServiceUpdateOne {
	if b != nil {
		suo.SetLightning(*b)
	}
	return suo
}

// SetCash sets the "cash" field.
func (suo *ServiceUpdateOne) SetCash(b bool) *ServiceUpdateOne {
	suo.mutation.SetCash(b)
	return suo
}

// SetNillableCash sets the "cash" field if the given value is not nil.
func (suo *ServiceUpdateOne) SetNillableCash(b *bool) *ServiceUpdateOne {
	if b != nil {
		suo.SetCash(*b)
	}
	return suo
}

// SetFiat sets the "fiat" field.
func (suo *ServiceUpdateOne) SetFiat(b bool) *ServiceUpdateOne {
	suo.mutation.SetFiat(b)
	return suo
}

// SetNillableFiat sets the "fiat" field if the given value is not nil.
func (suo *ServiceUpdateOne) SetNillableFiat(b *bool) *ServiceUpdateOne {
	if b != nil {
		suo.SetFiat(*b)
	}
	return suo
}

// SetLastTosReview sets the "last_tos_review" field.
func (suo *ServiceUpdateOne) SetLastTosReview(t time.Time) *ServiceUpdateOne {
	suo.mutation.SetLastTosReview(t)
	return suo
}

// SetNillableLastTosReview sets the "last_tos_review" field if the given value is not nil.
func (suo *ServiceUpdateOne) SetNillableLastTosReview(t *time.Time) *ServiceUpdateOne {
	if t != nil {
		suo.SetLastTosReview(*t)
	}
	return suo
}

// ClearLastTosReview clears the value of the "last_tos_review" field.
func (suo *ServiceUpdateOne) ClearLastTosReview() *ServiceUpdateOne {
	suo.mutation.ClearLastTosReview()
	return suo
}

// SetReferral sets the "referral" field.
func (suo *ServiceUpdateOne) SetReferral(s string) *ServiceUpdateOne {
	suo.mutation.SetReferral(s)
	return suo
}

// SetNillableReferral sets the "referral" field if the given value is not nil.
func (suo *ServiceUpdateOne) SetNillableReferral(s *string) *ServiceUpdateOne {
	if s != nil {
		suo.SetReferral(*s)
	}
	return suo
}

// ClearReferral clears the value of the "referral" field.
func (suo *ServiceUpdateOne) ClearReferral() *ServiceUpdateOne {
	suo.mutation.ClearReferral()
	return suo
}

// SetScore sets the "score" field.
func (suo *ServiceUpdateOne) SetScore(i int) *ServiceUpdateOne {
	suo.mutation.ResetScore()
	suo.mutation.SetScore(i)
	return suo
}

// SetNillableScore sets the "score" field if the given value is not nil.
func (suo *ServiceUpdateOne) SetNillableScore(i *int) *ServiceUpdateOne {
	if i != nil {
		suo.SetScore(*i)
	}
	return suo
}

// AddScore adds i to the "score" field.
func (suo *ServiceUpdateOne) AddScore(i int) *ServiceUpdateOne {
	suo.mutation.AddScore(i)
	return suo
}

// ClearScore clears the value of the "score" field.
func (suo *ServiceUpdateOne) ClearScore() *ServiceUpdateOne {
	suo.mutation.ClearScore()
	return suo
}

// SetPotentialScam sets the "potential_scam" field.
func (suo *ServiceUpdateOne) SetPotentialScam(b bool) *ServiceUpdateOne {
	suo.mutation.SetPotentialScam(b)
	return suo
}

// SetNillablePotentialScam sets the "potential_scam" field if the given value is not nil.
func (suo *ServiceUpdateOne) SetNillablePotentialScam(b *bool) *ServiceUpdateOne {
	if b != nil {
		suo.SetPotentialScam(*b)
	}
	return suo
}

// SetNotes sets the "notes" field.
func (suo *ServiceUpdateOne) SetNotes(s []string) *ServiceUpdateOne {
	suo.mutation.SetNotes(s)
	return suo
}

// AppendNotes appends s to the "notes" field.
func (suo *ServiceUpdateOne) AppendNotes(s []string) *ServiceUpdateOne {
	suo.mutation.AppendNotes(s)
	return suo
}

// ClearNotes clears the value of the "notes" field.
func (suo *ServiceUpdateOne) ClearNotes() *ServiceUpdateOne {
	suo.mutation.ClearNotes()
	return suo
}

// SetSupport sets the "support" field.
func (suo *ServiceUpdateOne) SetSupport(sm []schema.SupportMethod) *ServiceUpdateOne {
	suo.mutation.SetSupport(sm)
	return suo
}

// AppendSupport appends sm to the "support" field.
func (suo *ServiceUpdateOne) AppendSupport(sm []schema.SupportMethod) *ServiceUpdateOne {
	suo.mutation.AppendSupport(sm)
	return suo
}

// ClearSupport clears the value of the "support" field.
func (suo *ServiceUpdateOne) ClearSupport() *ServiceUpdateOne {
	suo.mutation.ClearSupport()
	return suo
}

// AddAttributeIDs adds the "attributes" edge to the Attribute entity by IDs.
func (suo *ServiceUpdateOne) AddAttributeIDs(ids ...string) *ServiceUpdateOne {
	suo.mutation.AddAttributeIDs(ids...)
	return suo
}

// AddAttributes adds the "attributes" edges to the Attribute entity.
func (suo *ServiceUpdateOne) AddAttributes(a ...*Attribute) *ServiceUpdateOne {
	ids := make([]string, len(a))
	for i := range a {
		ids[i] = a[i].ID
	}
	return suo.AddAttributeIDs(ids...)
}

// AddChangeIDs adds the "changes" edge to the Change entity by IDs.
func (suo *ServiceUpdateOne) AddChangeIDs(ids ...int) *ServiceUpdateOne {
	suo.mutation.AddChangeIDs(ids...)
	return suo
}

// AddChanges adds the "changes" edges to the Change entity.
func (suo *ServiceUpdateOne) AddChanges(c ...*Change) *ServiceUpdateOne {
	ids := make([]int, len(c))
	for i := range c {
		ids[i] = c[i].ID
	}
	return suo.AddChangeIDs(ids...)
}

// Mutation returns the ServiceMutation object of the builder.
func (suo *ServiceUpdateOne) Mutation() *ServiceMutation {
	return suo.mutation
}

// ClearAttributes clears all "attributes" edges to the Attribute entity.
func (suo *ServiceUpdateOne) ClearAttributes() *ServiceUpdateOne {
	suo.mutation.ClearAttributes()
	return suo
}

// RemoveAttributeIDs removes the "attributes" edge to Attribute entities by IDs.
func (suo *ServiceUpdateOne) RemoveAttributeIDs(ids ...string) *ServiceUpdateOne {
	suo.mutation.RemoveAttributeIDs(ids...)
	return suo
}

// RemoveAttributes removes "attributes" edges to Attribute entities.
func (suo *ServiceUpdateOne) RemoveAttributes(a ...*Attribute) *ServiceUpdateOne {
	ids := make([]string, len(a))
	for i := range a {
		ids[i] = a[i].ID
	}
	return suo.RemoveAttributeIDs(ids...)
}

// ClearChanges clears all "changes" edges to the Change entity.
func (suo *ServiceUpdateOne) ClearChanges() *ServiceUpdateOne {
	suo.mutation.ClearChanges()
	return suo
}

// RemoveChangeIDs removes the "changes" edge to Change entities by IDs.
func (suo *ServiceUpdateOne) RemoveChangeIDs(ids ...int) *ServiceUpdateOne {
	suo.mutation.RemoveChangeIDs(ids...)
	return suo
}

// RemoveChanges removes "changes" edges to Change entities.
func (suo *ServiceUpdateOne) RemoveChanges(c ...*Change) *ServiceUpdateOne {
	ids := make([]int, len(c))
	for i := range c {
		ids[i] = c[i].ID
	}
	return suo.RemoveChangeIDs(ids...)
}

// Where appends a list predicates to the ServiceUpdate builder.
func (suo *ServiceUpdateOne) Where(ps ...predicate.Service) *ServiceUpdateOne {
	suo.mutation.Where(ps...)
	return suo
}

// Select allows selecting one or more fields (columns) of the returned entity.
// The default is selecting all fields defined in the entity schema.
func (suo *ServiceUpdateOne) Select(field string, fields ...string) *ServiceUpdateOne {
	suo.fields = append([]string{field}, fields...)
	return suo
}

// Save executes the query and returns the updated Service entity.
func (suo *ServiceUpdateOne) Save(ctx context.Context) (*Service, error) {
	return withHooks(ctx, suo.sqlSave, suo.mutation, suo.hooks)
}

// SaveX is like Save, but panics if an error occurs.
func (suo *ServiceUpdateOne) SaveX(ctx context.Context) *Service {
	node, err := suo.Save(ctx)
	if err != nil {
		panic(err)
	}
	return node
}

// Exec executes the query on the entity.
func (suo *ServiceUpdateOne) Exec(ctx context.Context) error {
	_, err := suo.Save(ctx)
	return err
}

// ExecX is like Exec, but panics if an error occurs.
func (suo *ServiceUpdateOne) ExecX(ctx context.Context) {
	if err := suo.Exec(ctx); err != nil {
		panic(err)
	}
}

// check runs all checks and user-defined validators on the builder.
func (suo *ServiceUpdateOne) check() error {
	if v, ok := suo.mutation.Slug(); ok {
		if err := service.SlugValidator(v); err != nil {
			return &ValidationError{Name: "slug", err: fmt.Errorf(`ent: validator failed for field "Service.slug": %w`, err)}
		}
	}
	if v, ok := suo.mutation.Description(); ok {
		if err := service.DescriptionValidator(v); err != nil {
			return &ValidationError{Name: "description", err: fmt.Errorf(`ent: validator failed for field "Service.description": %w`, err)}
		}
	}
	if v, ok := suo.mutation.KycLevel(); ok {
		if err := service.KycLevelValidator(v); err != nil {
			return &ValidationError{Name: "kyc_level", err: fmt.Errorf(`ent: validator failed for field "Service.kyc_level": %w`, err)}
		}
	}
	if v, ok := suo.mutation.GetType(); ok {
		if err := service.TypeValidator(v); err != nil {
			return &ValidationError{Name: "type", err: fmt.Errorf(`ent: validator failed for field "Service.type": %w`, err)}
		}
	}
	if v, ok := suo.mutation.Score(); ok {
		if err := service.ScoreValidator(v); err != nil {
			return &ValidationError{Name: "score", err: fmt.Errorf(`ent: validator failed for field "Service.score": %w`, err)}
		}
	}
	return nil
}

func (suo *ServiceUpdateOne) sqlSave(ctx context.Context) (_node *Service, err error) {
	if err := suo.check(); err != nil {
		return _node, err
	}
	_spec := sqlgraph.NewUpdateSpec(service.Table, service.Columns, sqlgraph.NewFieldSpec(service.FieldID, field.TypeString))
	id, ok := suo.mutation.ID()
	if !ok {
		return nil, &ValidationError{Name: "id", err: errors.New(`ent: missing "Service.id" for update`)}
	}
	_spec.Node.ID.Value = id
	if fields := suo.fields; len(fields) > 0 {
		_spec.Node.Columns = make([]string, 0, len(fields))
		_spec.Node.Columns = append(_spec.Node.Columns, service.FieldID)
		for _, f := range fields {
			if !service.ValidColumn(f) {
				return nil, &ValidationError{Name: f, err: fmt.Errorf("ent: invalid field %q for query", f)}
			}
			if f != service.FieldID {
				_spec.Node.Columns = append(_spec.Node.Columns, f)
			}
		}
	}
	if ps := suo.mutation.predicates; len(ps) > 0 {
		_spec.Predicate = func(selector *sql.Selector) {
			for i := range ps {
				ps[i](selector)
			}
		}
	}
	if value, ok := suo.mutation.CreatedAt(); ok {
		_spec.SetField(service.FieldCreatedAt, field.TypeTime, value)
	}
	if value, ok := suo.mutation.Name(); ok {
		_spec.SetField(service.FieldName, field.TypeString, value)
	}
	if value, ok := suo.mutation.Slug(); ok {
		_spec.SetField(service.FieldSlug, field.TypeString, value)
	}
	if value, ok := suo.mutation.Description(); ok {
		_spec.SetField(service.FieldDescription, field.TypeString, value)
	}
	if value, ok := suo.mutation.LogoURL(); ok {
		_spec.SetField(service.FieldLogoURL, field.TypeString, value)
	}
	if suo.mutation.LogoURLCleared() {
		_spec.ClearField(service.FieldLogoURL, field.TypeString)
	}
	if value, ok := suo.mutation.TosUrls(); ok {
		_spec.SetField(service.FieldTosUrls, field.TypeJSON, value)
	}
	if value, ok := suo.mutation.AppendedTosUrls(); ok {
		_spec.AddModifier(func(u *sql.UpdateBuilder) {
			sqljson.Append(u, service.FieldTosUrls, value)
		})
	}
	if suo.mutation.TosUrlsCleared() {
		_spec.ClearField(service.FieldTosUrls, field.TypeJSON)
	}
	if value, ok := suo.mutation.OnionUrls(); ok {
		_spec.SetField(service.FieldOnionUrls, field.TypeJSON, value)
	}
	if value, ok := suo.mutation.AppendedOnionUrls(); ok {
		_spec.AddModifier(func(u *sql.UpdateBuilder) {
			sqljson.Append(u, service.FieldOnionUrls, value)
		})
	}
	if suo.mutation.OnionUrlsCleared() {
		_spec.ClearField(service.FieldOnionUrls, field.TypeJSON)
	}
	if value, ok := suo.mutation.Category(); ok {
		_spec.SetField(service.FieldCategory, field.TypeString, value)
	}
	if suo.mutation.CategoryCleared() {
		_spec.ClearField(service.FieldCategory, field.TypeString)
	}
	if value, ok := suo.mutation.Comments(); ok {
		_spec.SetField(service.FieldComments, field.TypeJSON, value)
	}
	if value, ok := suo.mutation.AppendedComments(); ok {
		_spec.AddModifier(func(u *sql.UpdateBuilder) {
			sqljson.Append(u, service.FieldComments, value)
		})
	}
	if suo.mutation.CommentsCleared() {
		_spec.ClearField(service.FieldComments, field.TypeJSON)
	}
	if value, ok := suo.mutation.TosReviews(); ok {
		_spec.SetField(service.FieldTosReviews, field.TypeJSON, value)
	}
	if value, ok := suo.mutation.AppendedTosReviews(); ok {
		_spec.AddModifier(func(u *sql.UpdateBuilder) {
			sqljson.Append(u, service.FieldTosReviews, value)
		})
	}
	if suo.mutation.TosReviewsCleared() {
		_spec.ClearField(service.FieldTosReviews, field.TypeJSON)
	}
	if value, ok := suo.mutation.Urls(); ok {
		_spec.SetField(service.FieldUrls, field.TypeJSON, value)
	}
	if value, ok := suo.mutation.AppendedUrls(); ok {
		_spec.AddModifier(func(u *sql.UpdateBuilder) {
			sqljson.Append(u, service.FieldUrls, value)
		})
	}
	if value, ok := suo.mutation.Tags(); ok {
		_spec.SetField(service.FieldTags, field.TypeJSON, value)
	}
	if value, ok := suo.mutation.AppendedTags(); ok {
		_spec.AddModifier(func(u *sql.UpdateBuilder) {
			sqljson.Append(u, service.FieldTags, value)
		})
	}
	if suo.mutation.TagsCleared() {
		_spec.ClearField(service.FieldTags, field.TypeJSON)
	}
	if value, ok := suo.mutation.KycLevel(); ok {
		_spec.SetField(service.FieldKycLevel, field.TypeInt, value)
	}
	if value, ok := suo.mutation.AddedKycLevel(); ok {
		_spec.AddField(service.FieldKycLevel, field.TypeInt, value)
	}
	if suo.mutation.KycLevelCleared() {
		_spec.ClearField(service.FieldKycLevel, field.TypeInt)
	}
	if value, ok := suo.mutation.GetType(); ok {
		_spec.SetField(service.FieldType, field.TypeEnum, value)
	}
	if value, ok := suo.mutation.Listed(); ok {
		_spec.SetField(service.FieldListed, field.TypeBool, value)
	}
	if value, ok := suo.mutation.Verified(); ok {
		_spec.SetField(service.FieldVerified, field.TypeBool, value)
	}
	if value, ok := suo.mutation.Pending(); ok {
		_spec.SetField(service.FieldPending, field.TypeBool, value)
	}
	if value, ok := suo.mutation.Xmr(); ok {
		_spec.SetField(service.FieldXmr, field.TypeBool, value)
	}
	if value, ok := suo.mutation.Btc(); ok {
		_spec.SetField(service.FieldBtc, field.TypeBool, value)
	}
	if value, ok := suo.mutation.Lightning(); ok {
		_spec.SetField(service.FieldLightning, field.TypeBool, value)
	}
	if value, ok := suo.mutation.Cash(); ok {
		_spec.SetField(service.FieldCash, field.TypeBool, value)
	}
	if value, ok := suo.mutation.Fiat(); ok {
		_spec.SetField(service.FieldFiat, field.TypeBool, value)
	}
	if value, ok := suo.mutation.LastTosReview(); ok {
		_spec.SetField(service.FieldLastTosReview, field.TypeTime, value)
	}
	if suo.mutation.LastTosReviewCleared() {
		_spec.ClearField(service.FieldLastTosReview, field.TypeTime)
	}
	if value, ok := suo.mutation.Referral(); ok {
		_spec.SetField(service.FieldReferral, field.TypeString, value)
	}
	if suo.mutation.ReferralCleared() {
		_spec.ClearField(service.FieldReferral, field.TypeString)
	}
	if value, ok := suo.mutation.Score(); ok {
		_spec.SetField(service.FieldScore, field.TypeInt, value)
	}
	if value, ok := suo.mutation.AddedScore(); ok {
		_spec.AddField(service.FieldScore, field.TypeInt, value)
	}
	if suo.mutation.ScoreCleared() {
		_spec.ClearField(service.FieldScore, field.TypeInt)
	}
	if value, ok := suo.mutation.PotentialScam(); ok {
		_spec.SetField(service.FieldPotentialScam, field.TypeBool, value)
	}
	if value, ok := suo.mutation.Notes(); ok {
		_spec.SetField(service.FieldNotes, field.TypeJSON, value)
	}
	if value, ok := suo.mutation.AppendedNotes(); ok {
		_spec.AddModifier(func(u *sql.UpdateBuilder) {
			sqljson.Append(u, service.FieldNotes, value)
		})
	}
	if suo.mutation.NotesCleared() {
		_spec.ClearField(service.FieldNotes, field.TypeJSON)
	}
	if value, ok := suo.mutation.Support(); ok {
		_spec.SetField(service.FieldSupport, field.TypeJSON, value)
	}
	if value, ok := suo.mutation.AppendedSupport(); ok {
		_spec.AddModifier(func(u *sql.UpdateBuilder) {
			sqljson.Append(u, service.FieldSupport, value)
		})
	}
	if suo.mutation.SupportCleared() {
		_spec.ClearField(service.FieldSupport, field.TypeJSON)
	}
	if suo.mutation.AttributesCleared() {
		edge := &sqlgraph.EdgeSpec{
			Rel:     sqlgraph.M2M,
			Inverse: false,
			Table:   service.AttributesTable,
			Columns: service.AttributesPrimaryKey,
			Bidi:    false,
			Target: &sqlgraph.EdgeTarget{
				IDSpec: sqlgraph.NewFieldSpec(attribute.FieldID, field.TypeString),
			},
		}
		_spec.Edges.Clear = append(_spec.Edges.Clear, edge)
	}
	if nodes := suo.mutation.RemovedAttributesIDs(); len(nodes) > 0 && !suo.mutation.AttributesCleared() {
		edge := &sqlgraph.EdgeSpec{
			Rel:     sqlgraph.M2M,
			Inverse: false,
			Table:   service.AttributesTable,
			Columns: service.AttributesPrimaryKey,
			Bidi:    false,
			Target: &sqlgraph.EdgeTarget{
				IDSpec: sqlgraph.NewFieldSpec(attribute.FieldID, field.TypeString),
			},
		}
		for _, k := range nodes {
			edge.Target.Nodes = append(edge.Target.Nodes, k)
		}
		_spec.Edges.Clear = append(_spec.Edges.Clear, edge)
	}
	if nodes := suo.mutation.AttributesIDs(); len(nodes) > 0 {
		edge := &sqlgraph.EdgeSpec{
			Rel:     sqlgraph.M2M,
			Inverse: false,
			Table:   service.AttributesTable,
			Columns: service.AttributesPrimaryKey,
			Bidi:    false,
			Target: &sqlgraph.EdgeTarget{
				IDSpec: sqlgraph.NewFieldSpec(attribute.FieldID, field.TypeString),
			},
		}
		for _, k := range nodes {
			edge.Target.Nodes = append(edge.Target.Nodes, k)
		}
		_spec.Edges.Add = append(_spec.Edges.Add, edge)
	}
	if suo.mutation.ChangesCleared() {
		edge := &sqlgraph.EdgeSpec{
			Rel:     sqlgraph.O2M,
			Inverse: false,
			Table:   service.ChangesTable,
			Columns: []string{service.ChangesColumn},
			Bidi:    false,
			Target: &sqlgraph.EdgeTarget{
				IDSpec: sqlgraph.NewFieldSpec(change.FieldID, field.TypeInt),
			},
		}
		_spec.Edges.Clear = append(_spec.Edges.Clear, edge)
	}
	if nodes := suo.mutation.RemovedChangesIDs(); len(nodes) > 0 && !suo.mutation.ChangesCleared() {
		edge := &sqlgraph.EdgeSpec{
			Rel:     sqlgraph.O2M,
			Inverse: false,
			Table:   service.ChangesTable,
			Columns: []string{service.ChangesColumn},
			Bidi:    false,
			Target: &sqlgraph.EdgeTarget{
				IDSpec: sqlgraph.NewFieldSpec(change.FieldID, field.TypeInt),
			},
		}
		for _, k := range nodes {
			edge.Target.Nodes = append(edge.Target.Nodes, k)
		}
		_spec.Edges.Clear = append(_spec.Edges.Clear, edge)
	}
	if nodes := suo.mutation.ChangesIDs(); len(nodes) > 0 {
		edge := &sqlgraph.EdgeSpec{
			Rel:     sqlgraph.O2M,
			Inverse: false,
			Table:   service.ChangesTable,
			Columns: []string{service.ChangesColumn},
			Bidi:    false,
			Target: &sqlgraph.EdgeTarget{
				IDSpec: sqlgraph.NewFieldSpec(change.FieldID, field.TypeInt),
			},
		}
		for _, k := range nodes {
			edge.Target.Nodes = append(edge.Target.Nodes, k)
		}
		_spec.Edges.Add = append(_spec.Edges.Add, edge)
	}
	_node = &Service{config: suo.config}
	_spec.Assign = _node.assignValues
	_spec.ScanValues = _node.scanValues
	if err = sqlgraph.UpdateNode(ctx, suo.driver, _spec); err != nil {
		if _, ok := err.(*sqlgraph.NotFoundError); ok {
			err = &NotFoundError{service.Label}
		} else if sqlgraph.IsConstraintError(err) {
			err = &ConstraintError{msg: err.Error(), wrap: err}
		}
		return nil, err
	}
	suo.mutation.done = true
	return _node, nil
}
